/***************************************************************
 * Name:      ApameGUIApp.h
 * Purpose:   Defines Application Class
 * Author:    Daniel Filkovic (daniel.filkovic@gmail.com)
 * Created:   2010-10-23
 * Copyright: Daniel Filkovic (www.3dpanelmethod.com)
 * License:   GNU GENERAL PUBLIC LICENSE
 **************************************************************/

#ifndef APAMEGUIAPP_H
#define APAMEGUIAPP_H

// custom Apame icons
#define wxART_NEW_24               wxART_MAKE_ART_ID(wxART_NEW_24)
#define wxART_OPEN_24              wxART_MAKE_ART_ID(wxART_OPEN_24)
#define wxART_SAVE_24              wxART_MAKE_ART_ID(wxART_SAVE_24)
#define wxART_UNDO_24              wxART_MAKE_ART_ID(wxART_UNDO_24)
#define wxART_REDO_24              wxART_MAKE_ART_ID(wxART_REDO_24)
#define wxART_REFIT_24             wxART_MAKE_ART_ID(wxART_REFIT_24)
#define wxART_FRONT_24             wxART_MAKE_ART_ID(wxART_FRONT_24)
#define wxART_TOP_24               wxART_MAKE_ART_ID(wxART_TOP_24)
#define wxART_LEFT_24              wxART_MAKE_ART_ID(wxART_LEFT_24)
#define wxART_BACK_24              wxART_MAKE_ART_ID(wxART_BACK_24)
#define wxART_BOTTOM_24            wxART_MAKE_ART_ID(wxART_BOTTOM_24)
#define wxART_RIGHT_24             wxART_MAKE_ART_ID(wxART_RIGHT_24)
#define wxART_ISOMETRIC_24         wxART_MAKE_ART_ID(wxART_ISOMETRIC_24)
#define wxART_RUN_24               wxART_MAKE_ART_ID(wxART_RUN_24)
#define wxART_APAME_32             wxART_MAKE_ART_ID(wxART_APAME_32)

#include <wx/app.h>
#include <wx/cmdline.h>

#include "generalFunctions.h"

class ApameGUIApp : public wxApp
{
public:
    virtual bool OnInit();
    virtual void OnInitCmdLine(wxCmdLineParser& parser);
    virtual bool OnCmdLineParsed(wxCmdLineParser& parser);
private:
    string m_programArgument;
};

static const wxCmdLineEntryDesc g_cmdLineDesc[]=
{
     { wxCMD_LINE_PARAM,  NULL, NULL, NULL, wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_OPTIONAL },
     { wxCMD_LINE_NONE }
};

DECLARE_APP(ApameGUIApp)

#endif
