#ifndef DCREATEELEMENT_H
#define DCREATEELEMENT_H

#ifndef WX_PRECOMP
//(*HeadersPCH(DCreateElement)
#include <wx/sizer.h>
#include <wx/radiobox.h>
#include <wx/button.h>
#include <wx/dialog.h>
//*)
#endif
//(*Headers(DCreateElement)
#include <wx/grid.h>
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "typenames.h"

class DCreateElement: public wxDialog
{
public:
    DCreateElement(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            wxWindowID id=wxID_ANY);
    virtual ~DCreateElement();

    //(*Declarations(DCreateElement)
    wxRadioBox* NumNodeRadioBox;
    wxRadioBox* MethodRadioBox;
    wxButton* OKButton;
    wxGrid* NodeGrid;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DCreateElement)
    static const long ID_RADIOBOX4;
    static const long ID_RADIOBOX5;
    static const long ID_GRID1;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;

    //(*Handlers(DCreateElement)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnTypeMethodRadioBoxSelect(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
