#ifndef DCREATENODE_H
#define DCREATENODE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DCreateNode)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DCreateNode)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "typenames.h"

class DCreateNode: public wxDialog
{
public:
    DCreateNode(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DCreateNode();

    //(*Declarations(DCreateNode)
    wxTextCtrl* zCoord;
    wxButton* OKButton;
    wxStaticText* StaticText2;
    wxCheckBox* predefinedNodeID;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxTextCtrl* yCoord;
    wxTextCtrl* nodeID;
    wxTextCtrl* xCoord;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DCreateNode)
    static const long ID_CHECKBOX1;
    static const long ID_TEXTCTRL4;
    static const long ID_STATICTEXT1;
    static const long ID_STATICTEXT2;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL1;
    static const long ID_TEXTCTRL2;
    static const long ID_TEXTCTRL3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;

    //(*Handlers(DCreateNode)
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnpredefinedNodeIDClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
