#ifndef DDELETEELEMENTS_H
#define DDELETEELEMENTS_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DDeleteElements)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DDeleteElements)
//*)

#include "CMesh.h"
#include "DElemSelection.h"
#include "DSimpleMessage.h"

class DDeleteElements: public wxDialog
{
public:
    DDeleteElements(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DDeleteElements();

    //(*Declarations(DDeleteElements)
    wxButton* SelectButton;
    wxButton* OKButton;
    wxStaticText* StaticText1;
    wxRadioBox* DomainRadioBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DDeleteElements)
    static const long ID_STATICTEXT1;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    setUInt& m_elemSelection;

    //(*Handlers(DDeleteElements)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
