#ifndef DDELETENODES_H
#define DDELETENODES_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DDeleteNodes)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DDeleteNodes)
//*)

#include "CMesh.h"
#include "DNodeSelection.h"
#include "DSimpleMessage.h"

class DDeleteNodes: public wxDialog
{
public:
    DDeleteNodes(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            setUInt& nodeSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DDeleteNodes();

    //(*Declarations(DDeleteNodes)
    wxButton* SelectButton;
    wxButton* OKButton;
    wxStaticText* StaticText1;
    wxRadioBox* DomainRadioBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DDeleteNodes)
    static const long ID_STATICTEXT1;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    setUInt& m_nodeSelection;
    
    //(*Handlers(DDeleteNodes)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
