#ifndef DDISPLAYRESULTS_H
#define DDISPLAYRESULTS_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DDisplayResults)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/choice.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DDisplayResults)
//*)

#include "C3DViewer.h"
#include "CMesh.h"
#include "CProjectData.h"
#include "CResults.h"
#include "generalFunctions.h"

class DDisplayResults: public wxDialog
{
public:
    DDisplayResults(
            wxWindow* parent,
            bool& modified,
            C3DViewer* m_p3DViewer,
            CMesh* m_pMesh,
            CProjectData* m_pProjectData,
            CResults* m_pResults,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DDisplayResults();

    //(*Declarations(DDisplayResults)
    wxCheckBox* PlotResultsCheckBox;
    wxChoice* ResultChoice;
    wxButton* OKButton;
    wxStaticText* StaticText2;
    wxTextCtrl* TextCtrlMin;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxTextCtrl* TextCtrlMax;
    wxRadioBox* PlotTypeRadioBox;
    wxChoice* CaseChoice;
    wxStaticText* StaticText4;
    wxRadioBox* LegendRadioBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DDisplayResults)
    static const long ID_CHECKBOX1;
    static const long ID_STATICTEXT1;
    static const long ID_CHOICE3;
    static const long ID_STATICTEXT2;
    static const long ID_CHOICE2;
    static const long ID_RADIOBOX1;
    static const long ID_RADIOBOX2;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL2;
    static const long ID_BUTTON3;
    static const long ID_BUTTON4;
    //*)

private:
    bool& m_modified;
    C3DViewer* m_p3DViewer;
    CMesh* m_pMesh;
    CProjectData* m_pProjectData;
    CResults* m_pResults;
    // following variables are made members since they are used throughout methods for live update of GUI text boxes
    vecDbl m_fieldData;
    vecUInt m_elemIDs;
    string selectedData;
    string selectedCase;
    string plotType;
    string limitType;
    double minLimit;
    double maxLimit;

    void updateMinMax();
    void updateCases();
    void calculateFieldData();

    //(*Handlers(DDisplayResults)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnResultChoiceSelect(wxCommandEvent& event);
    void OnLegendRadioBoxSelect(wxCommandEvent& event);
    void OnCaseChoiceSelect(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
