#ifndef DEDITELEMENT_H
#define DEDITELEMENT_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DEditElement)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DEditElement)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "typenames.h"

class DEditElement: public wxDialog
{
public:
    DEditElement(
            wxWindow* parent,
            CMesh* pMesh,
            uInt& elemID,
            uInt& state,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DEditElement();

    //(*Declarations(DEditElement)
    wxStaticText* NeighTrailStaticText;
    wxTextCtrl* Node2Box;
    wxStaticText* tNode1;
    wxTextCtrl* Elem4Box;
    wxButton* OKButton;
    wxTextCtrl* Node1Box;
    wxStaticText* tNode4;
    wxStaticText* StaticText2;
    wxTextCtrl* ElemIDBox;
    wxStaticText* tNode3;
    wxTextCtrl* Elem3Box;
    wxStaticText* StaticText3;
    wxStaticText* tElem2;
    wxStaticText* tElem4;
    wxStaticText* tNode2;
    wxTextCtrl* Elem1Box;
    wxTextCtrl* Elem2Box;
    wxRadioBox* TypeRadioBox;
    wxStaticText* tElem3;
    wxTextCtrl* Node3Box;
    wxButton* SkipButton;
    wxStaticText* tElem1;
    wxTextCtrl* Node4Box;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DEditElement)
    static const long ID_RADIOBOX1;
    static const long ID_STATICTEXT12;
    static const long ID_TEXTCTRL11;
    static const long ID_STATICTEXT2;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL3;
    static const long ID_STATICTEXT5;
    static const long ID_TEXTCTRL4;
    static const long ID_STATICTEXT6;
    static const long ID_TEXTCTRL5;
    static const long ID_STATICTEXT7;
    static const long ID_STATICTEXT8;
    static const long ID_TEXTCTRL6;
    static const long ID_STATICTEXT9;
    static const long ID_TEXTCTRL7;
    static const long ID_STATICTEXT10;
    static const long ID_TEXTCTRL8;
    static const long ID_STATICTEXT11;
    static const long ID_TEXTCTRL9;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    static const long ID_BUTTON3;
    //*)

private:
    CMesh* m_pMesh;
    uInt& m_elemID;
    uInt& m_state;
    uInt m_newElemID;
    vector<wxTextCtrl*> m_nodeBoxes;
    vector<wxTextCtrl*> m_elemBoxes;

    //(*Handlers(DEditElement)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnSkipButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnTypeRadioBoxSelect(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
