#ifndef DEDITNODE_H
#define DEDITNODE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DEditNode)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DEditNode)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "typenames.h"

class DEditNode: public wxDialog
{
public:
    DEditNode(
            wxWindow* parent,
            CMesh* pMesh,
            uInt& nodeID,
            uInt& state,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DEditNode();

    //(*Declarations(DEditNode)
    wxTextCtrl* CoordYBox;
    wxButton* OKButton;
    wxTextCtrl* CoordZBox;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxTextCtrl* CoordXBox;
    wxStaticText* StaticText5;
    wxTextCtrl* NodeIDBox;
    wxButton* SkipButton;
    wxStaticText* StaticText4;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DEditNode)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL5;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL6;
    static const long ID_STATICTEXT5;
    static const long ID_TEXTCTRL7;
    static const long ID_BUTTON1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON2;
    //*)

private:
    CMesh* m_pMesh;
    uInt& m_nodeID;
    uInt& m_state;
    uInt m_newNodeID;

    //(*Handlers(DEditNode)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnSkipButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
