#ifndef DELEMSELECTION_H
#define DELEMSELECTION_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DElemSelection)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/listbox.h>
	#include <wx/choice.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DElemSelection)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "generalFunctions.h"
#include "typenames.h"

class DElemSelection: public wxDialog
{
public:
    DElemSelection(
            wxWindow* parent,
            CMesh* pMesh,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DElemSelection();

    //(*Declarations(DElemSelection)
    wxTextCtrl* labelBoxOne;
    wxChoice* TypeChoice;
    wxButton* OKButton;
    wxTextCtrl* labelBoxThree;
    wxButton* ApplyButton;
    wxFlexGridSizer* FlexGridSizer3;
    wxStaticText* labelOne;
    wxButton* ClearListButton;
    wxFlexGridSizer* FlexGridSizer5;
    wxFlexGridSizer* FlexGridSizer2;
    wxStaticText* InfoText;
    wxStaticText* StaticText1;
    wxButton* DeleteListButton;
    wxStaticText* labelTwo;
    wxTextCtrl* labelBoxTwo;
    wxFlexGridSizer* FlexGridSizer1;
    wxButton* CancelButton;
    wxListBox* ElemList;
    wxRadioBox* AddOrRemove;
    wxFlexGridSizer* MainFlexGridSizer;
    wxStaticText* labelThree;
    //*)

protected:
    //(*Identifiers(DElemSelection)
    static const long ID_LISTBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON4;
    static const long ID_STATICTEXT1;
    static const long ID_CHOICE1;
    static const long ID_RADIOBOX1;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT5;
    static const long ID_TEXTCTRL3;
    static const long ID_BUTTON5;
    static const long ID_STATICTEXT2;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    CMesh* m_pMesh;
    setUInt& m_elemSelection;
    setUInt m_tempSelection; // temporary element selection that will be copied to real one if OK pressed

    void updateTypeSelection();
    void updateSelectionList();

    //(*Handlers(DElemSelection)
    void OnElemListSelect(wxCommandEvent& event);
    void OnDeleteListButtonClick(wxCommandEvent& event);
    void OnClearListButtonClick(wxCommandEvent& event);
    void OnTypeChoiceSelect(wxCommandEvent& event);
    void OnApplyButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
