#ifndef DEXPORTNASTRAN_H
#define DEXPORTNASTRAN_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DExportNastran)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/filedlg.h>
	#include <wx/choice.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DExportNastran)
//*)

#include "CMesh.h"
#include "CProjectData.h"
#include "CResults.h"
#include "DSimpleMessage.h"
#include "generalFunctions.h"
#include "importExport.h"

class DExportNastran: public wxDialog
{
public:
    DExportNastran(
            wxWindow* parent,
            CMesh* pMesh,
            CProjectData* pProjectData,
            CResults* pResults,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DExportNastran();

    //(*Declarations(DExportNastran)
    wxTextCtrl* ModulTextCtrl;
    wxButton* BrowseButton;
    wxStaticText* PoissonStaticText;
    wxButton* OKButton;
    wxStaticText* SelectLoadDataStaticText;
    wxCheckBox* WriteMeshCheckBox;
    wxTextCtrl* FileName;
    wxFileDialog* ExportFileDialog;
    wxCheckBox* WriteLoadsCheckBox;
    wxStaticText* ModulStaticText;
    wxTextCtrl* ThicknessTextCtrl;
    wxStaticText* ThicknessStaticText;
    wxChoice* CaseChoice;
    wxCheckBox* WriteMeshPropertyCheckBox;
    wxButton* CancelButton;
    wxStaticText* SelectCaseStaticText;
    wxChoice* LoadDataChoice;
    wxTextCtrl* PoissonTextCtrl;
    //*)

protected:
    //(*Identifiers(DExportNastran)
    static const long ID_CHECKBOX1;
    static const long ID_CHECKBOX2;
    static const long ID_CHECKBOX3;
    static const long ID_STATICTEXT1;
    static const long ID_CHOICE1;
    static const long ID_STATICTEXT2;
    static const long ID_CHOICE2;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT5;
    static const long ID_TEXTCTRL3;
    static const long ID_TEXTCTRL4;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    static const long ID_BUTTON3;
    //*)

private:
    CMesh* m_pMesh;
    CProjectData* m_pProjectData;
    CResults* m_pResults;

    //(*Handlers(DExportNastran)
    void OnLoadDataChoiceSelect(wxCommandEvent& event);
    void OnBrowseButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnWriteMeshPropertyCheckBoxClick(wxCommandEvent& event);
    void OnWriteMeshCheckBoxClick(wxCommandEvent& event);
    void OnWriteLoadsCheckBoxClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
