#ifndef DEXPORTVTK_H
#define DEXPORTVTK_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DExportVTK)
	#include <wx/sizer.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/filedlg.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DExportVTK)
//*)

#include "CMesh.h"
#include "CProjectData.h"
#include "CResults.h"
#include "DSimpleMessage.h"
#include "generalFunctions.h"
#include "importExport.h"

class DExportVTK: public wxDialog
{
public:
    DExportVTK(
            wxWindow* parent,
            CMesh* pMesh,
            CProjectData* pProjectData,
            CResults* pResults,
            wxWindowID id=wxID_ANY);
    virtual ~DExportVTK();

    //(*Declarations(DExportVTK)
    wxButton* OKButton;
    wxTextCtrl* FileName;
    wxFileDialog* ExportFileDialog;
    wxButton* FileNameButton;
    wxCheckBox* ResultsCheckBox;
    wxRadioBox* PlotTypeRadioBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DExportVTK)
    static const long ID_CHECKBOX1;
    static const long ID_RADIOBOX1;
    static const long ID_TEXTCTRL1;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    static const long ID_BUTTON3;
    //*)

private:
    CMesh* m_pMesh;
    CProjectData* m_pProjectData;
    CResults* m_pResults;

    //(*Handlers(DExportVTK)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnBrowseButtonClick(wxCommandEvent& event);
    void OnResultsCheckBoxClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
