#ifndef DEXTRUDELINE_H
#define DEXTRUDELINE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DExtrudeLine)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DExtrudeLine)
//*)

#include "CGUIData.h"
#include "CMesh.h"
#include "DNodeSelection.h"

class DExtrudeLine: public wxDialog
{
public:
    DExtrudeLine(
            wxWindow* parent,
            bool& modified,
            CGUIData* pGUIData,
            CMesh* pMesh,
            setUInt& nodeSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DExtrudeLine();

    //(*Declarations(DExtrudeLine)
    wxButton* SelectButton;
    wxButton* OKButton;
    wxTextCtrl* sExtrusionLength;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxStaticText* StaticText4;
    wxButton* CancelButton;
    wxTextCtrl* sNumElem;
    //*)

protected:
    //(*Identifiers(DExtrudeLine)
    static const long ID_STATICTEXT1;
    static const long ID_BUTTON1;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL1;
    static const long ID_BUTTON2;
    static const long ID_BUTTON3;
    //*)

private:
    bool& m_modified;
    CGUIData* m_pGUIData;
    CMesh* m_pMesh;
    setUInt& m_nodeSelection;

    //(*Handlers(DExtrudeLine)
    void OnSelectButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
