#ifndef DFLOWPARAMS_H
#define DFLOWPARAMS_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DFlowParams)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DFlowParams)
#include <wx/grid.h>
//*)

#include "CProjectData.h"
#include "DSimpleMessage.h"

class DFlowParams: public wxDialog
{
public:
    DFlowParams(
            wxWindow* parent,
            bool& modified,
            CProjectData* pProjectData,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DFlowParams();

    //(*Declarations(DFlowParams)
    wxButton* InsertButton;
    wxButton* OKButton;
    wxStaticText* StaticText2;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxTextCtrl* AirspeedBox;
    wxTextCtrl* DensityBox;
    wxTextCtrl* PressureBox;
    wxFlexGridSizer* FlexGridSizer1;
    wxButton* RemoveButton;
    wxTextCtrl* MachBox;
    wxStaticText* StaticText4;
    wxButton* CancelButton;
    wxGrid* AnglesGrid;
    //*)

protected:
    //(*Identifiers(DFlowParams)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL5;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL6;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL7;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL8;
    static const long ID_BUTTON2;
    static const long ID_BUTTON5;
    static const long ID_GRID1;
    static const long ID_BUTTON1;
    static const long ID_BUTTON3;
    //*)

private:
    bool& m_modified;
    CProjectData* m_pProjectData;

    //(*Handlers(DFlowParams)
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnInsertButtonClick(wxCommandEvent& event);
    void OnRemoveButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
