#ifndef DGENERATENEIGHBORS_H
#define DGENERATENEIGHBORS_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DGenerateNeighbors)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DGenerateNeighbors)
//*)

#include "CGUIData.h"
#include "CMesh.h"
#include "DElemSelection.h"
#include "DSimpleMessage.h"
#include "params.h"

class DGenerateNeighbors: public wxDialog
{
public:
    DGenerateNeighbors(
            wxWindow* parent,
            bool& modified,
            CGUIData* pGUIData,
            CMesh* m_pMesh,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DGenerateNeighbors();

    //(*Declarations(DGenerateNeighbors)
    wxButton* SelectButton;
    wxButton* OKButton;
    wxStaticText* StaticText1;
    wxRadioBox* DomainRadioBox;
    wxTextCtrl* neighborThreshold;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DGenerateNeighbors)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CGUIData* m_pGUIData;
    CMesh* m_pMesh;
    setUInt& m_elemSelection;

    //(*Handlers(DGenerateNeighbors)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
