#ifndef DGENERATEWAKE_H
#define DGENERATEWAKE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DGenerateWake)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DGenerateWake)
//*)

#include "CGUIData.h"
#include "CMesh.h"
#include "DElemSelection.h"
#include "DSimpleMessage.h"
#include "params.h"

class DGenerateWake: public wxDialog
{
public:
    DGenerateWake(
            wxWindow* parent,
            bool& modified,
            CGUIData* pGUIData,
            CMesh* pMesh,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DGenerateWake();

    //(*Declarations(DGenerateWake)
    wxButton* SelectButton;
    wxButton* OKButton;
    wxTextCtrl* wakeNumBox;
    wxStaticText* StaticText2;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxTextCtrl* wakeThresholdBox;
    wxRadioBox* DomainRadioBox;
    wxTextCtrl* wakeLengthBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DGenerateWake)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL3;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CGUIData* m_pGUIData;
    CMesh* m_pMesh;
    setUInt& m_elemSelection;

    //(*Handlers(DGenerateWake)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
