#ifndef DIMPORTAPAMESOLVERINPUT_H
#define DIMPORTAPAMESOLVERINPUT_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DImportApameSolverInput)
	#include <wx/sizer.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/filedlg.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DImportApameSolverInput)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "CProjectData.h"
#include "generalFunctions.h"
#include "importExport.h"
#include "typenames.h"

class DImportApameSolverInput: public wxDialog
{
public:
    DImportApameSolverInput(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            CProjectData* pProjectData,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DImportApameSolverInput();

    //(*Declarations(DImportApameSolverInput)
    wxButton* BrowseButton;
    wxButton* OKButton;
    wxCheckBox* ReadResReqBox;
    wxFileDialog* ApameSolverInputImportDialog;
    wxCheckBox* ReadRefDataBox;
    wxCheckBox* ReadNodesBox;
    wxTextCtrl* FileName;
    wxCheckBox* ReadSolverParamsBox;
    wxCheckBox* ReadElementsBox;
    wxButton* CancelButton;
    wxCheckBox* ReadFlowParamsBox;
    //*)

protected:
    //(*Identifiers(DImportApameSolverInput)
    static const long ID_CHECKBOX1;
    static const long ID_CHECKBOX2;
    static const long ID_CHECKBOX3;
    static const long ID_CHECKBOX4;
    static const long ID_CHECKBOX5;
    static const long ID_CHECKBOX6;
    static const long ID_TEXTCTRL1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    CProjectData* m_pProjectData;

    //(*Handlers(DImportApameSolverInput)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnBrowseButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
