#ifndef DIMPORTAPAMESOLVERRESULTS_H
#define DIMPORTAPAMESOLVERRESULTS_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DImportApameSolverResults)
	#include <wx/sizer.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/filedlg.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DImportApameSolverResults)
//*)

#include "CMesh.h"
#include "CProjectData.h"
#include "CResults.h"
#include "DSimpleMessage.h"
#include "generalFunctions.h"
#include "importExport.h"
#include "typenames.h"

class DImportApameSolverResults: public wxDialog
{
public:
    DImportApameSolverResults(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            CProjectData* pProjectData,
            CResults* pResults,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DImportApameSolverResults();

    //(*Declarations(DImportApameSolverResults)
    wxButton* BrowseButton;
    wxButton* OKButton;
    wxCheckBox* ReadResReqBox;
    wxCheckBox* ReadRefDataBox;
    wxCheckBox* ReadNodesBox;
    wxFileDialog* ApameSolverResultsImportDialog;
    wxTextCtrl* FileName;
    wxCheckBox* ReadSolverParamsBox;
    wxCheckBox* ReadElementsBox;
    wxButton* CancelButton;
    wxCheckBox* ReadResultsBox;
    wxCheckBox* ReadFlowParamsBox;
    //*)

protected:
    //(*Identifiers(DImportApameSolverResults)
    static const long ID_CHECKBOX1;
    static const long ID_CHECKBOX2;
    static const long ID_CHECKBOX3;
    static const long ID_CHECKBOX4;
    static const long ID_CHECKBOX5;
    static const long ID_CHECKBOX6;
    static const long ID_CHECKBOX7;
    static const long ID_TEXTCTRL1;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    static const long ID_BUTTON3;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    CProjectData* m_pProjectData;
    CResults* m_pResults;

    //(*Handlers(DImportApameSolverResults)
    void OnBrowseButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnReadElementsBoxClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
