#ifndef DIMPORTFLUENT_H
#define DIMPORTFLUENT_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DImportFluent)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/filedlg.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DImportFluent)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "generalFunctions.h"
#include "importExport.h"
#include "typenames.h"

class DImportFluent: public wxDialog
{
public:
    DImportFluent(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DImportFluent();

    //(*Declarations(DImportFluent)
    wxButton* BrowseButton;
    wxButton* OKButton;
    wxTextCtrl* EnumElemID;
    wxTextCtrl* FileName;
    wxTextCtrl* EnumNodeID;
    wxFileDialog* FluentFileDialog;
    wxStaticText* EnumNodeIDText;
    wxStaticText* EnumElemIDText;
    wxCheckBox* PreserveIDBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DImportFluent)
    static const long ID_CHECKBOX1;
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL2;
    static const long ID_TEXTCTRL3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    static const long ID_BUTTON3;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;

    //(*Handlers(DImportFluent)
    void OnPreserveIDBoxClick(wxCommandEvent& event);
    void OnBrowseButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
