#ifndef DIMPORTNASTRAN_H
#define DIMPORTNASTRAN_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DImportNastran)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/filedlg.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DImportNastran)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "generalFunctions.h"
#include "importExport.h"
#include "typenames.h"

class DImportNastran: public wxDialog
{
public:
    DImportNastran(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            wxWindowID id=wxID_ANY);
    virtual ~DImportNastran();

    //(*Declarations(DImportNastran)
    wxFileDialog* NastranImportDialog;
    wxButton* BrowseButton;
    wxButton* OKButton;
    wxTextCtrl* EnumElemID;
    wxTextCtrl* FileName;
    wxTextCtrl* EnumNodeID;
    wxStaticText* EnumNodeIDText;
    wxStaticText* EnumElemIDText;
    wxCheckBox* PreserveIDBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DImportNastran)
    static const long ID_CHECKBOX1;
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL3;
    static const long ID_TEXTCTRL2;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;

    //(*Handlers(DImportNastran)
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnBrowseButtonClick(wxCommandEvent& event);
    void OnPreserveIDBoxClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
