#ifndef DMERGENODES_H
#define DMERGENODES_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DMergeNodes)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DMergeNodes)
//*)

#include "CMesh.h"
#include "DNodeSelection.h"

class DMergeNodes: public wxDialog
{
public:
    DMergeNodes(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            setUInt& nodeSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DMergeNodes();

    //(*Declarations(DMergeNodes)
    wxButton* SelectButton;
    wxRadioBox* MethodRadioBox;
    wxButton* OKButton;
    wxStaticText* StaticText1;
    wxRadioBox* DomainRadioBox;
    wxTextCtrl* ToleranceText;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DMergeNodes)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_RADIOBOX2;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    setUInt& m_nodeSelection;

    //(*Handlers(DMergeNodes)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
