#ifndef DNODESELECTION_H
#define DNODESELECTION_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DNodeSelection)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/listbox.h>
	#include <wx/choice.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DNodeSelection)
//*)

#include "CMesh.h"
#include "DSimpleMessage.h"
#include "typenames.h"

class DNodeSelection: public wxDialog
{
public:
    DNodeSelection(
            wxWindow* parent,
            CMesh* pMesh,
            setUInt& nodeSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DNodeSelection();

    //(*Declarations(DNodeSelection)
    wxFlexGridSizer* FlexGridSizer4;
    wxTextCtrl* labelBoxOne;
    wxChoice* TypeChoice;
    wxButton* OKButton;
    wxTextCtrl* labelBoxThree;
    wxButton* ApplyButton;
    wxStaticText* labelOne;
    wxButton* ClearListButton;
    wxListBox* NodeList;
    wxFlexGridSizer* FlexGridSizer2;
    wxStaticText* InfoText;
    wxStaticText* StaticText1;
    wxButton* DeleteListButton;
    wxStaticText* labelTwo;
    wxTextCtrl* labelBoxTwo;
    wxFlexGridSizer* FlexGridSizer6;
    wxFlexGridSizer* FlexGridSizer1;
    wxButton* CancelButton;
    wxRadioBox* AddOrRemove;
    wxFlexGridSizer* MainFlexGridSizer;
    wxStaticText* labelThree;
    //*)

protected:
    //(*Identifiers(DNodeSelection)
    static const long ID_LISTBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON5;
    static const long ID_STATICTEXT1;
    static const long ID_CHOICE1;
    static const long ID_RADIOBOX1;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL3;
    static const long ID_BUTTON4;
    static const long ID_STATICTEXT5;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    CMesh* m_pMesh;
    setUInt& m_nodeSelection;
    setUInt m_tempSelection; // temporary node selection that will be copied to real one if OK pressed

    void updateTypeSelection();
    void updateSelectionList();

    //(*Handlers(DNodeSelection)
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnTypeChoiceSelect(wxCommandEvent& event);
    void OnApplyButtonClick(wxCommandEvent& event);
    void OnDeleteListButtonClick(wxCommandEvent& event);
    void OnNodeListSelect(wxCommandEvent& event);
    void OnClearListButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
