#ifndef DRESULTSREQUEST_H
#define DRESULTSREQUEST_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DResultsRequest)
	#include <wx/sizer.h>
	#include <wx/checkbox.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DResultsRequest)
//*)

#include "CProjectData.h"
#include "DSimpleMessage.h"

class DResultsRequest: public wxDialog
{
public:
    DResultsRequest(
            wxWindow* parent,
            bool& modified,
            CProjectData* pProjectData,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DResultsRequest();

    //(*Declarations(DResultsRequest)
    wxCheckBox* dynamicPressure;
    wxCheckBox* doubletValues;
    wxCheckBox* manometerPressure;
    wxCheckBox* sourceValues;
    wxCheckBox* geometry;
    wxCheckBox* velocityComponents;
    wxCheckBox* centerPoints;
    wxCheckBox* coefficients;
    wxCheckBox* velocity;
    wxCheckBox* results;
    wxCheckBox* pressureCoefficient;
    wxCheckBox* meshCharacteristics;
    wxCheckBox* forces;
    wxCheckBox* staticPressure;
    //*)

protected:
    //(*Identifiers(DResultsRequest)
    static const long ID_CHECKBOX1;
    static const long ID_CHECKBOX2;
    static const long ID_CHECKBOX3;
    static const long ID_CHECKBOX4;
    static const long ID_CHECKBOX5;
    static const long ID_CHECKBOX6;
    static const long ID_CHECKBOX7;
    static const long ID_CHECKBOX8;
    static const long ID_CHECKBOX9;
    static const long ID_CHECKBOX10;
    static const long ID_CHECKBOX11;
    static const long ID_CHECKBOX12;
    static const long ID_CHECKBOX13;
    static const long ID_CHECKBOX14;
    //*)

private:
    bool& m_modified;
    CProjectData* m_pProjectData;

    //(*Handlers(DResultsRequest)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnresultsClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
