#ifndef DRUN_H
#define DRUN_H

#ifndef WX_PRECOMP
//(*HeadersPCH(DRun)
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/button.h>
#include <wx/dialog.h>
#include <wx/gauge.h>
//*)
#endif
//(*Headers(DRun)
//*)

#include "wx/process.h"

#include <fstream>

#include "CGUIData.h"
#include "CMesh.h"
#include "CProjectData.h"
#include "DSimpleMessage.h"
#include "generalFunctions.h"
#include "importExport.h"
#include "typenames.h"

class DRun: public wxDialog
{
public:
    DRun(
            wxWindow* parent,
            bool& modified,
            CGUIData* pGUIData,
            CMesh* pMesh,
            CProjectData* pProjectData,
            CResults* pResults,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DRun();

    //(*Declarations(DRun)
    wxStaticText* state;
    wxGauge* progressBar;
    wxButton* ResultsButton;
    wxButton* CancelCloseButton;
    wxButton* RunButton;
    wxTextCtrl* logFileText;
    //*)

protected:
    //(*Identifiers(DRun)
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT2;
    static const long ID_GAUGE1;
    static const long ID_BUTTON1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON2;
    //*)

private:
    // data structures passed as arguments
    bool& m_modified;
    CGUIData* m_pGUIData;
    CMesh* m_pMesh;
    CProjectData* m_pProjectData;
    CResults* m_pResults;
    // local member types
    string m_jobNamePath;               // ApameSolver jobname path
    wxTimer* m_timer;                   // timer for updating log window
    vecStr m_logLines;                  // log window lines
    wxProcess* m_apameSolverProcess;    // process that will be used to launch ApameSolver

    void OnProgressTimer(wxTimerEvent& WXUNUSED(event));

    //(*Handlers(DRun)
    void OnRunButtonClick(wxCommandEvent& event);
    void OnCancelCloseButtonClick(wxCommandEvent& event);
    void OnResultsButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
