#ifndef DSETTINGS_H
#define DSETTINGS_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DSettings)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/checkbox.h>
	#include <wx/filedlg.h>
	#include <wx/button.h>
	#include <wx/dirdlg.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DSettings)
//*)

#include "CGUIData.h"

class DSettings: public wxDialog
{
public:
    DSettings(
            wxWindow* parent,
            CGUIData* pGUIData,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DSettings();

    //(*Declarations(DSettings)
    wxStaticText* StaticText9;
    wxButton* BrowseTemporaryDirButton;
    wxCheckBox* TempDirCheckBox;
    wxFileDialog* ApameSolverPathDialog;
    wxButton* OKButton;
    wxStaticText* StaticText6;
    wxStaticText* StaticText8;
    wxTextCtrl* TempDirBox;
    wxStaticText* StaticText1;
    wxTextCtrl* WakeLengthBox;
    wxStaticText* StaticText3;
    wxTextCtrl* RefreshRateBox;
    wxStaticText* TempDirStaticText;
    wxStaticText* StaticText5;
    wxButton* BrowseApameSolverExeButton;
    wxStaticText* StaticText7;
    wxTextCtrl* NeighborThresholdBox;
    wxTextCtrl* ApameSolverPathBox;
    wxTextCtrl* WakeThresholdBox;
    wxButton* CancelButton;
    wxTextCtrl* WakeNumBox;
    wxDirDialog* TemporaryDirDialog;
    //*)

protected:
    //(*Identifiers(DSettings)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL3;
    static const long ID_BUTTON5;
    static const long ID_STATICTEXT3;
    static const long ID_CHECKBOX1;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL6;
    static const long ID_BUTTON1;
    static const long ID_STATICTEXT5;
    static const long ID_TEXTCTRL5;
    static const long ID_STATICTEXT6;
    static const long ID_TEXTCTRL7;
    static const long ID_STATICTEXT7;
    static const long ID_TEXTCTRL8;
    static const long ID_STATICTEXT8;
    static const long ID_TEXTCTRL9;
    static const long ID_STATICTEXT9;
    static const long ID_TEXTCTRL10;
    static const long ID_BUTTON3;
    static const long ID_BUTTON4;
    //*)

private:
    CGUIData* m_pGUIData;

    //(*Handlers(DSettings)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnBrowseApameSolverPathButtonClick(wxCommandEvent& event);
    void OnTempDirCheckBoxClick(wxCommandEvent& event);
    void OnBrowseTemporaryDirButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
