#ifndef DSIMPLEMESSAGE_H
#define DSIMPLEMESSAGE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DSimpleMessage)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DSimpleMessage)
//*)

#include "generalFunctions.h"
#include "typenames.h"

class DSimpleMessage: public wxDialog
{
public:
    DSimpleMessage(
            wxWindow* parent,
            wxString& message,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DSimpleMessage();

    //(*Declarations(DSimpleMessage)
    wxButton* OKButton;
    wxStaticText* errorMessage;
    //*)

protected:
    //(*Identifiers(DSimpleMessage)
    static const long ID_STATICTEXT1;
    static const long ID_BUTTON1;
    //*)

private:
    wxString& m_message;

    //(*Handlers(DSimpleMessage)
    void OnOKButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

void showErrorMessage(const string& message);
void showWarningMessage(const string& message);
void showInfoMessage(const string& message);
void showLineErrorMessage(
        const string& message,
        const uInt& lineIndex);
int checkEndOfFile(
        const uInt& numSkip,
        const uInt& lineIndex,
        const uInt& numLines);

#endif
