#ifndef DSOLVERPARAMS_H
#define DSOLVERPARAMS_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DSolverParams)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DSolverParams)
//*)

#include "CProjectData.h"
#include "DSimpleMessage.h"

class DSolverParams: public wxDialog
{
public:
    DSolverParams(
            wxWindow* parent,
            bool& modified,
            CProjectData* pProjectData,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DSolverParams();

    //(*Declarations(DSolverParams)
    wxButton* OKButton;
    wxTextCtrl* FarfieldBox;
    wxStaticText* StaticText2;
    wxRadioBox* MethodBox;
    wxRadioBox* CollcalcBox;
    wxTextCtrl* ColldistBox;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxRadioBox* VelorderBox;
    wxTextCtrl* ErrorBox;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DSolverParams)
    static const long ID_RADIOBOX1;
    static const long ID_RADIOBOX2;
    static const long ID_RADIOBOX3;
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CProjectData* m_pProjectData;

    //(*Handlers(DSolverParams)
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
