#ifndef DTRANSFORMMIRROR_H
#define DTRANSFORMMIRROR_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DTransformMirror)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DTransformMirror)
//*)

#include "CMesh.h"
#include "DElemSelection.h"
#include "params.h"
#include "DSimpleMessage.h"

class DTransformMirror: public wxDialog
{
public:
    DTransformMirror(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DTransformMirror();

    //(*Declarations(DTransformMirror)
    wxButton* SelectButton;
    wxButton* XYButton;
    wxButton* OKButton;
    wxTextCtrl* OriginX;
    wxTextCtrl* TipZ;
    wxStaticText* StaticText2;
    wxButton* YZButton;
    wxStaticText* StaticText1;
    wxTextCtrl* OriginY;
    wxRadioBox* DomainRadioBox;
    wxButton* ZXButton;
    wxTextCtrl* TipX;
    wxTextCtrl* OriginZ;
    wxButton* CancelButton;
    wxTextCtrl* TipY;
    //*)

protected:
    //(*Identifiers(DTransformMirror)
    static const long ID_BUTTON3;
    static const long ID_BUTTON4;
    static const long ID_BUTTON5;
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_TEXTCTRL2;
    static const long ID_TEXTCTRL3;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL4;
    static const long ID_TEXTCTRL5;
    static const long ID_TEXTCTRL6;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON6;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    setUInt& m_elemSelection;

    //(*Handlers(DTransformMirror)
    void OnZXButtonClick(wxCommandEvent& event);
    void OnXYButtonClick(wxCommandEvent& event);
    void OnYZButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
