#ifndef DTRANSFORMROTATE_H
#define DTRANSFORMROTATE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DTransformRotate)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DTransformRotate)
//*)

#include "CMesh.h"
#include "DElemSelection.h"
#include "DNodeSelection.h"
#include "DSimpleMessage.h"

class DTransformRotate: public wxDialog
{
public:
    DTransformRotate(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            setUInt& nodeSelection,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~DTransformRotate();

    //(*Declarations(DTransformRotate)
    wxButton* SelectButton;
    wxTextCtrl* XStart;
    wxButton* OKButton;
    wxStaticText* StaticText2;
    wxStaticText* StaticText8;
    wxTextCtrl* YEnd;
    wxStaticText* StaticText1;
    wxTextCtrl* YStart;
    wxRadioBox* DomainRadioBox;
    wxTextCtrl* ZEnd;
    wxTextCtrl* XEnd;
    wxTextCtrl* ZStart;
    wxStaticText* StaticText12;
    wxButton* CancelButton;
    wxTextCtrl* Angle;
    //*)

protected:
    //(*Identifiers(DTransformRotate)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT2;
    static const long ID_STATICTEXT8;
    static const long ID_TEXTCTRL10;
    static const long ID_TEXTCTRL9;
    static const long ID_TEXTCTRL8;
    static const long ID_STATICTEXT12;
    static const long ID_TEXTCTRL11;
    static const long ID_TEXTCTRL12;
    static const long ID_TEXTCTRL13;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    setUInt& m_nodeSelection;
    setUInt& m_elemSelection;

    //(*Handlers(DTransformRotate)
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnOKButtonClick(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
