#ifndef DTRANSFORMSCALE_H
#define DTRANSFORMSCALE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DTransformScale)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DTransformScale)
//*)

#include "CMesh.h"
#include "DElemSelection.h"
#include "DNodeSelection.h"
#include "DSimpleMessage.h"

class DTransformScale: public wxDialog
{
public:
    DTransformScale(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            setUInt& nodeSelection,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY);
    virtual ~DTransformScale();

    //(*Declarations(DTransformScale)
    wxButton* SelectButton;
    wxButton* OKButton;
    wxTextCtrl* ZCenter;
    wxStaticText* StaticText6;
    wxStaticText* ZCenterText;
    wxRadioBox* RadioBoxType;
    wxStaticText* StaticText3;
    wxTextCtrl* XRatio;
    wxStaticText* CenterStaticText;
    wxTextCtrl* ZRatio;
    wxRadioBox* DomainRadioBox;
    wxStaticText* StaticText5;
    wxTextCtrl* YCenter;
    wxStaticText* XCenterText;
    wxStaticText* YCenterText;
    wxStaticText* StaticText4;
    wxButton* CancelButton;
    wxTextCtrl* XCenter;
    wxTextCtrl* YRatio;
    //*)

protected:
    //(*Identifiers(DTransformScale)
    static const long ID_RADIOBOX1;
    static const long ID_STATICTEXT3;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT5;
    static const long ID_TEXTCTRL3;
    static const long ID_STATICTEXT6;
    static const long ID_TEXTCTRL4;
    static const long ID_STATICTEXT1;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT7;
    static const long ID_TEXTCTRL5;
    static const long ID_STATICTEXT8;
    static const long ID_TEXTCTRL6;
    static const long ID_RADIOBOX2;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    setUInt& m_nodeSelection;
    setUInt& m_elemSelection;

    //(*Handlers(DTransformScale)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnRadioBoxTypeSelect(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
