#ifndef DTRANSFORMTRANSLATE_H
#define DTRANSFORMTRANSLATE_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(DTransformTranslate)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/radiobox.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(DTransformTranslate)
//*)

#include "CMesh.h"
#include "DElemSelection.h"
#include "DNodeSelection.h"
#include "DSimpleMessage.h"

class DTransformTranslate: public wxDialog
{
public:
    DTransformTranslate(
            wxWindow* parent,
            bool& modified,
            CMesh* pMesh,
            setUInt& nodeSelection,
            setUInt& elemSelection,
            wxWindowID id=wxID_ANY);
    virtual ~DTransformTranslate();

    //(*Declarations(DTransformTranslate)
    wxButton* SelectButton;
    wxButton* OKButton;
    wxTextCtrl* sz;
    wxStaticText* StaticText2;
    wxTextCtrl* sx;
    wxStaticText* StaticText1;
    wxStaticText* StaticText3;
    wxRadioBox* DomainRadioBox;
    wxTextCtrl* sy;
    wxStaticText* StaticText4;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(DTransformTranslate)
    static const long ID_STATICTEXT1;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT3;
    static const long ID_TEXTCTRL2;
    static const long ID_STATICTEXT4;
    static const long ID_TEXTCTRL3;
    static const long ID_RADIOBOX1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON1;
    static const long ID_BUTTON2;
    //*)

private:
    bool& m_modified;
    CMesh* m_pMesh;
    setUInt& m_nodeSelection;
    setUInt& m_elemSelection;

    //(*Handlers(DTransformTranslate)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnSelectButtonClick(wxCommandEvent& event);
    void OnDomainRadioBoxSelect(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
