#ifndef EDITNODEDIALOG_H
#define EDITNODEDIALOG_H

#ifndef WX_PRECOMP
	//(*HeadersPCH(EditNodeDialog)
	#include <wx/sizer.h>
	#include <wx/stattext.h>
	#include <wx/textctrl.h>
	#include <wx/button.h>
	#include <wx/dialog.h>
	//*)
#endif
//(*Headers(EditNodeDialog)
//*)

#include "CMesh.h"
#include "SimpleErrorDialog.h"
#include "typenames.h"

class EditNodeDialog: public wxDialog
{
public:
    EditNodeDialog(
            wxWindow* parent,
            CMesh& pMesh,
            uInt& nodeID,
            uInt& state,
            wxWindowID id=wxID_ANY,
            const wxPoint& pos=wxDefaultPosition,
            const wxSize& size=wxDefaultSize);
    virtual ~EditNodeDialog();

    //(*Declarations(EditNodeDialog)
    wxTextCtrl* sCoordX;
    wxButton* OKButton;
    wxStaticText* StaticText2;
    wxTextCtrl* sCoordZ;
    wxTextCtrl* sNodeID;
    wxStaticText* StaticText1;
    wxTextCtrl* sCoordY;
    wxButton* SkipButton;
    wxButton* CancelButton;
    //*)

protected:
    //(*Identifiers(EditNodeDialog)
    static const long ID_STATICTEXT1;
    static const long ID_TEXTCTRL1;
    static const long ID_STATICTEXT2;
    static const long ID_TEXTCTRL2;
    static const long ID_TEXTCTRL3;
    static const long ID_TEXTCTRL4;
    static const long ID_BUTTON1;
    static const long ID_BUTTON3;
    static const long ID_BUTTON2;
    //*)

private:
    CMesh* m_pMesh;
    uInt& m_nodeID;
    uInt& m_newNodeID;
    uInt& m_state;

    //(*Handlers(EditNodeDialog)
    void OnOKButtonClick(wxCommandEvent& event);
    void OnCancelButtonClick(wxCommandEvent& event);
    void OnSkipButtonClick(wxCommandEvent& event);
    //*)

    DECLARE_EVENT_TABLE()
};

#endif
