#ifndef GENERALFUNCTIONS_H
#define GENERALFUNCTIONS_H

#include "wx/process.h"

#include <iostream>
#include <fstream>
#include <sstream>

#include "CMesh.h"
#include "CResults.h"
#include "DSimpleMessage.h"
#include "params.h"
#include "typenames.h"

// general type conversions
int    str2Int(const string& number);
double str2Dbl(const string& number);
string int2Str(const int&    number);
string dbl2Str(const double& number);
string wxs2Str(const wxString& wxsString);
wxString str2Wxs(const string& stlString);

// conversions for analysis report
wxString dbl2StrCase (const double& number);
wxString dbl2StrForc (const double& number);
wxString dbl2StrCoeff(const double& number);

// string operations
string convert2UpperCase  (const string& inputString);
string change2SingleSpace (const string& inputString);
string removeLeadingSpaces(const string& inputString);
vecStr splitString(
        const string& inputString,
        const char& splitter);
string replaceStringSegment(
        const string& inputString,
        const string& oldSegment,
        const string& newSegment);

// file operations
bool fileExists(const string& filename);
int  deleteFile(const string& filename);
bool getLine(
        ifstream& inputFile,
        string& line);

// IDW - Inverse Distance Weighting Method operations
int weightFactors(
        vecVecDbl& nodeWeights,
        const vecVecUInt& elementNodes,
        const vecVecDbl& nodeCoords,
        const vecVecDbl& elemCenterCoords);
int weightAverage(
        vecDbl& nodeField,
        const vecVecDbl& weights,
        const vecVecUInt& elementNodes,
        const vecDbl& elemField);

double elementSurface(vecVecDbl& coords);

#endif
