#ifndef UNDOREDO_H
#define UNDOREDO_H

#include "CMesh.h"
#include "CProjectData.h"
#include "CResults.h"
#include "typenames.h"

struct undoRedoStruct
{
    // command name
    string command;
    // undo data
    CMesh undoMesh;
    CProjectData undoGUIData;
    CResults undoResults;
    // redo data
    CMesh redoMesh;
    CProjectData redoGUIData;
    CResults redoResults;
};

void undo(
        list<undoRedoStruct>& undoList,
        list<undoRedoStruct>& redoList,
        CProjectData* pProjectData,
        CMesh* pMesh,
        CResults* pResults);
void redo(
        list<undoRedoStruct>& undoList,
        list<undoRedoStruct>& redoList,
        CProjectData* pProjectData,
        CMesh* pMesh,
        CResults* pResults);
void storeUndoData(
        const string& command,
        undoRedoStruct& undoInfo,
        CMesh* pMesh,
        CProjectData* pProjectData,
        CResults* pResults);
void storeRedoData(
        undoRedoStruct& undoInfo,
        list<undoRedoStruct>& undoList,
        CMesh* pMesh,
        CProjectData* pProjectData,
        CResults* pResults);

#endif
