/***************************************************************
 * Name:      ApameGUIApp.cpp
 * Purpose:   Code for Application Class
 * Author:    Daniel Filkovic (daniel.filkovic@gmail.com)
 * Created:   2010-10-23
 * Copyright: Daniel Filkovic (www.3dpanelmethod.com)
 * License:   GNU GENERAL PUBLIC LICENSE
 **************************************************************/

//(*AppHeaders
#include "ApameGUIMain.h"
#include <wx/image.h>
//*)
#include "wx_pch.h"
#include "ApameGUIApp.h"
#include "wx/artprov.h"

// XPMs icons for wxART
#include "new24.xpm"
#include "open24.xpm"
#include "save24.xpm"
#include "undo24.xpm"
#include "redo24.xpm"
#include "refit24.xpm"
#include "front24.xpm"
#include "top24.xpm"
#include "left24.xpm"
#include "back24.xpm"
#include "bottom24.xpm"
#include "right24.xpm"
#include "isometric24.xpm"
#include "run24.xpm"
#include "logoApame_32.xpm"

class MyArtProvider : public wxArtProvider
{
protected:
    virtual wxBitmap CreateBitmap(const wxArtID& id, const wxArtClient& client, const wxSize& size);
};

wxBitmap MyArtProvider::CreateBitmap(const wxArtID& id, const wxArtClient& client, const wxSize& size)
{
    if      (id == wxART_NEW_24)       return wxBitmap(new24);
    else if (id == wxART_OPEN_24)      return wxBitmap(open24);
    else if (id == wxART_SAVE_24)      return wxBitmap(save24);
    else if (id == wxART_UNDO_24)      return wxBitmap(undo24);
    else if (id == wxART_REDO_24)      return wxBitmap(redo24);
    else if (id == wxART_REFIT_24)     return wxBitmap(refit24);
    else if (id == wxART_FRONT_24)     return wxBitmap(front24);
    else if (id == wxART_TOP_24)       return wxBitmap(top24);
    else if (id == wxART_LEFT_24)      return wxBitmap(left24);
    else if (id == wxART_BACK_24)      return wxBitmap(back24);
    else if (id == wxART_BOTTOM_24)    return wxBitmap(bottom24);
    else if (id == wxART_RIGHT_24)     return wxBitmap(right24);
    else if (id == wxART_ISOMETRIC_24) return wxBitmap(isometric24);
    else if (id == wxART_RUN_24)       return wxBitmap(run24);
    else if (id == wxART_APAME_32)     return wxBitmap(logoApame_32_xpm);
    else return wxNullBitmap;
}

IMPLEMENT_APP(ApameGUIApp);

bool ApameGUIApp::OnInit()
{
    if (!wxApp::OnInit())
        return false;

    wxArtProvider::PushBack(new MyArtProvider);

    //(*AppInitialize
    bool wxsOK = true;
    wxInitAllImageHandlers();
    if (wxsOK){
    	ApameGUIFrame* Frame = new ApameGUIFrame(0, m_programArgument);
    	Frame->Show();
    	SetTopWindow(Frame);
        Frame->initialize();
    }
    //*)

    return wxsOK;
}

void ApameGUIApp::OnInitCmdLine(wxCmdLineParser& parser)
{
    parser.SetDesc(g_cmdLineDesc);
}

bool ApameGUIApp::OnCmdLineParsed(wxCmdLineParser& parser)
{
    // get apameGUI argument
    if (parser.GetParamCount() != 0)
        m_programArgument = wxs2Str(parser.GetParam(0));

    return true;
}
