/***************************************************************
 * Name:      ApameGUIMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Daniel Filkovic (daniel.filkovic@gmail.com)
 * Created:   2010-10-23
 * Copyright: Daniel Filkovic (www.3dpanelmethod.com)
 * License:   GNU GENERAL PUBLIC LICENSE
 **************************************************************/

#include <wx/msgdlg.h>
#include <wx/app.h>

//(*InternalHeaders(ApameGUIFrame)
#include <wx/artprov.h>
#include <wx/bitmap.h>
#include <wx/icon.h>
#include <wx/intl.h>
#include <wx/image.h>
#include <wx/string.h>
//*)

#include "ApameGUIMain.h"
#include "wx_pch.h"

//(*IdInit(ApameGUIFrame)
const long ApameGUIFrame::ID_GLCANVAS1 = wxNewId();
const long ApameGUIFrame::idMenuNew = wxNewId();
const long ApameGUIFrame::idMenuOpen = wxNewId();
const long ApameGUIFrame::idMenuSave = wxNewId();
const long ApameGUIFrame::idMenuSaveAs = wxNewId();
const long ApameGUIFrame::idMenuApameIn = wxNewId();
const long ApameGUIFrame::idMenuApameRes = wxNewId();
const long ApameGUIFrame::idMenuABQIn = wxNewId();
const long ApameGUIFrame::idMenuFluentMsh = wxNewId();
const long ApameGUIFrame::idMenuIdeas = wxNewId();
const long ApameGUIFrame::idMenuNastran = wxNewId();
const long ApameGUIFrame::idMenuVTKIn = wxNewId();
const long ApameGUIFrame::idMenuImport = wxNewId();
const long ApameGUIFrame::idMenuApameOut = wxNewId();
const long ApameGUIFrame::idMenuABQ = wxNewId();
const long ApameGUIFrame::idMenuNAS = wxNewId();
const long ApameGUIFrame::idMenuVTK = wxNewId();
const long ApameGUIFrame::idMenuExport = wxNewId();
const long ApameGUIFrame::idMenuQuit = wxNewId();
const long ApameGUIFrame::idMenuUndo = wxNewId();
const long ApameGUIFrame::idMenuRedo = wxNewId();
const long ApameGUIFrame::idMenuSelectNodes = wxNewId();
const long ApameGUIFrame::idMenuSelectElems = wxNewId();
const long ApameGUIFrame::idMenuScale = wxNewId();
const long ApameGUIFrame::idMenuTranslate = wxNewId();
const long ApameGUIFrame::idMenuRotate = wxNewId();
const long ApameGUIFrame::idMenuMirror = wxNewId();
const long ApameGUIFrame::idMenuChangeElemType = wxNewId();
const long ApameGUIFrame::idMenuWakeElems = wxNewId();
const long ApameGUIFrame::idMenuNode = wxNewId();
const long ApameGUIFrame::idMenuElement = wxNewId();
const long ApameGUIFrame::idMenuNeighbors = wxNewId();
const long ApameGUIFrame::idMenuWake = wxNewId();
const long ApameGUIFrame::idMenuExtrude = wxNewId();
const long ApameGUIFrame::idMenuSeparate = wxNewId();
const long ApameGUIFrame::ID_MENUITEM6 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM9 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM12 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM21 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM22 = wxNewId();
const long ApameGUIFrame::idMenuFlowParams = wxNewId();
const long ApameGUIFrame::idMenuRefs = wxNewId();
const long ApameGUIFrame::idMenuSolvParams = wxNewId();
const long ApameGUIFrame::idMenuResReq = wxNewId();
const long ApameGUIFrame::idMenuRun = wxNewId();
const long ApameGUIFrame::idMenuDispWire = wxNewId();
const long ApameGUIFrame::idMenuDispSolid = wxNewId();
const long ApameGUIFrame::idMenuNormCheck = wxNewId();
const long ApameGUIFrame::idMenuNeighCheck = wxNewId();
const long ApameGUIFrame::idMenuLights = wxNewId();
const long ApameGUIFrame::idMenuDispEdge = wxNewId();
const long ApameGUIFrame::ID_MENUITEM4 = wxNewId();
const long ApameGUIFrame::idMenuNodes = wxNewId();
const long ApameGUIFrame::idMenuCoord = wxNewId();
const long ApameGUIFrame::idMenuLegend = wxNewId();
const long ApameGUIFrame::idMenuShowNodeID = wxNewId();
const long ApameGUIFrame::idMenuShowElemID = wxNewId();
const long ApameGUIFrame::ID_MENUITEM23 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM24 = wxNewId();
const long ApameGUIFrame::idMenuDelNode = wxNewId();
const long ApameGUIFrame::idMenuDelElem = wxNewId();
const long ApameGUIFrame::idMenuDelNeigh = wxNewId();
const long ApameGUIFrame::idMenuDelRes = wxNewId();
const long ApameGUIFrame::idMenuDelMesh = wxNewId();
const long ApameGUIFrame::idMenuGeneral = wxNewId();
const long ApameGUIFrame::idMenuAbout = wxNewId();
const long ApameGUIFrame::ID_STATUSBAR1 = wxNewId();
const long ApameGUIFrame::IdNew = wxNewId();
const long ApameGUIFrame::idOpen = wxNewId();
const long ApameGUIFrame::IdSave = wxNewId();
const long ApameGUIFrame::idUndo = wxNewId();
const long ApameGUIFrame::idRedo = wxNewId();
const long ApameGUIFrame::idRefit = wxNewId();
const long ApameGUIFrame::idFront = wxNewId();
const long ApameGUIFrame::idTop = wxNewId();
const long ApameGUIFrame::ID_TOOLBARITEM1 = wxNewId();
const long ApameGUIFrame::idBack = wxNewId();
const long ApameGUIFrame::idBottom = wxNewId();
const long ApameGUIFrame::idLeft = wxNewId();
const long ApameGUIFrame::idIsometric = wxNewId();
const long ApameGUIFrame::idRun = wxNewId();
const long ApameGUIFrame::ID_TOOLBAR1 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM10 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM14 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM15 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM16 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM11 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM17 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM18 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM19 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM20 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM13 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM2 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM3 = wxNewId();
const long ApameGUIFrame::ID_MENUITEM1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(ApameGUIFrame,wxFrame)
    //(*EventTable(ApameGUIFrame)
    //*)
END_EVENT_TABLE()

ApameGUIFrame::ApameGUIFrame(wxWindow* parent, string& programArgument, wxWindowID id)
{
    //(*Initialize(ApameGUIFrame)
    wxMenuItem* Quit;
    wxMenuItem* MenuItem2;
    wxMenu* Menu1;
    wxMenuItem* MenuItemImportApameSolverResults;
    wxMenu* Menu7;
    wxMenuItem* MenuItemExportApameInput;
    wxMenuItem* MenuItemImportAbaqusInput;
    wxMenuItem* MenuItemImportFluentMesh;
    wxMenuItem* MenuItemImportApameSolverInput;
    wxMenuItem* MenuItemNew;
    wxMenuBar* MenuBar1;
    wxMenu* MenuItem5;
    wxMenu* Menu8;
    wxMenu* Menu2;
    wxMenuItem* MenuItemImportVTKMesh;
    wxMenu* Menu11;

    Create(parent, wxID_ANY, _("ApameGUI - Untitled"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE|wxFULL_REPAINT_ON_RESIZE, _T("wxID_ANY"));
    {
    	wxIcon FrameIcon;
    	FrameIcon.CopyFromBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_APAME_32")),wxART_FRAME_ICON));
    	SetIcon(FrameIcon);
    }
    int GLCanvasAttributes_1[] = {
    	WX_GL_RGBA,
    	WX_GL_DOUBLEBUFFER,
    	WX_GL_DEPTH_SIZE,      16,
    	WX_GL_STENCIL_SIZE,    0,
    	0, 0 };
    m_p3DViewer = new C3DViewer(this, ID_GLCANVAS1, wxDefaultPosition, wxDefaultSize, 0, _T("ID_GLCANVAS1"), GLCanvasAttributes_1);
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItemNew = new wxMenuItem(Menu1, idMenuNew, _("New\tCtrl+N"), _("Clear all data and start new project"), wxITEM_NORMAL);
    Menu1->Append(MenuItemNew);
    MenuItemOpen = new wxMenuItem(Menu1, idMenuOpen, _("Open\tCtrl+O"), _("Open ApameGUI project"), wxITEM_NORMAL);
    Menu1->Append(MenuItemOpen);
    Menu1->AppendSeparator();
    MenuItemSave = new wxMenuItem(Menu1, idMenuSave, _("Save\tCtrl+S"), _("Save ApameGUI project"), wxITEM_NORMAL);
    Menu1->Append(MenuItemSave);
    MenuItemSaveAs = new wxMenuItem(Menu1, idMenuSaveAs, _("Save As..."), _("Save ApameGUI project with different file name"), wxITEM_NORMAL);
    Menu1->Append(MenuItemSaveAs);
    Menu1->AppendSeparator();
    MenuItem3 = new wxMenu();
    MenuItemImportApameSolverInput = new wxMenuItem(MenuItem3, idMenuApameIn, _("ApameSolver Input File..."), _("Import ApameSolver Input File"), wxITEM_NORMAL);
    MenuItem3->Append(MenuItemImportApameSolverInput);
    MenuItemImportApameSolverResults = new wxMenuItem(MenuItem3, idMenuApameRes, _("ApameSolver Results File..."), _("Import ApameSolver Results File"), wxITEM_NORMAL);
    MenuItem3->Append(MenuItemImportApameSolverResults);
    MenuItemImportAbaqusInput = new wxMenuItem(MenuItem3, idMenuABQIn, _("Abaqus File..."), _("Import Abaqus File"), wxITEM_NORMAL);
    MenuItem3->Append(MenuItemImportAbaqusInput);
    MenuItemImportFluentMesh = new wxMenuItem(MenuItem3, idMenuFluentMsh, _("Fluent File..."), _("Import Fluent File"), wxITEM_NORMAL);
    MenuItem3->Append(MenuItemImportFluentMesh);
    MenuItem1 = new wxMenuItem(MenuItem3, idMenuIdeas, _("Ideas File..."), _("Import Ideas file"), wxITEM_NORMAL);
    MenuItem3->Append(MenuItem1);
    MenuItem4 = new wxMenuItem(MenuItem3, idMenuNastran, _("Nastran File..."), _("Import Nastran File"), wxITEM_NORMAL);
    MenuItem3->Append(MenuItem4);
    MenuItemImportVTKMesh = new wxMenuItem(MenuItem3, idMenuVTKIn, _("VTK File..."), _("Import VTK File"), wxITEM_NORMAL);
    MenuItem3->Append(MenuItemImportVTKMesh);
    Menu1->Append(idMenuImport, _("Import"), MenuItem3, wxEmptyString);
    MenuItem5 = new wxMenu();
    MenuItemExportApameInput = new wxMenuItem(MenuItem5, idMenuApameOut, _("Apame Input File..."), _("Export Apame input file"), wxITEM_NORMAL);
    MenuItem5->Append(MenuItemExportApameInput);
    MenuItemExportAbaqus = new wxMenuItem(MenuItem5, idMenuABQ, _("Abaqus File..."), _("Export Abaqus file"), wxITEM_NORMAL);
    MenuItem5->Append(MenuItemExportAbaqus);
    MenuItemExportAbaqus->Enable(false);
    MenuItemExportNastran = new wxMenuItem(MenuItem5, idMenuNAS, _("Nastran File..."), _("Export Nastran file"), wxITEM_NORMAL);
    MenuItem5->Append(MenuItemExportNastran);
    MenuItemExportNastran->Enable(false);
    MenuItemVTKExport = new wxMenuItem(MenuItem5, idMenuVTK, _("VTK File..."), _("Export Visualization Toolkit file"), wxITEM_NORMAL);
    MenuItem5->Append(MenuItemVTKExport);
    MenuItemVTKExport->Enable(false);
    Menu1->Append(idMenuExport, _("Export"), MenuItem5, wxEmptyString);
    Menu1->AppendSeparator();
    Quit = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit ApameGUI"), wxITEM_NORMAL);
    Menu1->Append(Quit);
    MenuBar1->Append(Menu1, _("&File"));
    Menu8 = new wxMenu();
    MenuItemUndo = new wxMenuItem(Menu8, idMenuUndo, _("Undo\tCtrl+Z"), _("Undo Command"), wxITEM_NORMAL);
    Menu8->Append(MenuItemUndo);
    MenuItemUndo->Enable(false);
    MenuItemRedo = new wxMenuItem(Menu8, idMenuRedo, _("Redo\tCtrl+Y"), _("Redo Command"), wxITEM_NORMAL);
    Menu8->Append(MenuItemRedo);
    MenuItemRedo->Enable(false);
    Menu8->AppendSeparator();
    MenuItemSelectNodes = new wxMenuItem(Menu8, idMenuSelectNodes, _("Select Nodes"), _("Select nodes for further actions on them"), wxITEM_NORMAL);
    Menu8->Append(MenuItemSelectNodes);
    MenuItemSelectElems = new wxMenuItem(Menu8, idMenuSelectElems, _("Select Elements"), _("Select elements for further actions on them"), wxITEM_NORMAL);
    Menu8->Append(MenuItemSelectElems);
    Menu8->AppendSeparator();
    MenuItemScale = new wxMenuItem(Menu8, idMenuScale, _("Scale"), _("Scale Mesh"), wxITEM_NORMAL);
    Menu8->Append(MenuItemScale);
    MenuItemScale->Enable(false);
    MenuItemTranslate = new wxMenuItem(Menu8, idMenuTranslate, _("Translate"), _("Translate Mesh"), wxITEM_NORMAL);
    Menu8->Append(MenuItemTranslate);
    MenuItemTranslate->Enable(false);
    MenuItemRotate = new wxMenuItem(Menu8, idMenuRotate, _("Rotate"), _("Rotate Mesh"), wxITEM_NORMAL);
    Menu8->Append(MenuItemRotate);
    MenuItemRotate->Enable(false);
    MenuItemMirror = new wxMenuItem(Menu8, idMenuMirror, _("Mirror"), _("Mirror Mesh"), wxITEM_NORMAL);
    Menu8->Append(MenuItemMirror);
    MenuItemMirror->Enable(false);
    Menu8->AppendSeparator();
    MenuItemChangeElemType = new wxMenuItem(Menu8, idMenuChangeElemType, _("Change Element Type"), _("Change Element Type"), wxITEM_NORMAL);
    Menu8->Append(MenuItemChangeElemType);
    MenuItemChangeElemType->Enable(false);
    MenuItemEditWakes = new wxMenuItem(Menu8, idMenuWakeElems, _("Edit Wake Trailing Elements"), _("Edit wake\'s trailing elements"), wxITEM_NORMAL);
    Menu8->Append(MenuItemEditWakes);
    MenuItemEditWakes->Enable(false);
    MenuBar1->Append(Menu8, _("&Edit"));
    Menu3 = new wxMenu();
    MenuItemNode = new wxMenuItem(Menu3, idMenuNode, _("Create Node..."), _("Create node"), wxITEM_NORMAL);
    Menu3->Append(MenuItemNode);
    MenuItemElem = new wxMenuItem(Menu3, idMenuElement, _("Create Element..."), _("Create element"), wxITEM_NORMAL);
    Menu3->Append(MenuItemElem);
    Menu3->AppendSeparator();
    MenuItemNeighbors = new wxMenuItem(Menu3, idMenuNeighbors, _("Neighbors Generator"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItemNeighbors);
    MenuItemNeighbors->Enable(false);
    MenuItemWake = new wxMenuItem(Menu3, idMenuWake, _("Wake Generator"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItemWake);
    MenuItemWake->Enable(false);
    MenuItemExtrudeLine = new wxMenuItem(Menu3, idMenuExtrude, _("Extrude Line"), _("Extrude line of selected nodes (release wake)"), wxITEM_NORMAL);
    Menu3->Append(MenuItemExtrudeLine);
    MenuItemExtrudeLine->Enable(false);
    MenuItemDSeparateNeighbors = new wxMenuItem(Menu3, idMenuSeparate, _("Separate Neighbors"), _("Separate neighbors at node selection"), wxITEM_NORMAL);
    Menu3->Append(MenuItemDSeparateNeighbors);
    MenuItemDSeparateNeighbors->Enable(false);
    Menu3->AppendSeparator();
    MenuItemMergeNodes = new wxMenuItem(Menu3, ID_MENUITEM6, _("Merge Coincident Nodes"), _("Merge Coincident Nodes"), wxITEM_NORMAL);
    Menu3->Append(MenuItemMergeNodes);
    MenuItemMergeNodes->Enable(false);
    Menu3->AppendSeparator();
    MenuItemNodeDist = new wxMenuItem(Menu3, ID_MENUITEM9, _("Measure Node to Node"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItemNodeDist);
    MenuItemElemDist = new wxMenuItem(Menu3, ID_MENUITEM12, _("Measure Element to Element"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItemElemDist);
    MenuItemCalcSurf = new wxMenuItem(Menu3, ID_MENUITEM21, _("Measure Selection Surface"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItemCalcSurf);
    Menu3->AppendSeparator();
    MenuItemBoundBox = new wxMenuItem(Menu3, ID_MENUITEM22, _("Bounding Box Info"), wxEmptyString, wxITEM_NORMAL);
    Menu3->Append(MenuItemBoundBox);
    MenuBar1->Append(Menu3, _("&Mesh"));
    Menu4 = new wxMenu();
    MenuItem6 = new wxMenuItem(Menu4, idMenuFlowParams, _("Flow Parameters"), _("Define flow parameters such as airspeed, angle of attack, etc."), wxITEM_NORMAL);
    Menu4->Append(MenuItem6);
    MenuItem7 = new wxMenuItem(Menu4, idMenuRefs, _("Reference Values"), _("Define reference values for aerodynamic coefficients calculations"), wxITEM_NORMAL);
    Menu4->Append(MenuItem7);
    MenuItem8 = new wxMenuItem(Menu4, idMenuSolvParams, _("Solver Parameters"), _("Define solver parameters for fine tuning"), wxITEM_NORMAL);
    Menu4->Append(MenuItem8);
    MenuItem9 = new wxMenuItem(Menu4, idMenuResReq, _("Results Request"), _("Define which results Apame solver should output"), wxITEM_NORMAL);
    Menu4->Append(MenuItem9);
    MenuBar1->Append(Menu4, _("&Define"));
    Menu5 = new wxMenu();
    MenuItemRun = new wxMenuItem(Menu5, idMenuRun, _("Run"), _("Run Apame solver"), wxITEM_NORMAL);
    Menu5->Append(MenuItemRun);
    MenuItemRun->Enable(false);
    MenuBar1->Append(Menu5, _("&Solver"));
    Menu6 = new wxMenu();
    MenuItemWireframe = new wxMenuItem(Menu6, idMenuDispWire, _("Wireframe"), _("Display wireframe model"), wxITEM_CHECK);
    Menu6->Append(MenuItemWireframe);
    MenuItemSolid = new wxMenuItem(Menu6, idMenuDispSolid, _("Solid"), _("Display solid model"), wxITEM_CHECK);
    Menu6->Append(MenuItemSolid);
    MenuItemNormCheck = new wxMenuItem(Menu6, idMenuNormCheck, _("Normals Check"), _("Check element normals"), wxITEM_CHECK);
    Menu6->Append(MenuItemNormCheck);
    MenuItemNeighCheck = new wxMenuItem(Menu6, idMenuNeighCheck, _("Neighbors Check"), _("Check element neighbors"), wxITEM_CHECK);
    Menu6->Append(MenuItemNeighCheck);
    Menu6->AppendSeparator();
    MenuItemShowLights = new wxMenuItem(Menu6, idMenuLights, _("Lights"), _("Turn lights on/off"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowLights);
    MenuItemShowEdges = new wxMenuItem(Menu6, idMenuDispEdge, _("Edges"), _("Display/hide element edges"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowEdges);
    MenuItemShowWake = new wxMenuItem(Menu6, ID_MENUITEM4, _("Wake"), _("Display/hide wake geometry"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowWake);
    MenuItemShowNodes = new wxMenuItem(Menu6, idMenuNodes, _("Nodes"), _("Display/hide nodes"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowNodes);
    MenuItemShowCoord = new wxMenuItem(Menu6, idMenuCoord, _("Coordinate System"), _("Display/hide coordinate system"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowCoord);
    MenuItemShowLegend = new wxMenuItem(Menu6, idMenuLegend, _("Legend"), _("Display results legend"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowLegend);
    Menu6->AppendSeparator();
    MenuItemShowNodeID = new wxMenuItem(Menu6, idMenuShowNodeID, _("Show Node IDs"), _("Show Node IDs in 3D Viewer"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowNodeID);
    MenuItemShowElemID = new wxMenuItem(Menu6, idMenuShowElemID, _("Show Element IDs"), _("Show Element IDs in 3D Viewer"), wxITEM_CHECK);
    Menu6->Append(MenuItemShowElemID);
    MenuBar1->Append(Menu6, _("&View"));
    Menu11 = new wxMenu();
    MenuItemSurfacePlot = new wxMenuItem(Menu11, ID_MENUITEM23, _("Surface Plot..."), _("Display surface plot on geometry"), wxITEM_NORMAL);
    Menu11->Append(MenuItemSurfacePlot);
    MenuItemAnalysisReport = new wxMenuItem(Menu11, ID_MENUITEM24, _("Analysis Report..."), wxEmptyString, wxITEM_NORMAL);
    Menu11->Append(MenuItemAnalysisReport);
    MenuBar1->Append(Menu11, _("&Display"));
    Menu10 = new wxMenu();
    MenuItemDeleteNodes = new wxMenuItem(Menu10, idMenuDelNode, _("Nodes"), _("Delete selected nodes"), wxITEM_NORMAL);
    Menu10->Append(MenuItemDeleteNodes);
    MenuItemDeleteNodes->Enable(false);
    MenuItemDeleteElements = new wxMenuItem(Menu10, idMenuDelElem, _("Elements"), _("Delete selected elements"), wxITEM_NORMAL);
    Menu10->Append(MenuItemDeleteElements);
    MenuItemDeleteElements->Enable(false);
    Menu10->AppendSeparator();
    MenuItemDeleteNeighbors = new wxMenuItem(Menu10, idMenuDelNeigh, _("Neighboring Info"), _("Delete neighbor references from elements"), wxITEM_NORMAL);
    Menu10->Append(MenuItemDeleteNeighbors);
    MenuItemDeleteNeighbors->Enable(false);
    Menu10->AppendSeparator();
    MenuItemDeleteResults = new wxMenuItem(Menu10, idMenuDelRes, _("Results Data"), _("Delete results data"), wxITEM_NORMAL);
    Menu10->Append(MenuItemDeleteResults);
    Menu10->AppendSeparator();
    MenuItemDeleteMesh = new wxMenuItem(Menu10, idMenuDelMesh, _("All Mesh"), _("Delete all mesh"), wxITEM_NORMAL);
    Menu10->Append(MenuItemDeleteMesh);
    MenuItemDeleteMesh->Enable(false);
    MenuBar1->Append(Menu10, _("&Delete"));
    Menu7 = new wxMenu();
    MenuItemGeneralSettings = new wxMenuItem(Menu7, idMenuGeneral, _("General"), _("Define general settings"), wxITEM_NORMAL);
    Menu7->Append(MenuItemGeneralSettings);
    MenuBar1->Append(Menu7, _("&Settings"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About...\tF1"), _("About Apame"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, wxST_SIZEGRIP, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[2] = { -10, -10 };
    int __wxStatusBarStyles_1[2] = { wxSB_NORMAL, wxSB_NORMAL };
    StatusBar1->SetFieldsCount(2,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(2,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);
    ApameSolverExportDialog = new wxFileDialog(this, _("Enter ApameSolver input file"), wxEmptyString, wxEmptyString, _("ApameSolver input file (*.inp)|*.inp|All files (*.*)|*.*"), wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
    ToolBar1 = new wxToolBar(this, ID_TOOLBAR1, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL, _T("ID_TOOLBAR1"));
    ToolBar1->SetToolBitmapSize(wxSize(-1,16));
    ToolBarItem1 = ToolBar1->AddTool(IdNew, _("New"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_NEW_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Clear all data and start new project"), wxEmptyString);
    ToolBarItem2 = ToolBar1->AddTool(idOpen, _("Open"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_OPEN_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Open ApameGUI file"), wxEmptyString);
    ToolBarItemSave = ToolBar1->AddTool(IdSave, _("Save"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_SAVE_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Save ApameGUI file"), wxEmptyString);
    ToolBar1->AddSeparator();
    ToolBarItemUndo = ToolBar1->AddTool(idUndo, _("Undo"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_UNDO_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
    ToolBarItemRedo = ToolBar1->AddTool(idRedo, _("Redo"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_REDO_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
    ToolBar1->AddSeparator();
    ToolBarItem6 = ToolBar1->AddTool(idRefit, _("Refit"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_REFIT_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Refit model to screen"), wxEmptyString);
    ToolBarItem7 = ToolBar1->AddTool(idFront, _("Front"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FRONT_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Front"), wxEmptyString);
    ToolBarItem8 = ToolBar1->AddTool(idTop, _("Top"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_TOP_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Top"), wxEmptyString);
    ToolBarItem9 = ToolBar1->AddTool(ID_TOOLBARITEM1, _("Right"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_RIGHT_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Right"), wxEmptyString);
    ToolBarItem10 = ToolBar1->AddTool(idBack, _("Back"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_BACK_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Back"), wxEmptyString);
    ToolBarItem11 = ToolBar1->AddTool(idBottom, _("Bottom"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_BOTTOM_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Bottom"), wxEmptyString);
    ToolBarItem12 = ToolBar1->AddTool(idLeft, _("Left"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_LEFT_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Left"), wxEmptyString);
    ToolBarItem13 = ToolBar1->AddTool(idIsometric, _("Isometric"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_ISOMETRIC_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Isometric"), wxEmptyString);
    ToolBar1->AddSeparator();
    ToolBarItemRun = ToolBar1->AddTool(idRun, _("Run"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_RUN_24")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, _("Run Apame Solver"), wxEmptyString);
    ToolBar1->Realize();
    SetToolBar(ToolBar1);
    ApameGUISaveFileDialog = new wxFileDialog(this, _("Save ApameGUI project..."), wxEmptyString, wxEmptyString, _("ApameGUI file (*.apame)|*.apame|All files (*.*)|*.*"), wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
    ApameGUIOpenFileDialog = new wxFileDialog(this, _("Select ApameGUI file..."), wxEmptyString, wxEmptyString, _("ApameGUI file (*.apame)|*.apame|All files (*.*)|*.*"), wxFD_OPEN|wxFD_FILE_MUST_EXIST, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
    MenuItemClearAll = new wxMenuItem((&ViewerPopUpMenu), ID_MENUITEM10, _("Clear Selections"), wxEmptyString, wxITEM_NORMAL);
    ViewerPopUpMenu.Append(MenuItemClearAll);
    MenuItem11 = new wxMenu();
    MenuItemClearNodeSelection = new wxMenuItem(MenuItem11, ID_MENUITEM14, _("Clear Selection"), wxEmptyString, wxITEM_NORMAL);
    MenuItem11->Append(MenuItemClearNodeSelection);
    MenuItemPopEditNodes = new wxMenuItem(MenuItem11, ID_MENUITEM15, _("Edit"), wxEmptyString, wxITEM_NORMAL);
    MenuItem11->Append(MenuItemPopEditNodes);
    MenuItemPopDeleteNodes = new wxMenuItem(MenuItem11, ID_MENUITEM16, _("Delete"), wxEmptyString, wxITEM_NORMAL);
    MenuItem11->Append(MenuItemPopDeleteNodes);
    ViewerPopUpMenu.Append(ID_MENUITEM11, _("Node..."), MenuItem11, wxEmptyString);
    MenuItem13 = new wxMenu();
    MenuItemClearElementSelection = new wxMenuItem(MenuItem13, ID_MENUITEM17, _("Clear Selection"), wxEmptyString, wxITEM_NORMAL);
    MenuItem13->Append(MenuItemClearElementSelection);
    MenuItemPopEditElements = new wxMenuItem(MenuItem13, ID_MENUITEM18, _("Edit"), wxEmptyString, wxITEM_NORMAL);
    MenuItem13->Append(MenuItemPopEditElements);
    MenuItemPopReverseElements = new wxMenuItem(MenuItem13, ID_MENUITEM19, _("Reverse Normal"), wxEmptyString, wxITEM_NORMAL);
    MenuItem13->Append(MenuItemPopReverseElements);
    MenuItemPopDeleteElements = new wxMenuItem(MenuItem13, ID_MENUITEM20, _("Delete"), wxEmptyString, wxITEM_NORMAL);
    MenuItem13->Append(MenuItemPopDeleteElements);
    ViewerPopUpMenu.Append(ID_MENUITEM13, _("Element..."), MenuItem13, wxEmptyString);
    MenuItem10 = new wxMenu();
    MenuItemSelElem = new wxMenuItem(MenuItem10, ID_MENUITEM2, _("Elements"), wxEmptyString, wxITEM_CHECK);
    MenuItem10->Append(MenuItemSelElem);
    MenuItemSelNode = new wxMenuItem(MenuItem10, ID_MENUITEM3, _("Nodes"), wxEmptyString, wxITEM_CHECK);
    MenuItem10->Append(MenuItemSelNode);
    ViewerPopUpMenu.Append(ID_MENUITEM1, _("Selection Mode..."), MenuItem10, wxEmptyString);

    m_p3DViewer->Connect(wxEVT_LEFT_DOWN,(wxObjectEventFunction)&ApameGUIFrame::OnGLCanvasLeftMouse,0,this);
    m_p3DViewer->Connect(wxEVT_LEFT_UP,(wxObjectEventFunction)&ApameGUIFrame::OnGLCanvasLeftMouse,0,this);
    m_p3DViewer->Connect(wxEVT_MIDDLE_DOWN,(wxObjectEventFunction)&ApameGUIFrame::OnGLCanvasMiddleDown,0,this);
    m_p3DViewer->Connect(wxEVT_MIDDLE_UP,(wxObjectEventFunction)&ApameGUIFrame::OnGLCanvasMiddleUp,0,this);
    m_p3DViewer->Connect(wxEVT_RIGHT_UP,(wxObjectEventFunction)&ApameGUIFrame::OnGLCanvasRightMouse,0,this);
    m_p3DViewer->Connect(wxEVT_MOTION,(wxObjectEventFunction)&ApameGUIFrame::OnGLCanvasMouseMove,0,this);
    m_p3DViewer->Connect(wxEVT_MOUSEWHEEL,(wxObjectEventFunction)&ApameGUIFrame::OnGLCanvasMouseWheel,0,this);
    m_p3DViewer->Connect(wxEVT_SIZE,(wxObjectEventFunction)&ApameGUIFrame::OnResize,0,this);
    Connect(idMenuNew,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnNew);
    Connect(idMenuOpen,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemOpenSelected);
    Connect(idMenuSave,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSaveSelected);
    Connect(idMenuSaveAs,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSaveAsSelected);
    Connect(idMenuApameIn,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemImportApameSolverInputSelected);
    Connect(idMenuApameRes,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemImportApameSolverResultsSelected);
    Connect(idMenuABQIn,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemImportAbaqusInputSelected);
    Connect(idMenuFluentMsh,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemImportFluentMeshSelected);
    Connect(idMenuIdeas,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuIdeas);
    Connect(idMenuNastran,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuNastran);
    Connect(idMenuVTKIn,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemImportVTKMeshSelected);
    Connect(idMenuApameOut,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemExportApameInputSelected);
    Connect(idMenuABQ,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemExportAbaqusSelected);
    Connect(idMenuNAS,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemExportNastranSelected);
    Connect(idMenuVTK,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemExportVTK);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnQuitSelected);
    Connect(idMenuUndo,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemUndoSelected);
    Connect(idMenuRedo,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemRedoSelected);
    Connect(idMenuSelectNodes,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSelectNodesSelected);
    Connect(idMenuSelectElems,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSelectElemsSelected);
    Connect(idMenuScale,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemScaleSelected);
    Connect(idMenuTranslate,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemTranslateSelected);
    Connect(idMenuRotate,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemRotateSelected);
    Connect(idMenuMirror,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemMirrorSelected);
    Connect(idMenuChangeElemType,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemChangeElemTypeSelected);
    Connect(idMenuWakeElems,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemEditWakesSelected);
    Connect(idMenuNode,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemNodeSelected);
    Connect(idMenuElement,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemElemSelected);
    Connect(idMenuNeighbors,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemNeighborsSelected);
    Connect(idMenuWake,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemWakeSelected);
    Connect(idMenuExtrude,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemExtrudeLineSelected);
    Connect(idMenuSeparate,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemDSeparateNeighborsSelected);
    Connect(ID_MENUITEM6,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemMergeNodesSelected);
    Connect(ID_MENUITEM9,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemNodeDistSelected);
    Connect(ID_MENUITEM12,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemElemDistSelected);
    Connect(ID_MENUITEM21,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemCalcSurfSelected);
    Connect(ID_MENUITEM22,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemBoundBoxSelected);
    Connect(idMenuFlowParams,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemFlowParams);
    Connect(idMenuRefs,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuRefs);
    Connect(idMenuSolvParams,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuSolvParams);
    Connect(idMenuResReq,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuResultsRequest);
    Connect(idMenuRun,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuRunSelected);
    Connect(idMenuDispWire,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemWireframeSelected);
    Connect(idMenuDispSolid,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSolidSelected);
    Connect(idMenuNormCheck,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemNormCheckSelected);
    Connect(idMenuNeighCheck,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemNeighCheckSelected);
    Connect(idMenuLights,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnShowLightsSelected);
    Connect(idMenuDispEdge,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemShowEdgesSelected);
    Connect(ID_MENUITEM4,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnShowWakeSelected);
    Connect(idMenuNodes,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemShowNodesSelected);
    Connect(idMenuCoord,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemShowCoordSelected);
    Connect(idMenuLegend,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemShowLegendSelected);
    Connect(idMenuShowNodeID,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemShowNodeIDSelected);
    Connect(idMenuShowElemID,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemShowElemIDSelected);
    Connect(ID_MENUITEM23,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSelResSelected);
    Connect(ID_MENUITEM24,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemAnalysisReportSelected);
    Connect(idMenuDelNode,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemDeleteNodesSelected);
    Connect(idMenuDelElem,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemDeleteElementsSelected);
    Connect(idMenuDelNeigh,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemDeleteNeighborsSelected);
    Connect(idMenuDelRes,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemDeleteResultsSelected);
    Connect(idMenuDelMesh,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemDeleteMeshSelected);
    Connect(idMenuGeneral,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemGeneralSettings);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnAbout);
    Connect(IdNew,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnNew);
    Connect(idOpen,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemOpenSelected);
    Connect(IdSave,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSaveSelected);
    Connect(idUndo,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemUndoSelected);
    Connect(idRedo,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemRedoSelected);
    Connect(idRefit,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemRefitClicked);
    Connect(idFront,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemFrontClicked);
    Connect(idTop,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemTopClicked);
    Connect(ID_TOOLBARITEM1,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemLeftClicked);
    Connect(idBack,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemBackClicked);
    Connect(idBottom,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemBottomClicked);
    Connect(idLeft,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemRightClicked);
    Connect(idIsometric,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnToolBarItemIsometricClicked);
    Connect(idRun,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuRunSelected);
    Connect(ID_MENUITEM10,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemClearSelectionsSelected);
    Connect(ID_MENUITEM14,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemClearNodeSelectionSelected);
    Connect(ID_MENUITEM15,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemPopEditNodesSelected);
    Connect(ID_MENUITEM16,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemPopDeleteNodesSelected);
    Connect(ID_MENUITEM17,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemClearElementSelectionSelected);
    Connect(ID_MENUITEM18,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemPopEditElementsSelected);
    Connect(ID_MENUITEM19,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemPopReverseElementsSelected);
    Connect(ID_MENUITEM20,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemPopDeleteElementsSelected);
    Connect(ID_MENUITEM2,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSelElemSelected);
    Connect(ID_MENUITEM3,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&ApameGUIFrame::OnMenuItemSelNodeSelected);
    Connect(wxID_ANY,wxEVT_CLOSE_WINDOW,(wxObjectEventFunction)&ApameGUIFrame::OnClose);
    Connect(wxEVT_PAINT,(wxObjectEventFunction)&ApameGUIFrame::OnPaint);
    //*)

    // allocate member objects
    m_pGUIData     = new CGUIData();     // GUI data
    m_pMesh        = new CMesh();        // mesh data
    m_pResults     = new CResults();     // results data
    m_pProjectData = new CProjectData(); // project data

    // start with no change to the project
    m_modified = false;

    // read ApameGUI project file if argument is given
    if (!programArgument.empty())
        m_pProjectData->openApameGUIFile(programArgument, m_pGUIData, m_pMesh, m_pResults);
}

//-----------------------------------------------------------------------/
// deletes member objects
//-----------------------------------------------------------------------/
ApameGUIFrame::~ApameGUIFrame()
{
    //(*Destroy(ApameGUIFrame)
    //*)
    if (m_p3DViewer)    delete m_p3DViewer;
    if (m_pGUIData)     delete m_pGUIData;
    if (m_pMesh)        delete m_pMesh;
    if (m_pProjectData) delete m_pProjectData;
    if (m_pResults)     delete m_pResults;
}

void ApameGUIFrame::OnNew(wxCommandEvent& event)
{
    if (m_modified){
        // ask user for additional confirmation
        if (!OKToContinue("Project has been modified, are you sure you want to continue?"))
            return;
    }

    m_modified = false;

    // clear member objects
    delete m_pProjectData;
    delete m_pMesh;
    delete m_pResults;
    m_pMesh        = new CMesh();
    m_pProjectData = new CProjectData();
    m_pResults     = new CResults();
    m_p3DViewer->clearData();

    // clear undo/redo lists
    m_undoList.clear();
    m_redoList.clear();

    // clear node and element selection maps
    m_nodeSelection.clear();
    m_elemSelection.clear();

    // do complete refresh
    completeRefresh();
}

void ApameGUIFrame::OnMenuItemOpenSelected(wxCommandEvent& event)
{
    // ask user for additional confirmation
    if (m_modified){
        if (!OKToContinue("Project has been modified, are you sure you want to continue?"))
            return;
    }

    // open window
    if (ApameGUIOpenFileDialog->ShowModal() != wxID_OK)
        return;

    m_modified = false;

    // clear member objects
    delete m_pProjectData;
    delete m_pMesh;
    delete m_pResults;
    m_pMesh        = new CMesh();
    m_pProjectData = new CProjectData();
    m_pResults     = new CResults();
    m_p3DViewer->clearData();

    // clear undo/redo lists
    m_undoList.clear();
    m_redoList.clear();

    // clear node and element selection maps
    m_nodeSelection.clear();
    m_elemSelection.clear();

    // get filename with full path
    string fileName = wxs2Str(ApameGUIOpenFileDialog->GetPath());

    // call reading function
    m_pProjectData->openApameGUIFile(fileName, m_pGUIData, m_pMesh, m_pResults);

    // do complete refresh
    completeRefresh();

    // refit 3D Viewer
    m_p3DViewer->refit(m_pMesh);
}

void ApameGUIFrame::OnMenuItemSaveSelected(wxCommandEvent& event)
{
    // if project name is "Untitled" then call Save As function
    if (m_pProjectData->projectName == "Untitled"){
        OnMenuItemSaveAsSelected(event);
        return;
    }

    // assemble ApameGUI full file path
    string apameGUIFileName = m_pGUIData->currentDir+"/"+m_pProjectData->projectName+".apame";

    // call saving function
    m_pProjectData->saveApameGUIFile(apameGUIFileName, m_pMesh, m_pResults);

    // set modified flag to false
    m_modified = false;

    // refresh GUI
    refreshGUI();
}

void ApameGUIFrame::OnMenuItemSaveAsSelected(wxCommandEvent& event)
{
    // open window
    ApameGUISaveFileDialog->SetFilename(str2Wxs(m_pProjectData->projectName));
    if (ApameGUISaveFileDialog->ShowModal() != wxID_OK)
        return;

    // get filename with full path
    string apameGUIFileName = wxs2Str(ApameGUISaveFileDialog->GetPath());

    // store current working directory
    m_pGUIData->currentDir = wxs2Str(ApameGUISaveFileDialog->GetDirectory());

    // store project name from file name
    m_pProjectData->projectName = wxs2Str(ApameGUISaveFileDialog->GetFilename());
    if (m_pProjectData->projectName.size() > 6 && m_pProjectData->projectName.substr(m_pProjectData->projectName.size()-6, 6) == ".apame")
        m_pProjectData->projectName = m_pProjectData->projectName.substr(0, m_pProjectData->projectName.size()-6);

    // call saving function
    m_pProjectData->saveApameGUIFile(apameGUIFileName, m_pMesh, m_pResults);

    // set modified flag to false
    m_modified = false;

    // refresh GUI
    refreshGUI();
}

void ApameGUIFrame::OnClose(wxCloseEvent& event)
{
    // check if project has changed
    if (m_modified){
        if (!OKToContinue("Project has been modified, are you sure you want to continue?"))
            return;
    }

    if (IsMaximized())
        m_pGUIData->maximized = 1;
    else{
        m_pGUIData->maximized = 0;

        // restore window before saving its size (supported on windows only)
#ifdef WIN32
        Maximize(false);
#endif
        // get screen size
        int width, height;
        GetSize(&width, &height);
        m_pGUIData->width  = uInt(width);
        m_pGUIData->height = uInt(height);
    }

    // store GUI data
    m_pGUIData->storeGUIData();

    Destroy();
}

void ApameGUIFrame::OnQuitSelected(wxCommandEvent& event)
{
    Close(true);
}

void ApameGUIFrame::OnMenuItemImportApameSolverInputSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Import ApameSolver input File", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DImportApameSolverInput* importApameSolver = new DImportApameSolverInput(0, modified, m_pMesh, m_pProjectData);
    importApameSolver->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemImportApameSolverResultsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Import ApameSolver Result File", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DImportApameSolverResults* importApameSolverResult = new DImportApameSolverResults(0, modified, m_pMesh, m_pProjectData, m_pResults);
    importApameSolverResult->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemImportAbaqusInputSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Import Abaqus File", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DImportAbaqus* importAbaqus = new DImportAbaqus(0, modified, m_pMesh);
    importAbaqus->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemImportFluentMeshSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Import Fluent File", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DImportFluent* importFluent = new DImportFluent(0, modified, m_pMesh);
    importFluent->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuIdeas(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Import Ideas File", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DImportIdeas* importIdeas = new DImportIdeas(0, modified, m_pMesh);
    importIdeas->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuNastran(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Import Nastran File", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DImportNastran* importNastran = new DImportNastran(0, modified, m_pMesh);
    importNastran->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemImportVTKMeshSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Import VTK File", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DImportVTK* importVTK = new DImportVTK(0, modified, m_pMesh);
    importVTK->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemExportApameInputSelected(wxCommandEvent& event)
{
    // get ApameSolver input name from project name
    string apameSolverInputName = replaceStringSegment(change2SingleSpace(m_pProjectData->projectName), " ", "_");

    // open window
    ApameSolverExportDialog->SetFilename(str2Wxs(apameSolverInputName));
    if (ApameSolverExportDialog->ShowModal() != wxID_OK)
        return;

    // get filename with full path
    apameSolverInputName = wxs2Str(ApameSolverExportDialog->GetPath());

    // write ApameSolver input file
    writeApameSolverInput(apameSolverInputName, m_pMesh, m_pProjectData);
}

void ApameGUIFrame::OnMenuItemExportAbaqusSelected(wxCommandEvent& event)
{
    // open window
    DExportAbaqus* exportAbaqus = new DExportAbaqus(0, m_pMesh, m_pProjectData, m_pResults);
    exportAbaqus->ShowModal();
}

void ApameGUIFrame::OnMenuItemExportNastranSelected(wxCommandEvent& event)
{
    // open window
    DExportNastran* exportNastran = new DExportNastran(0, m_pMesh, m_pProjectData, m_pResults);
    exportNastran->ShowModal();
}

void ApameGUIFrame::OnMenuItemExportVTK(wxCommandEvent& event)
{
    // open new window
    DExportVTK* exportVTK = new DExportVTK(0, m_pMesh, m_pProjectData, m_pResults);
    exportVTK->ShowModal();
}

void ApameGUIFrame::OnMenuItemUndoSelected(wxCommandEvent& event)
{
    undo(m_undoList, m_redoList, m_pProjectData, m_pMesh, m_pResults);

    // clear node and element selection maps
    m_nodeSelection.clear();
    m_elemSelection.clear();

    // do complete refresh
    completeRefresh();
}

void ApameGUIFrame::OnMenuItemRedoSelected(wxCommandEvent& event)
{
    redo(m_undoList, m_redoList, m_pProjectData, m_pMesh, m_pResults);

    // clear node and element selection maps
    m_nodeSelection.clear();
    m_elemSelection.clear();

    // update openGL data for drawing
    m_p3DViewer->updateMeshData(m_pMesh, m_pProjectData);

    // do complete refresh
    completeRefresh();
}

void ApameGUIFrame::OnMenuItemSelectNodesSelected(wxCommandEvent& event)
{
    DNodeSelection* nodeSelection = new DNodeSelection(0, m_pMesh, m_nodeSelection);
    nodeSelection->ShowModal();

    m_p3DViewer->updateColor(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnMenuItemSelectElemsSelected(wxCommandEvent& event)
{
    DElemSelection* elemSelection = new DElemSelection(0, m_pMesh, m_elemSelection);
    elemSelection->ShowModal();

    m_p3DViewer->updateColor(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnMenuItemScaleSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Scale Geometry", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DTransformScale* scale = new DTransformScale(0, modified, m_pMesh, m_nodeSelection, m_elemSelection);
    scale->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemTranslateSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Translate Geometry", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DTransformTranslate* translate = new DTransformTranslate(0, modified, m_pMesh, m_nodeSelection, m_elemSelection);
    translate->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemRotateSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Rotate Geometry", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DTransformRotate* rotate = new DTransformRotate(0, modified, m_pMesh, m_nodeSelection, m_elemSelection);
    rotate->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemMirrorSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Mirror Geometry", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DTransformMirror* mirror = new DTransformMirror(0, modified, m_pMesh, m_elemSelection);
    mirror->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemChangeElemTypeSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Change Element Type", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DChangeElemType* changeElemType = new DChangeElemType(0, modified, m_pMesh, m_elemSelection);
    changeElemType->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemEditWakesSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Wake Trailing Elements", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DEditWakes* EditWakesFrame = new DEditWakes(0, modified, m_pMesh, m_elemSelection);
    EditWakesFrame->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemNodeSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Create Node", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DCreateNode* node = new DCreateNode(0, modified, m_pMesh);
    node->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemElemSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Create Element", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DCreateElement* element = new DCreateElement(0, modified, m_pMesh);
    element->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemNeighborsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Generate Neighbors", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DGenerateNeighbors* NeighborsFrame = new DGenerateNeighbors(0, modified, m_pGUIData, m_pMesh, m_elemSelection);
    NeighborsFrame->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemWakeSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Generate Wake", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DGenerateWake* WakeFrame = new DGenerateWake(0, modified, m_pGUIData, m_pMesh, m_elemSelection);
    WakeFrame->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemExtrudeLineSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Extrude Line", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DExtrudeLine* extrude = new DExtrudeLine(0, modified, m_pGUIData, m_pMesh, m_nodeSelection);
    extrude->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemDSeparateNeighborsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Separate Neighbors", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DSeparateNeighbors* separate = new DSeparateNeighbors(0, modified, m_pMesh, m_nodeSelection);
    separate->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemMergeNodesSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Merge Nodes", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DMergeNodes* mergeNodes = new DMergeNodes(0, modified, m_pMesh, m_nodeSelection);
    mergeNodes->ShowModal();

    // clear node selection map
    m_nodeSelection.clear();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemNodeDistSelected(wxCommandEvent& event)
{
    // check if exactly 2 nodes exist in node selection
    if (m_nodeSelection.size() != 2){
        showErrorMessage("Please select exactly 2 nodes for measuring!");
        return;
    }

    // extract node IDs
    uInt firstNode = *m_nodeSelection.begin();
    uInt secndNode = *m_nodeSelection.rbegin();

    // get node coordinates
    double firstCoords[3], secndCoords[3];
    if (m_pMesh->getNodeCoords(firstNode, firstCoords) ||
        m_pMesh->getNodeCoords(secndNode, secndCoords) ){
        showErrorMessage("Error in getting node coordinates for measuring");
        return;
    }

    // calculate distance
    double distanceComponents[3];
    for (uInt i=0; i<3; i++)
        distanceComponents[i] = secndCoords[i]-firstCoords[i];
    double distance = sqrt( pow(distanceComponents[0], 2) +
                            pow(distanceComponents[1], 2) +
                            pow(distanceComponents[2], 2) );

    // print info in dialog
    string message = "Distance between nodes "+int2Str(firstNode)+" and "+int2Str(secndNode)+" is:\n"+dbl2Str(distance)+"\n\n";
    message = message+"Components are:"+"\nX : "+dbl2Str(distanceComponents[0]) +
                                        "\nY : "+dbl2Str(distanceComponents[1]) +
                                        "\nZ : "+dbl2Str(distanceComponents[2]) ;
    showInfoMessage(message);
}

void ApameGUIFrame::OnMenuItemElemDistSelected(wxCommandEvent& event)
{
    // check if exactly 2 elements exist in element selection
    if (m_elemSelection.size() != 2){
        showErrorMessage("Please select exactly 2 elements for measuring!");
        return;
    }

    // extract element IDs
    uInt firstElem = *m_elemSelection.begin();
    uInt secndElem = *m_elemSelection.rbegin();

    // get element coordinates
    vecVecDbl firstElemCoords, secndElemCoords;
    if (m_pMesh->getElemCoords(firstElem, firstElemCoords) ||
        m_pMesh->getElemCoords(secndElem, secndElemCoords) ){
        showErrorMessage("Error in getting element coordinates for measuring");
        return;
    }

    // convert to element center
    vecDbl firstCoords(3, 0.0);
    for (uInt nodeIndex=0; nodeIndex<firstElemCoords.size(); nodeIndex++){
        for (uInt i=0; i<3; i++)
            firstCoords[i] += firstElemCoords[nodeIndex][i];
    }
    for (uInt i=0; i<3; i++)
        firstCoords[i] /= firstElemCoords.size();

    vecDbl secndCoords(3, 0.0);
    for (uInt nodeIndex=0; nodeIndex<secndElemCoords.size(); nodeIndex++){
        for (uInt i=0; i<3; i++)
            secndCoords[i] += secndElemCoords[nodeIndex][i];
    }
    for (uInt i=0; i<3; i++)
        secndCoords[i] /= secndElemCoords.size();

    // calculate distance
    double distanceComponents[3];
    for (uInt i=0; i<3; i++)
        distanceComponents[i] = secndCoords[i]-firstCoords[i];
    double distance = sqrt( pow(distanceComponents[0], 2) +
                            pow(distanceComponents[1], 2) +
                            pow(distanceComponents[2], 2) );

    // print info in dialog
    string message = "Distance between elements "+int2Str(firstElem)+" and "+int2Str(secndElem)+" is:\n"+dbl2Str(distance)+"\n\n";
    message = message+"Components are:"+"\nX : "+dbl2Str(distanceComponents[0]) +
                                        "\nY : "+dbl2Str(distanceComponents[1]) +
                                        "\nZ : "+dbl2Str(distanceComponents[2]) ;
    showInfoMessage(message);
}

void ApameGUIFrame::OnMenuItemCalcSurfSelected(wxCommandEvent& event)
{
    // sum surfaces of elements from selection
    double surface = 0.0;
    for (setUIntIt elemIt=m_elemSelection.begin(); elemIt!=m_elemSelection.end(); elemIt++){
        // get element coordinates
        vecVecDbl elemCoords;
        if (m_pMesh->getElemCoords(*elemIt, elemCoords)){
            showErrorMessage("Error in getting element coordinates for measuring surface");
            return;
        }
        surface += elementSurface(elemCoords);
    }

    // print info in dialog
    string message = "Total surface of selected elements is:\n"+dbl2Str(surface);
    showInfoMessage(message);
}

void ApameGUIFrame::OnMenuItemBoundBoxSelected(wxCommandEvent& event)
{
    // get bounds from mesh
    // node bounds
    double* minNode = m_pMesh->getMinNode();
    double* maxNode = m_pMesh->getMaxNode();
    // body bounds
    double* minBody = m_pMesh->getMinBody();
    double* maxBody = m_pMesh->getMaxBody();
    // wake bounds
    double* minWake = m_pMesh->getMinWake();
    double* maxWake = m_pMesh->getMaxWake();
    if (minWake[0] > maxWake[0]){
        for (uInt i=0; i<3; i++){
            minWake[i] = 0.0;
            maxWake[i] = 0.0;
        }
    }
    else{
        for (uInt i=0; i<3; i++){
            minWake[i] = min(minWake[i], minBody[i]);
            maxWake[i] = max(maxWake[i], maxBody[i]);
        }
    }

    // print info in dialog
    string message = "Bounding box for body (without wake):";
    message += "\n X - min: "+dbl2Str(minBody[0])+" max: "+dbl2Str(maxBody[0])+" total: "+dbl2Str(maxBody[0]-minBody[0]);
    message += "\n Y - min: "+dbl2Str(minBody[1])+" max: "+dbl2Str(maxBody[1])+" total: "+dbl2Str(maxBody[1]-minBody[1]);
    message += "\n Z - min: "+dbl2Str(minBody[2])+" max: "+dbl2Str(maxBody[2])+" total: "+dbl2Str(maxBody[2]-minBody[2]);
    message += "\n\nBounding box for body (with wake):";
    message += "\n X - min: "+dbl2Str(minWake[0])+" max: "+dbl2Str(maxWake[0])+" total: "+dbl2Str(maxWake[0]-minWake[0]);
    message += "\n Y - min: "+dbl2Str(minWake[1])+" max: "+dbl2Str(maxWake[1])+" total: "+dbl2Str(maxWake[1]-minWake[1]);
    message += "\n Z - min: "+dbl2Str(minWake[2])+" max: "+dbl2Str(maxWake[2])+" total: "+dbl2Str(maxWake[2]-minWake[2]);
    message += "\n\nBounding box for nodes:";
    message += "\n X - min: "+dbl2Str(minNode[0])+" max: "+dbl2Str(maxNode[0])+" total: "+dbl2Str(maxNode[0]-minNode[0]);
    message += "\n Y - min: "+dbl2Str(minNode[1])+" max: "+dbl2Str(maxNode[1])+" total: "+dbl2Str(maxNode[1]-minNode[1]);
    message += "\n Z - min: "+dbl2Str(minNode[2])+" max: "+dbl2Str(maxNode[2])+" total: "+dbl2Str(maxNode[2]-minNode[2]);
    showInfoMessage(message);
}

void ApameGUIFrame::OnMenuItemFlowParams(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Flow Parameters", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DFlowParams* FlowParams = new DFlowParams(0, modified, m_pProjectData);
    FlowParams->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuRefs(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Reference Values", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DReferenceValues* referenceValues = new DReferenceValues(0, modified, m_pProjectData);
    referenceValues->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuSolvParams(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Solver Parameters", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DSolverParams* solverParams = new DSolverParams(0, modified, m_pProjectData);
    solverParams->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuResultsRequest(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Result Requests", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DResultsRequest* resultsRequest = new DResultsRequest(0, modified, m_pProjectData);
    resultsRequest->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuRunSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Load ApameSolver Results", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DRun* run = new DRun(0, modified, m_pGUIData, m_pMesh, m_pProjectData, m_pResults);
    run->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemWireframeSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Set Display Mode To Wireframe", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->displayMode = 0;

    // check/uncheck modes
    MenuItemWireframe->Check(true);
    MenuItemSolid->Check(false);
    MenuItemNormCheck->Check(false);
    MenuItemNeighCheck->Check(false);

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemSolidSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Set Display Mode To Solid", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->displayMode = 1;

    // check/uncheck modes
    MenuItemWireframe->Check(false);
    MenuItemSolid->Check(true);
    MenuItemNormCheck->Check(false);
    MenuItemNeighCheck->Check(false);

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemNormCheckSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Set Display Mode To Normals Check", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->displayMode = 2;

    // check/uncheck modes
    MenuItemWireframe->Check(false);
    MenuItemSolid->Check(false);
    MenuItemNormCheck->Check(true);
    MenuItemNeighCheck->Check(false);

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemNeighCheckSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Set Display Mode To Neighbor Check", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->displayMode = 3;

    // check/uncheck modes
    MenuItemWireframe->Check(false);
    MenuItemSolid->Check(false);
    MenuItemNormCheck->Check(false);
    MenuItemNeighCheck->Check(true);

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnShowLightsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Show Lights", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showLights = MenuItemShowLights->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemShowEdgesSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Show Edges", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showEdges = MenuItemShowEdges->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnShowWakeSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Show Wake", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showWake = MenuItemShowWake->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemShowNodesSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Show Nodes", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showNodes = MenuItemShowNodes->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemShowCoordSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Show Coordinate System", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showCoordSys = MenuItemShowCoord->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemShowLegendSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Legend", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showLegend = MenuItemShowLegend->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemShowNodeIDSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Show Node IDs", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showNodeIDs = MenuItemShowNodeID->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemShowElemIDSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Toggle Show Element IDs", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // update project data
    m_pProjectData->showElemIDs = MenuItemShowElemID->IsChecked();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemSelResSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Results Display", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open dialog
    bool modified = false;
    DDisplayResults* displayResults = new DDisplayResults(0, modified, m_p3DViewer, m_pMesh, m_pProjectData, m_pResults);
    displayResults->ShowModal();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemAnalysisReportSelected(wxCommandEvent& event)
{
    DAnalysisReport* analysisReport = new DAnalysisReport(0, m_pResults);
    analysisReport->ShowModal();
}

void ApameGUIFrame::OnMenuItemDeleteNodesSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Delete Nodes", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DDeleteNodes* deleteNodes = new DDeleteNodes(0, modified, m_pMesh, m_nodeSelection);
    deleteNodes->ShowModal();

    // clear node selection
    m_nodeSelection.clear();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemDeleteElementsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Delete Elements", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // open new window
    bool modified = false;
    DDeleteElements* deleteElements = new DDeleteElements(0, modified, m_pMesh, m_elemSelection);
    deleteElements->ShowModal();

    // clear element selection
    m_elemSelection.clear();

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemDeleteNeighborsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Delete Neighboring Info", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // ask user for additional confirmation
    if (!OKToContinue("This action will neighboring information, OK to continue?"))
        return;

    // clear neighbor information
    m_pMesh->clearNeighboringInfo();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemDeleteResultsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Delete Results", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // ask user for additional confirmation
    if (!OKToContinue("This action will clear all result data, OK to continue?"))
        return;

    // delete result data
    delete m_pResults;
    m_pResults = new CResults();

    // disable surface plot
    m_pProjectData->surfResultsShown = false;

    // hide legend
    m_pProjectData->showLegend = false;

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemDeleteMeshSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Delete Mesh", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // ask user for additional confirmation
    if (!OKToContinue("This action will clear all mesh and result data, OK to continue?"))
        return;

    // clear node and element selection maps
    m_nodeSelection.clear();
    m_elemSelection.clear();

    // delete mesh
    m_pMesh->clearData();

    // clear results data
    delete m_pResults;
    m_pResults = new CResults();

    // disable surface plot
    m_pProjectData->surfResultsShown = false;

    // hide legend
    m_pProjectData->showLegend = false;

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemGeneralSettings(wxCommandEvent& event)
{
    DSettings* settings = new DSettings(0, m_pGUIData);
    settings->ShowModal();
}

void ApameGUIFrame::OnAbout(wxCommandEvent& event)
{
    wxAboutDialogInfo info;
    info.SetName("ApameGUI");
    info.SetDescription("Aircraft Panel Method Graphic User Interface\nLicensed under General Public License\n\n(C) 2010-2014 Daniel Filkovic <daniel.filkovic@gmail.com>");
    wxString version;
    version << apameGUIVersion << '.' << apameGUISubVersion << '.' << apameGUIVersionDate;
    info.SetVersion(version);
    info.SetWebSite("http://www.3dpanelmethod.com");
    wxAboutBox(info);
}

void ApameGUIFrame::OnToolBarItemRefitClicked(wxCommandEvent& event)
{
    m_p3DViewer->refit(m_pMesh);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnToolBarItemFrontClicked(wxCommandEvent& event)
{
    m_p3DViewer->setViewToFront();
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnToolBarItemTopClicked(wxCommandEvent& event)
{
    m_p3DViewer->setViewToTop();
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnToolBarItemRightClicked(wxCommandEvent& event)
{
    m_p3DViewer->setViewToRight();
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnToolBarItemBackClicked(wxCommandEvent& event)
{
    m_p3DViewer->setViewToBack();
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnToolBarItemBottomClicked(wxCommandEvent& event)
{
    m_p3DViewer->setViewToBottom();
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnToolBarItemLeftClicked(wxCommandEvent& event)
{
    m_p3DViewer->setViewToLeft();
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnToolBarItemIsometricClicked(wxCommandEvent& event)
{
    m_p3DViewer->setViewToIso();
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnMenuItemClearSelectionsSelected(wxCommandEvent& event)
{
    // clear node and element selection maps
    m_nodeSelection.clear();
    m_elemSelection.clear();

    m_p3DViewer->updateColor(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnMenuItemClearNodeSelectionSelected(wxCommandEvent& event)
{
    // clear node selection map
    m_nodeSelection.clear();

    m_p3DViewer->updateColor(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnMenuItemClearElementSelectionSelected(wxCommandEvent& event)
{
    // clear element selection map
    m_elemSelection.clear();

    m_p3DViewer->updateColor(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnMenuItemPopEditNodesSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Nodes", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    bool modified = false;
    for (setUIntIt it=m_nodeSelection.begin(); it!=m_nodeSelection.end(); it++){
        // open Edit Node window
        uInt state = 0;
        uInt nodeID = *it;
        DEditNode* EditNodeFrame = new DEditNode(0, m_pMesh, nodeID, state);
        EditNodeFrame->ShowModal();

        // check state value
        if      (state == 0) modified = true;
        else if (state == 1) break;
        else if (state == 2) continue;
        else                 return;
    }

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemPopEditElementsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Edit Elements", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    bool modified = false;
    for (setUIntIt it=m_elemSelection.begin(); it!=m_elemSelection.end(); it++){
        // open Edit Element window
        uInt state = 0;
        uInt elemID = *it;
        DEditElement* editElement = new DEditElement(0, m_pMesh, elemID, state);
        editElement->ShowModal();

        // check state value
        if      (state == 0) modified = true;
        else if (state == 1) break;
        else if (state == 2) continue;
        else                 return;
    }

    // store changed data for redo option and refresh
    processChange(modified, undoInfo);
}

void ApameGUIFrame::OnMenuItemPopDeleteNodesSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Delete Nodes", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // store selected nodes to vector
    vecUInt nodeIDs(m_nodeSelection.size());
    uInt nodeIndex = 0;
    for (setUIntIt it=m_nodeSelection.begin(); it!=m_nodeSelection.end(); it++)
        nodeIDs[nodeIndex++] = *it;

    // delete them
    m_pMesh->deleteNodesByID(nodeIDs);

    // clear node selection map
    m_nodeSelection.clear();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemPopDeleteElementsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Delete Elements", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // store selected elements to vector
    vecUInt elemIDs(m_elemSelection.size());
    uInt elemIndex = 0;
    for (setUIntIt it=m_elemSelection.begin(); it!=m_elemSelection.end(); it++)
        elemIDs[elemIndex++] = *it;

    // delete them
    m_pMesh->deleteElemsByID(elemIDs);

    // clear element selection map
    m_elemSelection.clear();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemPopReverseElementsSelected(wxCommandEvent& event)
{
    // store current data for undo option
    undoRedoStruct undoInfo;
    storeUndoData("Reverse Element Normal", undoInfo, m_pMesh, m_pProjectData, m_pResults);

    // reverse them
    m_pMesh->reverseNormal(m_elemSelection);

    // clear element selection map
    m_elemSelection.clear();

    // store changed data for redo option and refresh
    processChange(true, undoInfo);
}

void ApameGUIFrame::OnMenuItemSelElemSelected(wxCommandEvent& event)
{
    m_p3DViewer->m_selectionMode = 0;
}

void ApameGUIFrame::OnMenuItemSelNodeSelected(wxCommandEvent& event)
{
    m_p3DViewer->m_selectionMode = 1;
}

void ApameGUIFrame::OnGLCanvasLeftMouse(wxMouseEvent& event)
{
    m_p3DViewer->onLeftMouseButton(event, m_elemSelection, m_nodeSelection);
    m_p3DViewer->updateColor(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnGLCanvasRightMouse(wxMouseEvent& event)
{
    // update 3DViewer pop-up menu
    if (m_nodeSelection.empty() && m_elemSelection.empty())
        ViewerPopUpMenu.Enable(ID_MENUITEM10, false);
    else
        ViewerPopUpMenu.Enable(ID_MENUITEM10, true);

    if (!m_nodeSelection.empty()){
        // in case nodes are selected
        ViewerPopUpMenu.Enable(ID_MENUITEM11, true); // nodes menu
        ViewerPopUpMenu.Enable(ID_MENUITEM14, true); // clear
        ViewerPopUpMenu.Enable(ID_MENUITEM15, true); // edit
        ViewerPopUpMenu.Enable(ID_MENUITEM16, true); // delete
    }
    else{
        // no nodes are selected
        ViewerPopUpMenu.Enable(ID_MENUITEM11, false); // nodes menu
        ViewerPopUpMenu.Enable(ID_MENUITEM14, false); // clear
        ViewerPopUpMenu.Enable(ID_MENUITEM15, false); // edit
        ViewerPopUpMenu.Enable(ID_MENUITEM16, false); // delete
    }

    if (!m_elemSelection.empty()){
        // in case elements are selected
        ViewerPopUpMenu.Enable(ID_MENUITEM13, true); // elements menu
        ViewerPopUpMenu.Enable(ID_MENUITEM17, true); // clear
        ViewerPopUpMenu.Enable(ID_MENUITEM18, true); // edit
        ViewerPopUpMenu.Enable(ID_MENUITEM19, true); // reverse normal
        ViewerPopUpMenu.Enable(ID_MENUITEM20, true); // delete
    }
    else{
        // no elements are selected
        ViewerPopUpMenu.Enable(ID_MENUITEM13, false); // elements menu
        ViewerPopUpMenu.Enable(ID_MENUITEM17, false); // clear
        ViewerPopUpMenu.Enable(ID_MENUITEM18, false); // edit
        ViewerPopUpMenu.Enable(ID_MENUITEM19, false); // reverse normal
        ViewerPopUpMenu.Enable(ID_MENUITEM20, false); // delete
    }

    // check/uncheck element selection mode
    MenuItemSelElem->Check(m_p3DViewer->m_selectionMode==0);

    // check/uncheck node selection mode
    MenuItemSelNode->Check(m_p3DViewer->m_selectionMode==1);

    // open 3DViewer pop-up menu
    ViewerPopUpMenu.UpdateUI();
    this->PopupMenu(&ViewerPopUpMenu);
}

void ApameGUIFrame::OnGLCanvasMiddleUp(wxMouseEvent& event)
{
    m_p3DViewer->onMouseMiddleUp(event, m_pMesh);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnGLCanvasMiddleDown(wxMouseEvent& event)
{
    m_p3DViewer->onMouseMiddleDown(event);
}

void ApameGUIFrame::OnGLCanvasMouseWheel(wxMouseEvent& event)
{
    m_p3DViewer->onMouseWheel(event);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnGLCanvasMouseMove(wxMouseEvent& event)
{
    m_p3DViewer->onMouseMove(event, m_pProjectData);
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnResize(wxSizeEvent& event)
{
    event.Skip();

    // do stuff only if 3D viewer is shown
    if (!m_p3DViewer->m_viewerInitialized)
        return;

    // get size of 3D view
    wxSize sz(GetClientSize());

    // resize 3D Viewer
    glViewport(0, 0, sz.x, sz.y);

    // refresh 3D Viewer
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

void ApameGUIFrame::OnPaint(wxPaintEvent& WXUNUSED(event))
{
    if (m_p3DViewer->m_viewerInitialized)
        m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);
}

//-----------------------------------------------------------------------/
// refresh GUI; menu, toolbar, etc.
//-----------------------------------------------------------------------/
void ApameGUIFrame::refreshGUI()
{
    // update title
    string sTitle = m_pProjectData->projectName+" - ApameGUI";
    if      ( m_modified && *sTitle.begin()!='*') sTitle.insert(0, "*");
    else if (!m_modified && *sTitle.begin()=='*') sTitle.erase(0, 1);
    SetTitle(str2Wxs(sTitle));

    // modified flag dependant items
    if (m_modified){
        MenuItemSave->Enable(true);
        ToolBarItemSave->Enable(true);
    }
    else{
        MenuItemSave->Enable(false);
        ToolBarItemSave->Enable(false);
    }

    // display mesh information
    wxString triaMsg = "Trias: ";
    wxString quadMsg = "  Quads: ";
    wxString wakeMsg = "  Wakes: ";
    wxString nodeMsg = "    Nodes: ";
    wxString triaNum = wxString::Format("%i", m_pMesh->getNumBodyTria()+m_pMesh->getNumDummTria());
    wxString quadNum = wxString::Format("%i", m_pMesh->getNumBodyQuad()+m_pMesh->getNumDummQuad());
    wxString wakeNum = wxString::Format("%i", m_pMesh->getNumWakeQuad()+m_pMesh->getNumWakeTria());
    wxString nodeNum = wxString::Format("%i", m_pMesh->getNumNode());
    StatusBar1->PushStatusText(triaMsg+triaNum+quadMsg+quadNum+wakeMsg+wakeNum+nodeMsg+nodeNum, 1);

    // extract data sizes
    uInt numBody = m_pMesh->getNumBodyQuad()+m_pMesh->getNumBodyTria();
    uInt numDumm = m_pMesh->getNumDummQuad()+m_pMesh->getNumDummTria();
    uInt numWake = m_pMesh->getNumWakeQuad()+m_pMesh->getNumWakeTria();
    uInt numElem = numBody+numDumm+numWake;

    // body element existence dependent menus
    if (numBody){
        MenuItemNeighbors->Enable(true);
        MenuItemDSeparateNeighbors->Enable(true);
        MenuItemDeleteNeighbors->Enable(true);
    }
    else{
        MenuItemNeighbors->Enable(false);
        MenuItemDSeparateNeighbors->Enable(false);
        MenuItemDeleteNeighbors->Enable(false);
    }

    // body and dummy element existence dependent menus
    if (numBody+numDumm){
        MenuItemVTKExport->Enable(true);
        MenuItemExportAbaqus->Enable(true);
        MenuItemExportNastran->Enable(true);
        MenuItemRun->Enable(true);
        ToolBarItemRun->Enable(true);
        MenuItemWake->Enable(true);
    }
    else{
        MenuItemVTKExport->Enable(false);
        MenuItemExportAbaqus->Enable(false);
        MenuItemExportNastran->Enable(false);
        MenuItemRun->Enable(false);
        ToolBarItemRun->Enable(false);
        MenuItemWake->Enable(false);
    }

    // wake existence dependent menus
    if (numWake)
        MenuItemEditWakes->Enable(true);
    else
        MenuItemEditWakes->Enable(false);

    // element existence dependent menus
    if (numElem){
        MenuItemScale->Enable(true);
        MenuItemTranslate->Enable(true);
        MenuItemRotate->Enable(true);
        MenuItemMirror->Enable(true);
        MenuItemChangeElemType->Enable(true);
        MenuItemSelectElems->Enable(true);
        MenuItemCalcSurf->Enable(true);
        MenuItemDeleteElements->Enable(true);
    }
    else{
        MenuItemScale->Enable(false);
        MenuItemTranslate->Enable(false);
        MenuItemRotate->Enable(false);
        MenuItemMirror->Enable(false);
        MenuItemChangeElemType->Enable(false);
        MenuItemSelectElems->Enable(false);
        MenuItemCalcSurf->Enable(false);
        MenuItemDeleteElements->Enable(false);
    }

    // more than two elements dependent menus
    if (numElem > 1)
        MenuItemElemDist->Enable(true);
    else
        MenuItemElemDist->Enable(false);

    // undo existence dependent menus
    if (m_undoList.empty()){
        MenuItemUndo->Enable(false);
        ToolBarItemUndo->Enable(false);
        ToolBarItemUndo->SetShortHelp("Undo Command");
    }
    else{
        MenuItemUndo->Enable(true);
        ToolBarItemUndo->Enable(true);
        ToolBarItemUndo->SetShortHelp(str2Wxs("Undo '"+m_undoList.front().command+"' Command"));
    }

    // redo existence dependent menus
    if (m_redoList.empty()){
        MenuItemRedo->Enable(false);
        ToolBarItemRedo->Enable(false);
        ToolBarItemRedo->SetShortHelp("Redo Command");
    }
    else{
        MenuItemRedo->Enable(true);
        ToolBarItemRedo->Enable(true);
        ToolBarItemRedo->SetShortHelp(str2Wxs("Redo '"+m_redoList.front().command+"' Command"));
    }

    // node existence dependent menus
    if (m_pMesh->getNumNode()){
        MenuItemSelectNodes->Enable(true);
        MenuItemDeleteNodes->Enable(true);
        MenuItemDeleteMesh->Enable(true);
    }
    else{
        MenuItemSelectNodes->Enable(false);
        MenuItemDeleteNodes->Enable(false);
        MenuItemDeleteMesh->Enable(false);
    }

    // more then one node existence dependent menus
    if (m_pMesh->getNumNode()){
        MenuItemExtrudeLine->Enable(true);
        MenuItemMergeNodes->Enable(true);
        MenuItemNodeDist->Enable(true);
    }
    else{
        MenuItemExtrudeLine->Enable(false);
        MenuItemMergeNodes->Enable(false);
        MenuItemNodeDist->Enable(false);
    }

    // enable checked menu items
    if (m_pProjectData->displayMode == 0)  MenuItemWireframe->Check(true);
    else                                   MenuItemWireframe->Check(false);
    if (m_pProjectData->displayMode == 1)  MenuItemSolid->Check(true);
    else                                   MenuItemSolid->Check(false);
    if (m_pProjectData->displayMode == 2)  MenuItemNormCheck->Check(true);
    else                                   MenuItemNormCheck->Check(false);
    if (m_pProjectData->displayMode == 3)  MenuItemNeighCheck->Check(true);
    else                                   MenuItemNeighCheck->Check(false);
    if (m_pProjectData->showLights == 1)   MenuItemShowLights->Check(true);
    else                                   MenuItemShowLights->Check(false);
    if (m_pProjectData->showEdges == 1)    MenuItemShowEdges->Check(true);
    else                                   MenuItemShowEdges->Check(false);
    if (m_pProjectData->showWake == 1)     MenuItemShowWake->Check(true);
    else                                   MenuItemShowWake->Check(false);
    if (m_pProjectData->showNodes == 1)    MenuItemShowNodes->Check(true);
    else                                   MenuItemShowNodes->Check(false);
    if (m_pProjectData->showCoordSys == 1) MenuItemShowCoord->Check(true);
    else                                   MenuItemShowCoord->Check(false);
    if (m_pProjectData->showLegend == 1)   MenuItemShowLegend->Check(true);
    else                                   MenuItemShowLegend->Check(false);
    if (m_pProjectData->showNodeIDs == 1)  MenuItemShowNodeID->Check(true);
    else                                   MenuItemShowNodeID->Check(false);
    if (m_pProjectData->showElemIDs == 1)  MenuItemShowElemID->Check(true);
    else                                   MenuItemShowElemID->Check(false);

    ToolBar1->Realize();
}

//-----------------------------------------------------------------------/
// initialize ApameGUI frame
//-----------------------------------------------------------------------/
void ApameGUIFrame::initialize()
{
    // resize ApameGUI window
    SetSize(m_pGUIData->width, m_pGUIData->height);
#ifdef WIN32
    if (m_pGUIData->maximized) Maximize(true);
#endif

    // initialize 3D Viewer
    m_p3DViewer->initialize();

    // do complete refresh
    completeRefresh();

    // refit 3D Viewer
    m_p3DViewer->refit(m_pMesh);
}

//-----------------------------------------------------------------------/
// store changed data for redo option and do complete refresh
//-----------------------------------------------------------------------/
void ApameGUIFrame::processChange(bool modified, undoRedoStruct& undoInfo)
{
    // exit if no change has been made
    if (!modified)
        return;

    m_modified = true;

    // store changed data for redo option
    storeRedoData(undoInfo, m_undoList, m_pMesh, m_pProjectData, m_pResults);

    // do complete refresh
    completeRefresh();
}

//-----------------------------------------------------------------------/
// performs complete refresh of 3D Viewer and GUI
//-----------------------------------------------------------------------/
void ApameGUIFrame::completeRefresh()
{
    // update lighting in 3D Viewer
    m_p3DViewer->updateLighting(m_pProjectData);

    // update 3D Viewer data for drawing
    m_p3DViewer->updateMeshData(m_pMesh, m_pProjectData);

    // update colors with results
    m_p3DViewer->updateResultColors(m_pMesh, m_pProjectData, m_pResults);

    // update colors
    m_p3DViewer->updateColor(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);

    // refresh 3D Viewer
    m_p3DViewer->refresh3DViewer(m_pMesh, m_pProjectData, m_elemSelection, m_nodeSelection);

    // refresh GUI
    refreshGUI();
}
