#include "CResults.h"

CResults::CResults()
{
    numNode = 0;
    numElem = 0;
    numBodyElem = 0;
    airspeed = 0.0;
    density = 0.0;
    pressure = 0.0;
    mach = 0.0;
    caseNumber = 0;
    wingspan = 0.0;
    mac = 0.0;
    surface = 0.0;
    method = 0;
    error = 0.0;
    coplAng = 0.0;
    collDist = 0.0;
    farField = 0.0;
    collCalc = 0;
    velOrder = 0;
}

//-----------------------------------------------------------------------/
// get field data and element IDs for given data and case name
//-----------------------------------------------------------------------/
int CResults::getFieldData(
        const string& dataName,
        const string& caseName,
        vecDbl& fieldData,
        vecUInt& elemIDs)
{
    // search field data for given data name
    for (uInt dataIndex=0; dataIndex<surfDatas.size(); dataIndex++){
        if (surfDatas[dataIndex].dataName == dataName){
            // search for case title
            for (uInt caseIndex=0; caseIndex<surfDatas[dataIndex].caseTitles.size(); caseIndex++){
                if (surfDatas[dataIndex].caseTitles[caseIndex] == caseName){
                    fieldData = surfDatas[dataIndex].data[caseIndex];
                    elemIDs = surfDatas[dataIndex].elemIDs;
                    return 0;
                }
            }
        }

    }

    return -1;
}
