#include "wx_pch.h"
#include "DChangeElemType.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DChangeElemType)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DChangeElemType)
//*)

//(*IdInit(DChangeElemType)
const long DChangeElemType::ID_RADIOBOX1 = wxNewId();
const long DChangeElemType::ID_BUTTON3 = wxNewId();
const long DChangeElemType::ID_BUTTON1 = wxNewId();
const long DChangeElemType::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DChangeElemType,wxDialog)
	//(*EventTable(DChangeElemType)
	//*)
END_EVENT_TABLE()

DChangeElemType::DChangeElemType(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        setUInt& elemSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh), m_elemSelection(elemSelection)
{
	//(*Initialize(DChangeElemType)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Change Element Type"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	wxString __wxRadioBoxChoices_1[3] =
	{
		_("body - types 1 and 2"),
		_("dummy - types 20 and 21"),
		_("wake - types 10 and 11")
	};
	TypeRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Convert to element type"), wxDefaultPosition, wxDefaultSize, 3, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	TypeRadioBox->SetSelection(0);
	FlexGridSizer1->Add(TypeRadioBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON3, _("Select Elements"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer1->Add(SelectButton, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(0, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DChangeElemType::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DChangeElemType::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DChangeElemType::OnCancelButtonClick);
	//*)
}

DChangeElemType::~DChangeElemType()
{
	//(*Destroy(DChangeElemType)
	//*)
}

void DChangeElemType::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DChangeElemType::OnSelectButtonClick(wxCommandEvent& event)
{
    DElemSelection* elemSelection = new DElemSelection(0, m_pMesh, m_elemSelection);
    elemSelection->ShowModal();
}

void DChangeElemType::OnOKButtonClick(wxCommandEvent& event)
{
    m_modified = true;

    // get requested type
    string type;
    if      (TypeRadioBox->GetStringSelection() == _("body - types 1 and 2"   )) type = "body";
    else if (TypeRadioBox->GetStringSelection() == _("wake - types 10 and 11" )) type = "wake";
    else                                                                         type = "dummy";

    // convert elements from selection
    for (setUIntIt it=m_elemSelection.begin(); it!=m_elemSelection.end(); it++)
        m_pMesh->convertElemType(*it, type);

    this->Destroy();
}
