#include "wx_pch.h"
#include "DConfirmation.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DConfirmation)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DConfirmation)
//*)

//(*IdInit(DConfirmation)
const long DConfirmation::ID_STATICTEXT1 = wxNewId();
const long DConfirmation::ID_BUTTON1 = wxNewId();
const long DConfirmation::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DConfirmation,wxDialog)
	//(*EventTable(DConfirmation)
	//*)
END_EVENT_TABLE()

DConfirmation::DConfirmation(
        wxWindow* parent,
        wxString& message,
        bool& yesOrNo,
        wxWindowID id) : m_message(message), m_yesOrNo(yesOrNo)
{
	//(*Initialize(DConfirmation)
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Query"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	FlexGridSizer1 = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer1->AddGrowableCol(0);
	FlexGridSizer1->AddGrowableRow(0);
	messagePrint = new wxStaticText(this, ID_STATICTEXT1, _("Are you sure\?"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer1->Add(messagePrint, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	YesButton = new wxButton(this, ID_BUTTON1, _("Yes"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer2->Add(YesButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	NoButton = new wxButton(this, ID_BUTTON2, _("No"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer2->Add(NoButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);
	Center();

	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DConfirmation::OnYesButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DConfirmation::OnNoButtonClick);
	//*)

	messagePrint->SetLabel(m_message);
	FlexGridSizer1->Fit(this);
}

DConfirmation::~DConfirmation()
{
	//(*Destroy(DConfirmation)
	//*)
}

void DConfirmation::OnYesButtonClick(wxCommandEvent& event)
{
    m_yesOrNo = true;
    this->Destroy();
}

void DConfirmation::OnNoButtonClick(wxCommandEvent& event)
{
    m_yesOrNo = false;
    this->Destroy();
}

bool OKToContinue(const string& message)
{
    bool OKToContinue = false;
    wxString wxMessage = str2Wxs(message);
    DConfirmation* yesOrNo = new DConfirmation(0, wxMessage, OKToContinue);
    yesOrNo->ShowModal();
    return OKToContinue;
}
