#include "wx_pch.h"
#include "DCreateElement.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DCreateElement)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DCreateElement)
//*)

//(*IdInit(DCreateElement)
const long DCreateElement::ID_RADIOBOX4 = wxNewId();
const long DCreateElement::ID_RADIOBOX5 = wxNewId();
const long DCreateElement::ID_GRID1 = wxNewId();
const long DCreateElement::ID_BUTTON1 = wxNewId();
const long DCreateElement::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DCreateElement,wxDialog)
	//(*EventTable(DCreateElement)
	//*)
END_EVENT_TABLE()

DCreateElement::DCreateElement(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        wxWindowID id) : m_modified(modified), m_pMesh(pMesh)
{
	//(*Initialize(DCreateElement)
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, wxID_ANY, _("Create Element"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(4, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	wxString __wxRadioBoxChoices_1[2] =
	{
		_("Quad - Type 1"),
		_("Triangle - Type 2")
	};
	NumNodeRadioBox = new wxRadioBox(this, ID_RADIOBOX4, _("Choose Type"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX4"));
	NumNodeRadioBox->SetSelection(0);
	FlexGridSizer2->Add(NumNodeRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	wxString __wxRadioBoxChoices_2[2] =
	{
		_("Define Coordinates"),
		_("Enter Node ID\'s")
	};
	MethodRadioBox = new wxRadioBox(this, ID_RADIOBOX5, _("Choose Method"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_2, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX5"));
	MethodRadioBox->SetSelection(0);
	FlexGridSizer2->Add(MethodRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	NodeGrid = new wxGrid(this, ID_GRID1, wxDefaultPosition, wxDefaultSize, 0, _T("ID_GRID1"));
	NodeGrid->CreateGrid(3,4);
	NodeGrid->EnableEditing(true);
	NodeGrid->EnableGridLines(true);
	NodeGrid->SetColLabelSize(20);
	NodeGrid->SetRowLabelSize(60);
	NodeGrid->SetDefaultRowSize(20, true);
	NodeGrid->SetDefaultColSize(80, true);
	NodeGrid->SetColLabelValue(0, _("Node 1"));
	NodeGrid->SetColLabelValue(1, _("Node 2"));
	NodeGrid->SetColLabelValue(2, _("Node 3"));
	NodeGrid->SetColLabelValue(3, _("Node 4"));
	NodeGrid->SetRowLabelValue(0, _("X"));
	NodeGrid->SetRowLabelValue(1, _("Y"));
	NodeGrid->SetRowLabelValue(2, _("Z"));
	NodeGrid->SetCellValue(0, 0, _("0"));
	NodeGrid->SetCellValue(0, 1, _("0"));
	NodeGrid->SetCellValue(0, 2, _("0"));
	NodeGrid->SetCellValue(0, 3, _("0"));
	NodeGrid->SetCellValue(1, 0, _("0"));
	NodeGrid->SetCellValue(1, 1, _("0"));
	NodeGrid->SetCellValue(1, 2, _("0"));
	NodeGrid->SetCellValue(1, 3, _("0"));
	NodeGrid->SetCellValue(2, 0, _("0"));
	NodeGrid->SetCellValue(2, 1, _("0"));
	NodeGrid->SetCellValue(2, 2, _("0"));
	NodeGrid->SetCellValue(2, 3, _("0"));
	NodeGrid->SetDefaultCellFont( NodeGrid->GetFont() );
	NodeGrid->SetDefaultCellTextColour( NodeGrid->GetForegroundColour() );
	FlexGridSizer1->Add(NodeGrid, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_RADIOBOX4,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DCreateElement::OnTypeMethodRadioBoxSelect);
	Connect(ID_RADIOBOX5,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DCreateElement::OnTypeMethodRadioBoxSelect);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DCreateElement::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DCreateElement::OnCancelButtonClick);
	//*)
}

DCreateElement::~DCreateElement()
{
	//(*Destroy(DCreateElement)
	//*)
}

void DCreateElement::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DCreateElement::OnTypeMethodRadioBoxSelect(wxCommandEvent& event)
{
    // enable all by default
    for (uInt i=0; i<3; i++){
        for (uInt j=0; j<4; j++){
            NodeGrid->SetReadOnly(i, j, false);
            NodeGrid->SetCellBackgroundColour(i, j, *wxWHITE);
        }
    }
    NodeGrid->SetRowLabelValue(0, "X");
    NodeGrid->SetRowLabelValue(1, "Y");
    NodeGrid->SetRowLabelValue(2, "Z");

    // disable fourth column for triangular element
    if (NumNodeRadioBox->GetStringSelection() == "Triangle - Type 2"){
        for (uInt i=0; i<3; i++){
            NodeGrid->SetReadOnly(i, 3, true);
            NodeGrid->SetCellBackgroundColour(i, 3, *wxLIGHT_GREY);
        }
    }

    // disable second and third row for definition by node ID
    if (MethodRadioBox->GetStringSelection() == "Enter Node ID's"){
        for (uInt i=0; i<4; i++){
            NodeGrid->SetReadOnly(1, i, true);
            NodeGrid->SetReadOnly(2, i, true);
            NodeGrid->SetCellBackgroundColour(1, i, *wxLIGHT_GREY);
            NodeGrid->SetCellBackgroundColour(2, i, *wxLIGHT_GREY);
        }
        NodeGrid->SetRowLabelValue(0, "Node ID");
        NodeGrid->SetRowLabelValue(1, "N/A");
        NodeGrid->SetRowLabelValue(2, "N/A");
    }

    NodeGrid->ForceRefresh();
}

void DCreateElement::OnOKButtonClick(wxCommandEvent& event)
{
    // get number of nodes
    uInt nodeNum = 0;
    uInt type = 0;
    if (NumNodeRadioBox->GetStringSelection() == "Quad - Type 1"){
        nodeNum = 4;
        type = 1;
    }
    else{
        nodeNum = 3;
        type = 2;
    }

    if (MethodRadioBox->GetStringSelection() == "Define Coordinates"){
        // read vector of node coordinates from table
        vecVecDbl coordinates(nodeNum);
        for (uInt nodeIndex=0; nodeIndex<nodeNum; nodeIndex++){
            coordinates[nodeIndex].resize(3);
            for (uInt j=0; j<3; j++){
                if (!NodeGrid->GetCellValue(j, nodeIndex).ToDouble(&coordinates[nodeIndex][j])){
                    showErrorMessage("Incorrect coordinates defined");
                    return;
                }
            }
        }

        // add element to mesh
        if (m_pMesh->insertElemWithNodeCoords(coordinates, type) == -2){
            showErrorMessage("Zero surface element");
            return;
        }

        m_modified = true;

        this->Destroy();
    }
    else{
        // read node IDs from table
        vecUInt nodeIDs(nodeNum);
        for (uInt nodeIndex=0; nodeIndex<nodeNum; nodeIndex++){
            long temp;
            if (!NodeGrid->GetCellValue(0, nodeIndex).ToLong(&temp) || temp<=0){
                showErrorMessage("Incorrect value in table");
                return;
            }
            nodeIDs[nodeIndex] = uInt(temp);
        }

        // add element to mesh
        int elemID = m_pMesh->insertElemWithNodeIDs(type, nodeIDs);

        // process return code
        if      (elemID == -2){ showErrorMessage("Zero surface element"      ); return; }
        else if (elemID == -4){ showErrorMessage("Duplicate node ID(s) given"); return; }
        else if (elemID == -5){ showErrorMessage("Node(s) does not exist"    ); return; }
        else if (elemID <=  0){ showErrorMessage("Unknown error"             ); return; }

        m_modified = true;

        this->Destroy();
    }
}
