#include "wx_pch.h"
#include "DCreateNode.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DCreateNode)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DCreateNode)
//*)

//(*IdInit(DCreateNode)
const long DCreateNode::ID_CHECKBOX1 = wxNewId();
const long DCreateNode::ID_TEXTCTRL4 = wxNewId();
const long DCreateNode::ID_STATICTEXT1 = wxNewId();
const long DCreateNode::ID_STATICTEXT2 = wxNewId();
const long DCreateNode::ID_STATICTEXT3 = wxNewId();
const long DCreateNode::ID_TEXTCTRL1 = wxNewId();
const long DCreateNode::ID_TEXTCTRL2 = wxNewId();
const long DCreateNode::ID_TEXTCTRL3 = wxNewId();
const long DCreateNode::ID_BUTTON1 = wxNewId();
const long DCreateNode::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DCreateNode,wxDialog)
	//(*EventTable(DCreateNode)
	//*)
END_EVENT_TABLE()

DCreateNode::DCreateNode(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh)
{
	//(*Initialize(DCreateNode)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Enter Node Coordinates"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	predefinedNodeID = new wxCheckBox(this, ID_CHECKBOX1, _("With predefined node ID"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	predefinedNodeID->SetValue(false);
	FlexGridSizer4->Add(predefinedNodeID, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	nodeID = new wxTextCtrl(this, ID_TEXTCTRL4, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
	FlexGridSizer4->Add(nodeID, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(2, 3, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("X"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer2->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Y"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer2->Add(StaticText2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Z"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer2->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	xCoord = new wxTextCtrl(this, ID_TEXTCTRL1, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(xCoord, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	yCoord = new wxTextCtrl(this, ID_TEXTCTRL2, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer2->Add(yCoord, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	zCoord = new wxTextCtrl(this, ID_TEXTCTRL3, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer2->Add(zCoord, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_CHECKBOX1,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DCreateNode::OnpredefinedNodeIDClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DCreateNode::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DCreateNode::OnCancelButtonClick);
	//*)
}

DCreateNode::~DCreateNode()
{
	//(*Destroy(DCreateNode)
	//*)
}

void DCreateNode::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DCreateNode::OnOKButtonClick(wxCommandEvent& event)
{
    // extract node ID
    long ID;
    if (predefinedNodeID->IsChecked()){
        wxString number = nodeID->GetValue();
        if(!number.ToLong(&ID) || ID<=0){
            showErrorMessage("Incorrect value for node ID entered");
            return;
        }
    }

    // extract coordinates
    double coordinates[3];
    wxString numberX = xCoord->GetValue();
    wxString numberY = yCoord->GetValue();
    wxString numberZ = zCoord->GetValue();
    if (!numberX.ToDouble(&coordinates[0]) ||
        !numberY.ToDouble(&coordinates[1]) ||
        !numberZ.ToDouble(&coordinates[2]) ){
        showErrorMessage("Incorrect coordinates entered");
        return;
    }

    // add node to mesh
    if (predefinedNodeID->IsChecked()){
        // insert node with defined node ID
        if (m_pMesh->insertNodeWithIDCoords(ID, coordinates) == -1){
            showErrorMessage("Given node ID already exists");
            return;
        }
    }
    else
        // insert node without node ID
        m_pMesh->insertNodeWithCoords(coordinates);

    m_modified = true;
    
    this->Destroy();
}

void DCreateNode::OnpredefinedNodeIDClick(wxCommandEvent& event)
{
    if (predefinedNodeID->IsChecked()) nodeID->Enable();
    else                               nodeID->Disable();
}
