#include "wx_pch.h"
#include "DDisplayResults.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DDisplayResults)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DDisplayResults)
//*)

//(*IdInit(DDisplayResults)
const long DDisplayResults::ID_CHECKBOX1 = wxNewId();
const long DDisplayResults::ID_STATICTEXT1 = wxNewId();
const long DDisplayResults::ID_CHOICE3 = wxNewId();
const long DDisplayResults::ID_STATICTEXT2 = wxNewId();
const long DDisplayResults::ID_CHOICE2 = wxNewId();
const long DDisplayResults::ID_RADIOBOX1 = wxNewId();
const long DDisplayResults::ID_RADIOBOX2 = wxNewId();
const long DDisplayResults::ID_STATICTEXT3 = wxNewId();
const long DDisplayResults::ID_TEXTCTRL1 = wxNewId();
const long DDisplayResults::ID_STATICTEXT4 = wxNewId();
const long DDisplayResults::ID_TEXTCTRL2 = wxNewId();
const long DDisplayResults::ID_BUTTON3 = wxNewId();
const long DDisplayResults::ID_BUTTON4 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DDisplayResults,wxDialog)
	//(*EventTable(DDisplayResults)
	//*)
END_EVENT_TABLE()

DDisplayResults::DDisplayResults(
        wxWindow* parent,
        bool& modified,
        C3DViewer* p3DViewer,
        CMesh* pMesh,
        CProjectData* pProjectData,
        CResults* pResults,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_p3DViewer(p3DViewer), m_pMesh(pMesh), m_pProjectData(pProjectData), m_pResults(pResults)
{
	//(*Initialize(DDisplayResults)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer8;
	wxFlexGridSizer* FlexGridSizer12;
	wxFlexGridSizer* FlexGridSizer1;
	wxFlexGridSizer* FlexGridSizer11;

	Create(parent, id, _("Display Results"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(5, 1, 0, 0);
	PlotResultsCheckBox = new wxCheckBox(this, ID_CHECKBOX1, _("Show Surface Plot"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	PlotResultsCheckBox->SetValue(false);
	FlexGridSizer1->Add(PlotResultsCheckBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer8 = new wxFlexGridSizer(2, 2, 0, 0);
	FlexGridSizer8->AddGrowableCol(1);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Select Result Field"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer8->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ResultChoice = new wxChoice(this, ID_CHOICE3, wxDefaultPosition, wxSize(300,-1), 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE3"));
	FlexGridSizer8->Add(ResultChoice, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Select Case"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer8->Add(StaticText2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	CaseChoice = new wxChoice(this, ID_CHOICE2, wxDefaultPosition, wxSize(300,-1), 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE2"));
	FlexGridSizer8->Add(CaseChoice, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer8, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	wxString __wxRadioBoxChoices_1[2] =
	{
		_("Elemental"),
		_("Nodal")
	};
	PlotTypeRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Plot Type"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	PlotTypeRadioBox->SetSelection(0);
	FlexGridSizer1->Add(PlotTypeRadioBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer11 = new wxFlexGridSizer(1, 2, 0, 0);
	wxString __wxRadioBoxChoices_2[2] =
	{
		_("Automatic"),
		_("Manual")
	};
	LegendRadioBox = new wxRadioBox(this, ID_RADIOBOX2, _("Legend Range"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_2, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX2"));
	FlexGridSizer11->Add(LegendRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(2, 2, 0, 0);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Max"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer4->Add(StaticText3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	TextCtrlMax = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	TextCtrlMax->Disable();
	FlexGridSizer4->Add(TextCtrlMax, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Min"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer4->Add(StaticText4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	TextCtrlMin = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	TextCtrlMin->Disable();
	FlexGridSizer4->Add(TextCtrlMin, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer11->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer11, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer12 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON3, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer12->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON4, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
	FlexGridSizer12->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer12, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_CHOICE3,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&DDisplayResults::OnResultChoiceSelect);
	Connect(ID_CHOICE2,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&DDisplayResults::OnCaseChoiceSelect);
	Connect(ID_RADIOBOX2,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DDisplayResults::OnLegendRadioBoxSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DDisplayResults::OnOKButtonClick);
	Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DDisplayResults::OnCancelButtonClick);
	//*)

    // skip loading constructor stuff if null pointer
    if (!m_pResults)
        return;

    // check/uncheck surface results
    if (m_pProjectData->surfResultsShown) PlotResultsCheckBox->SetValue(true);
    else                                  PlotResultsCheckBox->SetValue(false);

    // append data fields
    for (uInt i=0; i<m_pResults->surfDatas.size(); i++)
        ResultChoice->Append(str2Wxs(m_pResults->surfDatas[i].dataName));

    // set data field (first one if no previously selected data)
    if (m_pProjectData->selectedData.empty())
        ResultChoice->SetSelection(0);
    else
        ResultChoice->SetSelection(ResultChoice->FindString(str2Wxs(m_pProjectData->selectedData)));

    // update case list box with case titles from current results list selection
    updateCases();

    // select case (first one if no previously selected data)
    if (m_pProjectData->selectedCase.empty())
        CaseChoice->SetSelection(0);
    else
        CaseChoice->SetSelection(CaseChoice->FindString(str2Wxs(m_pProjectData->selectedCase)));

    // select plot type
    if (m_pProjectData->plotType == "elemental") PlotTypeRadioBox->SetSelection(0);
    else                                         PlotTypeRadioBox->SetSelection(1);

    // select limit type
    if (m_pProjectData->limitType == "automatic"){
        LegendRadioBox->SetSelection(0);
        // disable manual input
        TextCtrlMin->Disable();
        TextCtrlMax->Disable();
    }
    else{
        LegendRadioBox->SetSelection(1);
        // enable manual input
        TextCtrlMin->Enable();
        TextCtrlMax->Enable();
    }

    // calculate fieldData
    calculateFieldData();

    // set minimum and maximum legend values
    updateMinMax();
}

DDisplayResults::~DDisplayResults()
{
	//(*Destroy(DDisplayResults)
	//*)
}

void DDisplayResults::OnOKButtonClick(wxCommandEvent& event)
{
    // just exit if no results exist
    if (!m_pResults)
        this->Destroy();

    m_modified = true;
    
    // check if results plot is checked
    if (PlotResultsCheckBox->IsChecked()) m_pProjectData->surfResultsShown = true;
    else                                  m_pProjectData->surfResultsShown = false;

    // store selected result field
    m_pProjectData->selectedData = wxs2Str(ResultChoice->GetString(ResultChoice->GetSelection()));

    // store selected case
    m_pProjectData->selectedCase = wxs2Str(CaseChoice->GetString(CaseChoice->GetSelection()));

    // store plot type
    if (PlotTypeRadioBox->GetStringSelection() == "Nodal") m_pProjectData->plotType = "nodal";
    else                                                   m_pProjectData->plotType = "elemental";

    // store limit type
    if (LegendRadioBox->GetStringSelection() == "Automatic") m_pProjectData->limitType = "automatic";
    else                                                     m_pProjectData->limitType = "manual";

    // read limit minimum and maximum
    TextCtrlMin->GetValue().ToDouble(&m_pProjectData->minLimit);
    TextCtrlMax->GetValue().ToDouble(&m_pProjectData->maxLimit);

    this->Destroy();
}

void DDisplayResults::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DDisplayResults::OnResultChoiceSelect(wxCommandEvent& event)
{
    // update case list
    updateCases();

    // update like on choice select
    OnCaseChoiceSelect(event);
}

void DDisplayResults::OnCaseChoiceSelect(wxCommandEvent& event)
{
    // calculate fieldData
    calculateFieldData();

    // set minimum and maximum legend values
    updateMinMax();
}

void DDisplayResults::OnLegendRadioBoxSelect(wxCommandEvent& event)
{
    // check for legend limits type
    if (LegendRadioBox->GetStringSelection() == "Automatic"){
        // disable manual input
        TextCtrlMin->Disable();
        TextCtrlMax->Disable();

        // update minimum and maximum values according to fieldData
        updateMinMax();
    }
    else{
        // enable manual input
        TextCtrlMin->Enable();
        TextCtrlMax->Enable();
    }
}

void DDisplayResults::updateMinMax()
{
    if (m_fieldData.empty()){
        TextCtrlMin->SetValue("0.0");
        TextCtrlMax->SetValue("0.0");
    }
    else if (LegendRadioBox->GetStringSelection() == "Automatic"){
        // recalculate using fieldData
        double min = m_fieldData[0];
        double max = m_fieldData[0];
        for (uInt i=0; i<m_fieldData.size(); i++){
            if (m_fieldData[i] < min) min = m_fieldData[i];
            if (m_fieldData[i] > max) max = m_fieldData[i];
        }

        // set data
        TextCtrlMin->SetValue(wxString::Format("%f", min));
        TextCtrlMax->SetValue(wxString::Format("%f", max));
    }
    else{
        // set data from ResultsData
        TextCtrlMin->SetValue(wxString::Format("%f", m_pProjectData->minLimit));
        TextCtrlMax->SetValue(wxString::Format("%f", m_pProjectData->maxLimit));
    }
}

void DDisplayResults::updateCases()
{
    // clear existing cases
    CaseChoice->Clear();
    bool selected = false;
    wxString selectedData = ResultChoice->GetString(ResultChoice->GetSelection());
    // find that data in ResultsData
    for (uInt i=0; i<m_pResults->surfDatas.size(); i++){
        if (selectedData.Cmp(str2Wxs(m_pResults->surfDatas[i].dataName)) == 0){
            // get all case titles from that data field
            for (uInt j=0; j<m_pResults->surfDatas[i].caseTitles.size(); j++){
                CaseChoice->Append(str2Wxs(m_pResults->surfDatas[i].caseTitles[j]));
                // set this case if it corresponds to previously selected case
                if (m_pResults->surfDatas[i].caseTitles[j] == m_pProjectData->selectedCase){
                    CaseChoice->SetSelection(j);
                    selected = true;
                }
            }
            break;
        }
    }
    if (!selected)
        CaseChoice->SetSelection(0);
}

void DDisplayResults::calculateFieldData()
{
    // get selected field name
    wxString selectedField = ResultChoice->GetString(ResultChoice->GetSelection());
    if (selectedField.IsEmpty())
        return;

    // search results for this field name
    uInt fieldIndex = 0;
    bool fieldFound = false;
    for (; fieldIndex<m_pResults->surfDatas.size(); fieldIndex++){
        if (selectedField.Cmp(str2Wxs(m_pResults->surfDatas[fieldIndex].dataName)) == 0){
            fieldFound = true;
            break;
        }
    }
    if (!fieldFound){
        showErrorMessage("Internal error: Inconsistency in field results - CONTACT SUPPORT!");
        return;
    }

    // store field data
    uInt caseIndex = CaseChoice->GetSelection();
    if (caseIndex >= m_pResults->surfDatas[fieldIndex].data.size()){
        showErrorMessage("Internal error: Inconsistency in field result size - CONTACT SUPPORT!");
        return;
    }
    m_fieldData = m_pResults->surfDatas[fieldIndex].data[caseIndex];
    m_elemIDs = m_pResults->surfDatas[fieldIndex].elemIDs;
}
