#include "wx_pch.h"
#include "DEditElement.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DEditElement)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DEditElement)
//*)

//(*IdInit(DEditElement)
const long DEditElement::ID_RADIOBOX1 = wxNewId();
const long DEditElement::ID_STATICTEXT12 = wxNewId();
const long DEditElement::ID_TEXTCTRL11 = wxNewId();
const long DEditElement::ID_STATICTEXT2 = wxNewId();
const long DEditElement::ID_STATICTEXT3 = wxNewId();
const long DEditElement::ID_TEXTCTRL2 = wxNewId();
const long DEditElement::ID_STATICTEXT4 = wxNewId();
const long DEditElement::ID_TEXTCTRL3 = wxNewId();
const long DEditElement::ID_STATICTEXT5 = wxNewId();
const long DEditElement::ID_TEXTCTRL4 = wxNewId();
const long DEditElement::ID_STATICTEXT6 = wxNewId();
const long DEditElement::ID_TEXTCTRL5 = wxNewId();
const long DEditElement::ID_STATICTEXT7 = wxNewId();
const long DEditElement::ID_STATICTEXT8 = wxNewId();
const long DEditElement::ID_TEXTCTRL6 = wxNewId();
const long DEditElement::ID_STATICTEXT9 = wxNewId();
const long DEditElement::ID_TEXTCTRL7 = wxNewId();
const long DEditElement::ID_STATICTEXT10 = wxNewId();
const long DEditElement::ID_TEXTCTRL8 = wxNewId();
const long DEditElement::ID_STATICTEXT11 = wxNewId();
const long DEditElement::ID_TEXTCTRL9 = wxNewId();
const long DEditElement::ID_BUTTON1 = wxNewId();
const long DEditElement::ID_BUTTON2 = wxNewId();
const long DEditElement::ID_BUTTON3 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DEditElement,wxDialog)
	//(*EventTable(DEditElement)
	//*)
END_EVENT_TABLE()

DEditElement::DEditElement(
        wxWindow* parent,
        CMesh* pMesh,
        uInt& elemID,
        uInt& state,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_pMesh(pMesh), m_elemID(elemID), m_state(state)
{
	//(*Initialize(DEditElement)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer7;
	wxFlexGridSizer* FlexGridSizer8;
	wxFlexGridSizer* FlexGridSizer6;
	wxFlexGridSizer* FlexGridSizer1;
	wxFlexGridSizer* FlexGridSizer11;

	Create(parent, id, _("Edit Element"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(5, 1, 0, 0);
	wxString __wxRadioBoxChoices_1[6] =
	{
		_("1 - Body Quadrilateral"),
		_("2 - Body Triangular"),
		_("20 - Dummy Quadrilateral"),
		_("21 - Dummy Triangular"),
		_("10 - Wake Quadrilateral"),
		_("11 - Wake Triangular")
	};
	TypeRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Element Type"), wxDefaultPosition, wxDefaultSize, 6, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	TypeRadioBox->SetSelection(0);
	FlexGridSizer1->Add(TypeRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer11 = new wxFlexGridSizer(1, 2, 0, 0);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT12, _("Element ID"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT12"));
	FlexGridSizer11->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ElemIDBox = new wxTextCtrl(this, ID_TEXTCTRL11, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL11"));
	FlexGridSizer11->Add(ElemIDBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer11, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer5->AddGrowableCol(1);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Constituing Node IDs"), wxDefaultPosition, wxSize(140,-1), 0, _T("ID_STATICTEXT2"));
	FlexGridSizer5->Add(StaticText2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer7 = new wxFlexGridSizer(4, 2, 0, 0);
	tNode1 = new wxStaticText(this, ID_STATICTEXT3, _("Node 1"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT3"));
	FlexGridSizer7->Add(tNode1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Node1Box = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer7->Add(Node1Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	tNode2 = new wxStaticText(this, ID_STATICTEXT4, _("Node 2"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT4"));
	FlexGridSizer7->Add(tNode2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Node2Box = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer7->Add(Node2Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	tNode3 = new wxStaticText(this, ID_STATICTEXT5, _("Node 3"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT5"));
	FlexGridSizer7->Add(tNode3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Node3Box = new wxTextCtrl(this, ID_TEXTCTRL4, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
	FlexGridSizer7->Add(Node3Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	tNode4 = new wxStaticText(this, ID_STATICTEXT6, _("Node 4"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT6"));
	FlexGridSizer7->Add(tNode4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Node4Box = new wxTextCtrl(this, ID_TEXTCTRL5, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
	FlexGridSizer7->Add(Node4Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5->Add(FlexGridSizer7, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6 = new wxFlexGridSizer(1, 2, 0, 0);
	NeighTrailStaticText = new wxStaticText(this, ID_STATICTEXT7, _("Neighboring/Trailing\nElements"), wxDefaultPosition, wxSize(140,-1), 0, _T("ID_STATICTEXT7"));
	FlexGridSizer6->Add(NeighTrailStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer8 = new wxFlexGridSizer(4, 2, 0, 0);
	tElem1 = new wxStaticText(this, ID_STATICTEXT8, _("Element 1"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT8"));
	FlexGridSizer8->Add(tElem1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Elem1Box = new wxTextCtrl(this, ID_TEXTCTRL6, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
	FlexGridSizer8->Add(Elem1Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	tElem2 = new wxStaticText(this, ID_STATICTEXT9, _("Element 2"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT9"));
	FlexGridSizer8->Add(tElem2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Elem2Box = new wxTextCtrl(this, ID_TEXTCTRL7, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL7"));
	FlexGridSizer8->Add(Elem2Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	tElem3 = new wxStaticText(this, ID_STATICTEXT10, _("Element 3"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT10"));
	FlexGridSizer8->Add(tElem3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Elem3Box = new wxTextCtrl(this, ID_TEXTCTRL8, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL8"));
	FlexGridSizer8->Add(Elem3Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	tElem4 = new wxStaticText(this, ID_STATICTEXT11, _("Element 4"), wxDefaultPosition, wxSize(50,-1), 0, _T("ID_STATICTEXT11"));
	FlexGridSizer8->Add(tElem4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Elem4Box = new wxTextCtrl(this, ID_TEXTCTRL9, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL9"));
	FlexGridSizer8->Add(Elem4Box, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6->Add(FlexGridSizer8, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK/Next"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SkipButton = new wxButton(this, ID_BUTTON2, _("Skip"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(SkipButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON3, _("Cancel/Stop"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_RADIOBOX1,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DEditElement::OnTypeRadioBoxSelect);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DEditElement::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DEditElement::OnSkipButtonClick);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DEditElement::OnCancelButtonClick);
	//*)

    // store element ID
	m_newElemID = m_elemID;

    // get element data
    uInt type;
    vecUInt nodeIDs;
    vecUInt neighborTrailIDs;
    if (m_pMesh->getElemData(m_elemID, type, nodeIDs, neighborTrailIDs)) return;

    // fill dialog with element ID
	ElemIDBox->SetValue(wxString::Format("%i", m_elemID));

    // fill dialog with element type
    if      (type == 1 ) TypeRadioBox->SetSelection(0);
    else if (type == 2 ) TypeRadioBox->SetSelection(1);
    else if (type == 20) TypeRadioBox->SetSelection(2);
    else if (type == 21) TypeRadioBox->SetSelection(3);
    else if (type == 10) TypeRadioBox->SetSelection(4);
    else if (type == 11) TypeRadioBox->SetSelection(5);

    // fill dialog with element nodes
    m_nodeBoxes.resize(4);
    m_nodeBoxes[0] = Node1Box;
    m_nodeBoxes[1] = Node2Box;
    m_nodeBoxes[2] = Node3Box;
    m_nodeBoxes[3] = Node4Box;
    uInt boxIndex = 0;
    for (; boxIndex<nodeIDs.size(); boxIndex++)
        m_nodeBoxes[boxIndex]->SetValue(wxString::Format("%i", nodeIDs[boxIndex]));

    // fill dialog with element neighbors/wakes
    m_elemBoxes.resize(4);
    m_elemBoxes[0] = Elem1Box;
    m_elemBoxes[1] = Elem2Box;
    m_elemBoxes[2] = Elem3Box;
    m_elemBoxes[3] = Elem4Box;
    boxIndex = 0;
    for (; boxIndex<neighborTrailIDs.size(); boxIndex++)
        m_elemBoxes[boxIndex]->SetValue(wxString::Format("%i", neighborTrailIDs[boxIndex]));

    wxCommandEvent dummyEvent;
    OnTypeRadioBoxSelect(dummyEvent);
}

DEditElement::~DEditElement()
{
	//(*Destroy(DEditElement)
	//*)
}

void DEditElement::OnCancelButtonClick(wxCommandEvent& event)
{
    m_state = 1;
    this->Destroy();
}

void DEditElement::OnSkipButtonClick(wxCommandEvent& event)
{
    m_state = 2;
    this->Destroy();
}

void DEditElement::OnTypeRadioBoxSelect(wxCommandEvent& event)
{
    if (TypeRadioBox->GetStringSelection() == _("2 - Body Triangular"  ) ||
        TypeRadioBox->GetStringSelection() == _("21 - Dummy Triangular") ||
        TypeRadioBox->GetStringSelection() == _("11 - Wake Triangular" ) ){
        Node4Box->Disable();
        tNode4->Disable();
    }
    else{
        Node4Box->Enable();
        tNode4->Enable();
    }

    if (TypeRadioBox->GetStringSelection() == _("1 - Body Quadrilateral") ||
        TypeRadioBox->GetStringSelection() == _("2 - Body Triangular"   ) ){
        Elem1Box->Enable();
        Elem2Box->Enable();
        Elem3Box->Enable();
        Elem4Box->Enable();
        tElem1->Enable();
        tElem2->Enable();
        tElem3->Enable();
        tElem4->Enable();
    }
    else if (TypeRadioBox->GetStringSelection() == _("10 - Wake Quadrilateral") ||
             TypeRadioBox->GetStringSelection() == _("11 - Wake Triangular"   ) ){
        Elem1Box->Enable();
        Elem2Box->Enable();
        Elem3Box->Disable();
        Elem4Box->Disable();
        tElem1->Enable();
        tElem2->Enable();
        tElem3->Disable();
        tElem4->Disable();
    }
    else{
        Elem1Box->Disable();
        Elem2Box->Disable();
        Elem3Box->Disable();
        Elem4Box->Disable();
        tElem1->Disable();
        tElem2->Disable();
        tElem3->Disable();
        tElem4->Disable();
    }
}

void DEditElement::OnOKButtonClick(wxCommandEvent& event)
{
    // get element ID
    long elemIDlong;
    wxString number = ElemIDBox->GetValue();
    if(!number.ToLong(&elemIDlong) || elemIDlong<=0){
        // incorrect string entered
        showErrorMessage("Incorrect value for element ID entered");
        return;
    }
    m_newElemID = elemIDlong;

    // get element type
    uInt elemType = 0;
    if      (TypeRadioBox->GetStringSelection() == _("1 - Body Quadrilateral"  )) elemType = 1;
    else if (TypeRadioBox->GetStringSelection() == _("2 - Body Triangular"     )) elemType = 2;
    else if (TypeRadioBox->GetStringSelection() == _("20 - Dummy Quadrilateral")) elemType = 20;
    else if (TypeRadioBox->GetStringSelection() == _("21 - Dummy Triangular"   )) elemType = 21;
    else if (TypeRadioBox->GetStringSelection() == _("10 - Wake Quadrilateral" )) elemType = 10;
    else if (TypeRadioBox->GetStringSelection() == _("11 - Wake Triangular"    )) elemType = 11;

    // get node IDs
    vecUInt nodeIDs(3);
    if (elemType == 1 || elemType == 10 || elemType == 20)
        nodeIDs.resize(4);
    for (uInt nodeIndex=0; nodeIndex<nodeIDs.size(); nodeIndex++){
        number = m_nodeBoxes[nodeIndex]->GetValue();
        long longNum = 0;
        if(!number.ToLong(&longNum) || longNum<1){
            showErrorMessage("Incorrect value for node ID entered");
            return;
        }
        nodeIDs[nodeIndex] = longNum;
    }

    // get neighbor/trailing IDs
    vecUInt neighborTrailIDs;
    for (uInt neighborIndex=0; neighborIndex<4; neighborIndex++){
        number = m_elemBoxes[neighborIndex]->GetValue();
        if (number.empty())
            break;
        long longNum = 0;
        if(!number.ToLong(&longNum) || longNum<1){
            showErrorMessage("Incorrect value for neighboring/trailing element ID entered");
            return;
        }
        neighborTrailIDs.push_back(uInt(longNum));
    }

    // edit element
    int retCode = m_pMesh->editElement(
            m_elemID,
            m_newElemID,
            elemType,
            nodeIDs,
            neighborTrailIDs);

    // process return value
    string message;
    if      (retCode ==  0) m_state = 0;
    else if (retCode == -2) message = "Element with new ID already exists";
    else if (retCode == -4) message = "Duplicate node IDs are given";
    else if (retCode == -6) message = "Non-existing node IDs given";
    else if (retCode == -7) message = "Operation results with zero surface element";
    else if (retCode == -8) message = "Duplicate element IDs are given";
    else if (retCode == -9) message = "Non-existing element IDs given";
    else                    message = "Problem editing element - Contact support!";

    if (retCode != 0){
        showErrorMessage(message);
        return;
    }

    this->Destroy();
}
