#include "wx_pch.h"
#include "DEditNode.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DEditNode)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DEditNode)
//*)

//(*IdInit(DEditNode)
const long DEditNode::ID_STATICTEXT1 = wxNewId();
const long DEditNode::ID_TEXTCTRL1 = wxNewId();
const long DEditNode::ID_STATICTEXT3 = wxNewId();
const long DEditNode::ID_TEXTCTRL5 = wxNewId();
const long DEditNode::ID_STATICTEXT4 = wxNewId();
const long DEditNode::ID_TEXTCTRL6 = wxNewId();
const long DEditNode::ID_STATICTEXT5 = wxNewId();
const long DEditNode::ID_TEXTCTRL7 = wxNewId();
const long DEditNode::ID_BUTTON1 = wxNewId();
const long DEditNode::ID_BUTTON3 = wxNewId();
const long DEditNode::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DEditNode,wxDialog)
	//(*EventTable(DEditNode)
	//*)
END_EVENT_TABLE()

DEditNode::DEditNode(
        wxWindow* parent,
        CMesh* pMesh,
        uInt& nodeID,
        uInt& state,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_pMesh(pMesh), m_nodeID(nodeID), m_state(state)
{
	//(*Initialize(DEditNode)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Edit Node"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(4, 2, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Node ID"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer2->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	NodeIDBox = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(NodeIDBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer2->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CoordXBox = new wxTextCtrl(this, ID_TEXTCTRL5, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
	FlexGridSizer2->Add(CoordXBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Coordinates"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer2->Add(StaticText4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	CoordYBox = new wxTextCtrl(this, ID_TEXTCTRL6, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
	FlexGridSizer2->Add(CoordYBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText5 = new wxStaticText(this, ID_STATICTEXT5, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT5"));
	FlexGridSizer2->Add(StaticText5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CoordZBox = new wxTextCtrl(this, ID_TEXTCTRL7, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL7"));
	FlexGridSizer2->Add(CoordZBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK/Next"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SkipButton = new wxButton(this, ID_BUTTON3, _("Skip"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer4->Add(SkipButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel/Stop"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DEditNode::OnOKButtonClick);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DEditNode::OnSkipButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DEditNode::OnCancelButtonClick);
	//*)

    // store node ID
	m_newNodeID = m_nodeID;

    // get node data
    double coordinates[3];
    m_pMesh->getNodeCoords(m_nodeID, coordinates);

    // fill dialog with node data
	NodeIDBox->SetValue(wxString::Format("%i", m_nodeID));
	CoordXBox->SetValue(wxString::Format("%f", coordinates[0]));
	CoordYBox->SetValue(wxString::Format("%f", coordinates[1]));
	CoordZBox->SetValue(wxString::Format("%f", coordinates[2]));
}

DEditNode::~DEditNode()
{
	//(*Destroy(DEditNode)
	//*)
}

void DEditNode::OnCancelButtonClick(wxCommandEvent& event)
{
    m_state = 1;
    this->Destroy();
}

void DEditNode::OnSkipButtonClick(wxCommandEvent& event)
{
    m_state = 2;
    this->Destroy();
}

void DEditNode::OnOKButtonClick(wxCommandEvent& event)
{
    // get node ID
    long nodeIDlong;
    wxString number = NodeIDBox->GetValue();
    if(!number.ToLong(&nodeIDlong) || nodeIDlong<=0){
        // incorrect string entered
        showErrorMessage("Incorrect value for Node ID entered");
        return;
    }
    m_newNodeID = nodeIDlong;

    // get coordinates
    double coordinates[3];
    number = CoordXBox->GetValue();
    if(!number.ToDouble(&coordinates[0])){
        showErrorMessage("Incorrect value for X coordinate entered");
        return;
    }
    number = CoordYBox->GetValue();
    if(!number.ToDouble(&coordinates[1])){
        showErrorMessage("Incorrect value for Y coordinate entered");
        return;
    }
    number = CoordZBox->GetValue();
    if(!number.ToDouble(&coordinates[2])){
        showErrorMessage("Incorrect value for Z coordinate entered");
        return;
    }

    // edit node
    int retCode = m_pMesh->editNode(m_nodeID, m_newNodeID, coordinates);

    // process return value
    if (retCode ==  0)
        m_state = 0;
    else if (retCode == -2){
        showErrorMessage("Node with given ID already exists");
        return;
    }
    else{
        showErrorMessage("Problem editing node - Contact support!");
        return;
    }
    
    this->Destroy();
}
