#include "wx_pch.h"
#include "DElemSelection.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DElemSelection)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DElemSelection)
//*)

//(*IdInit(DElemSelection)
const long DElemSelection::ID_LISTBOX1 = wxNewId();
const long DElemSelection::ID_BUTTON3 = wxNewId();
const long DElemSelection::ID_BUTTON4 = wxNewId();
const long DElemSelection::ID_STATICTEXT1 = wxNewId();
const long DElemSelection::ID_CHOICE1 = wxNewId();
const long DElemSelection::ID_RADIOBOX1 = wxNewId();
const long DElemSelection::ID_STATICTEXT3 = wxNewId();
const long DElemSelection::ID_TEXTCTRL1 = wxNewId();
const long DElemSelection::ID_STATICTEXT4 = wxNewId();
const long DElemSelection::ID_TEXTCTRL2 = wxNewId();
const long DElemSelection::ID_STATICTEXT5 = wxNewId();
const long DElemSelection::ID_TEXTCTRL3 = wxNewId();
const long DElemSelection::ID_BUTTON5 = wxNewId();
const long DElemSelection::ID_STATICTEXT2 = wxNewId();
const long DElemSelection::ID_BUTTON1 = wxNewId();
const long DElemSelection::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DElemSelection,wxDialog)
	//(*EventTable(DElemSelection)
	//*)
END_EVENT_TABLE()

DElemSelection::DElemSelection(
        wxWindow* parent,
        CMesh* pMesh,
        setUInt& elemSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_pMesh(pMesh), m_elemSelection(elemSelection)
{
	//(*Initialize(DElemSelection)
	wxFlexGridSizer* FlexGridSizer4;

	Create(parent, id, _("Element Selection"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxDEFAULT_DIALOG_STYLE, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	MainFlexGridSizer = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer3 = new wxFlexGridSizer(3, 1, 0, 0);
	ElemList = new wxListBox(this, ID_LISTBOX1, wxDefaultPosition, wxDefaultSize, 0, 0, wxLB_EXTENDED|wxSUNKEN_BORDER, wxDefaultValidator, _T("ID_LISTBOX1"));
	ElemList->SetMinSize(wxSize(80,400));
	FlexGridSizer3->Add(ElemList, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	DeleteListButton = new wxButton(this, ID_BUTTON3, _("Delete"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	DeleteListButton->Disable();
	FlexGridSizer3->Add(DeleteListButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ClearListButton = new wxButton(this, ID_BUTTON4, _("Clear List"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
	ClearListButton->Disable();
	FlexGridSizer3->Add(ClearListButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5 = new wxFlexGridSizer(6, 1, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Select Type:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer5->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	TypeChoice = new wxChoice(this, ID_CHOICE1, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE1"));
	TypeChoice->SetSelection( TypeChoice->Append(_("By Element ID")) );
	TypeChoice->Append(_("By Element ID Range"));
	TypeChoice->Append(_("By Element Area"));
	TypeChoice->Append(_("By Element Type"));
	FlexGridSizer5->Add(TypeChoice, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	wxString __wxRadioBoxChoices_1[2] =
	{
		_("Add"),
		_("Remove")
	};
	AddOrRemove = new wxRadioBox(this, ID_RADIOBOX1, _("Select Action"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, wxRA_VERTICAL, wxDefaultValidator, _T("ID_RADIOBOX1"));
	AddOrRemove->SetSelection(0);
	FlexGridSizer5->Add(AddOrRemove, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1 = new wxFlexGridSizer(3, 2, 0, 0);
	labelOne = new wxStaticText(this, ID_STATICTEXT3, _("Label"), wxDefaultPosition, wxSize(80,-1), 0, _T("ID_STATICTEXT3"));
	FlexGridSizer1->Add(labelOne, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	labelBoxOne = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer1->Add(labelBoxOne, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	labelTwo = new wxStaticText(this, ID_STATICTEXT4, _("Label"), wxDefaultPosition, wxSize(80,-1), 0, _T("ID_STATICTEXT4"));
	FlexGridSizer1->Add(labelTwo, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	labelBoxTwo = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer1->Add(labelBoxTwo, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	labelThree = new wxStaticText(this, ID_STATICTEXT5, _("Label"), wxDefaultPosition, wxSize(80,-1), 0, _T("ID_STATICTEXT5"));
	FlexGridSizer1->Add(labelThree, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	labelBoxThree = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer1->Add(labelBoxThree, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5->Add(FlexGridSizer1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ApplyButton = new wxButton(this, ID_BUTTON5, _("Apply"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON5"));
	FlexGridSizer5->Add(ApplyButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	InfoText = new wxStaticText(this, ID_STATICTEXT2, wxEmptyString, wxDefaultPosition, wxSize(220,170), 0, _T("ID_STATICTEXT2"));
	FlexGridSizer5->Add(InfoText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(FlexGridSizer5, 1, wxALL|wxALIGN_TOP|wxALIGN_CENTER_HORIZONTAL, 5);
	MainFlexGridSizer->Add(FlexGridSizer2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	MainFlexGridSizer->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(MainFlexGridSizer);
	MainFlexGridSizer->Fit(this);
	MainFlexGridSizer->SetSizeHints(this);

	Connect(ID_LISTBOX1,wxEVT_COMMAND_LISTBOX_SELECTED,(wxObjectEventFunction)&DElemSelection::OnElemListSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DElemSelection::OnDeleteListButtonClick);
	Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DElemSelection::OnClearListButtonClick);
	Connect(ID_CHOICE1,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&DElemSelection::OnTypeChoiceSelect);
	Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DElemSelection::OnApplyButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DElemSelection::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DElemSelection::OnCancelButtonClick);
	//*)

	// copy external element selection to temporary one
	m_tempSelection = m_elemSelection;

	// append selection list from selection vector
    updateSelectionList();

    // update type definition boxes
    updateTypeSelection();
}

DElemSelection::~DElemSelection()
{
	//(*Destroy(DElemSelection)
	//*)
}

void DElemSelection::updateSelectionList()
{
    // append selection list from selection map
    ElemList->Clear();
    for (setUIntIt it=m_tempSelection.begin(); it!=m_tempSelection.end(); it++)
        ElemList->Append(wxString::Format("%i", *it));

    // enable or disable clear list button
    if (!m_tempSelection.empty()) ClearListButton->Enable(true);
    else                          ClearListButton->Enable(false);
}

void DElemSelection::updateTypeSelection()
{
    // remove any messages from dialog
    InfoText->SetLabel("");

    // check which type is selected and fill appropriate boxes
    if (TypeChoice->GetCurrentSelection() == 0){
        // enable/disable boxes
        labelOne->Enable(true);
        labelTwo->Enable(false);
        labelThree->Enable(false);
        labelBoxOne->Enable(true);
        labelBoxTwo->Enable(false);
        labelBoxThree->Enable(false);
        // name them
        labelOne->SetLabel("ID");
        labelTwo->SetLabel("");
        labelThree->SetLabel("");
    }
    else if (TypeChoice->GetCurrentSelection() == 1){
        // enable/disable boxes
        labelOne->Enable(true);
        labelTwo->Enable(true);
        labelThree->Enable(false);
        labelBoxOne->Enable(true);
        labelBoxTwo->Enable(true);
        labelBoxThree->Enable(false);
        // name them
        labelOne->SetLabel("Starting ID");
        labelTwo->SetLabel("Ending ID");
        labelThree->SetLabel("");
    }
    else if (TypeChoice->GetCurrentSelection() == 2){
        // enable/disable boxes
        labelOne->Enable(true);
        labelTwo->Enable(true);
        labelThree->Enable(false);
        labelBoxOne->Enable(true);
        labelBoxTwo->Enable(true);
        labelBoxThree->Enable(false);
        // name them
        labelOne->SetLabel("Minimum Area");
        labelTwo->SetLabel("Maximum Area");
        labelThree->SetLabel("");
    }
    else if (TypeChoice->GetCurrentSelection() == 3){
        // enable/disable boxes
        labelOne->Enable(true);
        labelTwo->Enable(false);
        labelThree->Enable(false);
        labelBoxOne->Enable(true);
        labelBoxTwo->Enable(false);
        labelBoxThree->Enable(false);
        // name them
        labelOne->SetLabel("Element Type");
        labelTwo->SetLabel("");
        labelThree->SetLabel("");
        // print info on element types
        InfoText->SetLabel("type 1 - quadrilateral body element\ntype 2 - triangular body element\ntype 10 - quadrilateral wake element\ntype 11 - triangular wake element\ntype 20 - quadrilateral dummy element\ntype 21 - triangular dummy element");
    }
    else{
        // disable all in case not supported option is selected
        labelOne->Enable(false);
        labelTwo->Enable(false);
        labelThree->Enable(false);
        labelBoxOne->Enable(false);
        labelBoxTwo->Enable(false);
        labelBoxThree->Enable(false);
        // clear names
        labelOne->SetLabel("");
        labelTwo->SetLabel("");
        labelThree->SetLabel("");
    }
}

void DElemSelection::OnElemListSelect(wxCommandEvent& event)
{
    // enable or disable delete button based on weather selection has been made in selection list
    wxArrayInt dummy;
    if (ElemList->GetSelections(dummy)) DeleteListButton->Enable(true);
    else                                DeleteListButton->Enable(false);
}

void DElemSelection::OnDeleteListButtonClick(wxCommandEvent& event)
{
    // array of list strings
    wxArrayString allElements = ElemList->GetStrings();

    // array of selected items
    wxArrayInt selectedIndexes;
    if (!ElemList->GetSelections(selectedIndexes))
        return;

    // remove selected items from selection map
    for (uInt i=0; i<selectedIndexes.GetCount(); i++)
        m_tempSelection.erase(wxAtoi(allElements[selectedIndexes[i]]));

    // update selection list from selection map
    updateSelectionList();
}

void DElemSelection::OnClearListButtonClick(wxCommandEvent& event)
{
    // remove any messages from dialog
    InfoText->SetLabel("");

    // clear selection
    m_tempSelection.clear();

    // append selection list from selection vector
    updateSelectionList();

    // enable/disable delete button
    wxCommandEvent dummyEvent;
    OnElemListSelect(dummyEvent);
}

void DElemSelection::OnTypeChoiceSelect(wxCommandEvent& event)
{
    updateTypeSelection();
}

void DElemSelection::OnOKButtonClick(wxCommandEvent& event)
{
    // store temporary selection
    m_elemSelection = m_tempSelection;

    this->Destroy();
}

void DElemSelection::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DElemSelection::OnApplyButtonClick(wxCommandEvent& event)
{
    // remove any messages from dialog
    InfoText->SetLabel("");

    if (TypeChoice->GetCurrentSelection() == 0){
        // read element ID
        long elemID;
        wxString number = labelBoxOne->GetValue();
        if(!number.ToLong(&elemID) || elemID<=0){
            showErrorMessage("Incorrect value for Element ID entered");
            return;
        }

        // check if element (ID) exists in mesh
        if (!m_pMesh->checkIfElemExists(elemID)){
            InfoText->SetLabel("Element does not exist");
            return;
        }

        // check if addition or removal
        if (AddOrRemove->GetStringSelection() == "Add"){
            // check if element ID is already in list
            if (m_tempSelection.find(elemID) != m_tempSelection.end()){
                InfoText->SetLabel("Element is already in selection");
                return;
            }
            m_tempSelection.insert(elemID);
        }
        else{
            // check if element ID is not in list
            if (m_tempSelection.find(elemID) == m_tempSelection.end()){
                InfoText->SetLabel("Element is not in selection");
                return;
            }
            m_tempSelection.erase(elemID);
        }
    }
    else if (TypeChoice->GetCurrentSelection() == 1){
        // read starting ID
        long startID;
        wxString number = labelBoxOne->GetValue();
        if(!number.ToLong(&startID) || startID<=0){
            showErrorMessage("Incorrect value for starting Element ID entered");
            return;
        }

        // read ending ID
        long endID;
        number = labelBoxTwo->GetValue();
        if(!number.ToLong(&endID) || endID<=startID){
            showErrorMessage("Incorrect value for ending Element ID entered");
            return;
        }

        // process element ID's
        for (uInt elemID=uInt(startID); elemID<=uInt(endID); elemID++){
            // check if element ID exists in mesh
            if (!m_pMesh->checkIfElemExists(elemID))
                continue;

            // add or remove element according to request and elements existence in list
            if   (AddOrRemove->GetStringSelection() == "Add") m_tempSelection.insert(elemID);
            else                                              m_tempSelection.erase (elemID);
        }
    }
    else if (TypeChoice->GetCurrentSelection() == 2){
        // read minimum area
        double minArea;
        wxString number = labelBoxOne->GetValue();
        if(!number.ToDouble(&minArea) || minArea<0.0){
            showErrorMessage("Incorrect value for minimum area entered");
            return;
        }

        // read maximum area
        double maxArea;
        number = labelBoxTwo->GetValue();
        if(!number.ToDouble(&maxArea) || maxArea<=minArea){
            showErrorMessage("Incorrect value for maximum area entered");
            return;
        }

        // get element IDs and coordinates
        vecUInt elemIDs;
        vecVecVecDbl coordinates;
        vecUInt dummy;
        m_pMesh->getElemIDsTypesCoords(elemIDs, dummy, coordinates);

        // calculate element areas
        vecDbl elemAreas(elemIDs.size());
        for (uInt elemIndex=0; elemIndex<elemAreas.size(); elemIndex++){
            elemAreas[elemIndex] = elementSurface(coordinates[elemIndex]);
        }

        // add or remove elements from list
        for (uInt elemIndex=0; elemIndex<elemIDs.size(); elemIndex++){
            if (elemAreas[elemIndex]>minArea && elemAreas[elemIndex]<maxArea){
                if   (AddOrRemove->GetStringSelection() == "Add") m_tempSelection.insert(elemIDs[elemIndex]);
                else                                              m_tempSelection.erase (elemIDs[elemIndex]);
            }
        }
    }
    else if (TypeChoice->GetCurrentSelection() == 3){
        // read element type
        long type;
        wxString number = labelBoxOne->GetValue();
        if(!number.ToLong(&type) || (type!=1 && type!=2 && type!=10 && type!=11 && type!=20 && type!=21)){
            showErrorMessage("Incorrect value for element type entered");
            return;
        }

        // get element IDs and types
        vecUInt elemIDs;
        vecUInt elemTypes;
        m_pMesh->getElemIDsTypes(elemIDs, elemTypes);

        // add or remove elements from list
        for (uInt elemIndex=0; elemIndex<elemIDs.size(); elemIndex++){
            if (elemTypes[elemIndex] == uInt(type)){
                if   (AddOrRemove->GetStringSelection() == "Add") m_tempSelection.insert(elemIDs[elemIndex]);
                else                                              m_tempSelection.erase (elemIDs[elemIndex]);
            }
        }
    }

    // update selection list
    updateSelectionList();

    // enable/disable delete button
    wxCommandEvent dummyEvent;
    OnElemListSelect(dummyEvent);
}
