#include "wx_pch.h"
#include "DExportAbaqus.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DExportAbaqus)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DExportAbaqus)
//*)

//(*IdInit(DExportAbaqus)
const long DExportAbaqus::ID_CHECKBOX1 = wxNewId();
const long DExportAbaqus::ID_CHECKBOX2 = wxNewId();
const long DExportAbaqus::ID_CHECKBOX3 = wxNewId();
const long DExportAbaqus::ID_STATICTEXT1 = wxNewId();
const long DExportAbaqus::ID_CHOICE1 = wxNewId();
const long DExportAbaqus::ID_STATICTEXT5 = wxNewId();
const long DExportAbaqus::ID_CHOICE2 = wxNewId();
const long DExportAbaqus::ID_STATICTEXT2 = wxNewId();
const long DExportAbaqus::ID_TEXTCTRL2 = wxNewId();
const long DExportAbaqus::ID_STATICTEXT3 = wxNewId();
const long DExportAbaqus::ID_TEXTCTRL3 = wxNewId();
const long DExportAbaqus::ID_STATICTEXT4 = wxNewId();
const long DExportAbaqus::ID_TEXTCTRL4 = wxNewId();
const long DExportAbaqus::ID_TEXTCTRL1 = wxNewId();
const long DExportAbaqus::ID_BUTTON1 = wxNewId();
const long DExportAbaqus::ID_BUTTON2 = wxNewId();
const long DExportAbaqus::ID_BUTTON3 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DExportAbaqus,wxDialog)
	//(*EventTable(DExportAbaqus)
	//*)
END_EVENT_TABLE()

DExportAbaqus::DExportAbaqus(
        wxWindow* parent,
        CMesh* pMesh,
        CProjectData* pProjectData,
        CResults* pResults,
        wxWindowID id) : m_pMesh(pMesh), m_pProjectData(pProjectData), m_pResults(pResults)
{
	//(*Initialize(DExportAbaqus)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer7;
	wxFlexGridSizer* FlexGridSizer6;
	wxFlexGridSizer* FlexGridSizer1;

	Create(0, wxID_ANY, _("Export Abaqus input file"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(6, 1, 0, 0);
	FlexGridSizer1->AddGrowableCol(0);
	FlexGridSizer1->AddGrowableRow(0);
	FlexGridSizer4 = new wxFlexGridSizer(3, 1, 0, 0);
	WriteMeshCheckBox = new wxCheckBox(this, ID_CHECKBOX1, _("Write Mesh"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	WriteMeshCheckBox->SetValue(true);
	FlexGridSizer4->Add(WriteMeshCheckBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	WriteMeshPropertyCheckBox = new wxCheckBox(this, ID_CHECKBOX2, _("Write Mesh Property"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX2"));
	WriteMeshPropertyCheckBox->SetValue(false);
	FlexGridSizer4->Add(WriteMeshPropertyCheckBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	WriteLoadsCheckBox = new wxCheckBox(this, ID_CHECKBOX3, _("Write Loads"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX3"));
	WriteLoadsCheckBox->SetValue(false);
	FlexGridSizer4->Add(WriteLoadsCheckBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer6->AddGrowableCol(1);
	FlexGridSizer6->AddGrowableRow(0);
	SelectLoadDataStaticText = new wxStaticText(this, ID_STATICTEXT1, _("Select Load Data"), wxDefaultPosition, wxSize(85,-1), 0, _T("ID_STATICTEXT1"));
	SelectLoadDataStaticText->Disable();
	FlexGridSizer6->Add(SelectLoadDataStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	LoadDataChoice = new wxChoice(this, ID_CHOICE1, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE1"));
	LoadDataChoice->Disable();
	FlexGridSizer6->Add(LoadDataChoice, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer6, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer7 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer7->AddGrowableCol(1);
	SelectCaseStaticText = new wxStaticText(this, ID_STATICTEXT5, _("Select Case"), wxDefaultPosition, wxSize(85,-1), 0, _T("ID_STATICTEXT5"));
	SelectCaseStaticText->Disable();
	FlexGridSizer7->Add(SelectCaseStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CaseChoice = new wxChoice(this, ID_CHOICE2, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE2"));
	CaseChoice->Disable();
	FlexGridSizer7->Add(CaseChoice, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer7, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5 = new wxFlexGridSizer(3, 2, 0, 0);
	ModulStaticText = new wxStaticText(this, ID_STATICTEXT2, _("Young\'s Modulus"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	ModulStaticText->Disable();
	FlexGridSizer5->Add(ModulStaticText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ModulTextCtrl = new wxTextCtrl(this, ID_TEXTCTRL2, _("70000"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	ModulTextCtrl->Disable();
	FlexGridSizer5->Add(ModulTextCtrl, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	PoissonStaticText = new wxStaticText(this, ID_STATICTEXT3, _("Poisson\'s Ratio"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	PoissonStaticText->Disable();
	FlexGridSizer5->Add(PoissonStaticText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	PoissonTextCtrl = new wxTextCtrl(this, ID_TEXTCTRL3, _("0.35"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	PoissonTextCtrl->Disable();
	FlexGridSizer5->Add(PoissonTextCtrl, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ThicknessStaticText = new wxStaticText(this, ID_STATICTEXT4, _("Plate Thickness"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	ThicknessStaticText->Disable();
	FlexGridSizer5->Add(ThicknessStaticText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ThicknessTextCtrl = new wxTextCtrl(this, ID_TEXTCTRL4, _("0.001"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
	ThicknessTextCtrl->Disable();
	FlexGridSizer5->Add(ThicknessTextCtrl, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer5, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer2->AddGrowableCol(0);
	FlexGridSizer2->AddGrowableRow(0);
	FileName = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxSize(200,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(FileName, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BrowseButton = new wxButton(this, ID_BUTTON1, _("File Name"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer2->Add(BrowseButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON2, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON3, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	ExportFileDialog = new wxFileDialog(this, _("Select file"), wxEmptyString, wxEmptyString, _("Abaqus input file (*.inp)|*.inp|All files (*.*)|*.*"), wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_CHECKBOX1,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DExportAbaqus::OnWriteMeshCheckBoxClick);
	Connect(ID_CHECKBOX2,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DExportAbaqus::OnWriteMeshPropertyCheckBoxClick);
	Connect(ID_CHECKBOX3,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DExportAbaqus::OnWriteLoadsCheckBoxClick);
	Connect(ID_CHOICE1,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&DExportAbaqus::OnLoadDataChoiceSelect);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DExportAbaqus::OnBrowseButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DExportAbaqus::OnOKButtonClick);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DExportAbaqus::OnCancelButtonClick);
	//*)

    // append job name into filename box
    FileName->AppendText(str2Wxs(m_pProjectData->projectName+".inp"));

	// append results list box with existing data
    if (m_pResults){
        for (uInt i=0; i<m_pResults->surfDatas.size(); i++)
            LoadDataChoice->SetSelection(LoadDataChoice->Append(str2Wxs(m_pResults->surfDatas[i].dataName)));
    }

    wxCommandEvent dummyEvent;
    OnLoadDataChoiceSelect(dummyEvent);
}

DExportAbaqus::~DExportAbaqus()
{
	//(*Destroy(DExportAbaqus)
	//*)
}

void DExportAbaqus::OnLoadDataChoiceSelect(wxCommandEvent& event)
{
    if (!m_pResults)
        return;

    // append case list box with case titles from current results list selection
    CaseChoice->Clear();
    wxString selectedField = LoadDataChoice->GetString(LoadDataChoice->GetSelection());
    for (uInt i=0; i<m_pResults->surfDatas.size(); i++){
        if (selectedField.Cmp(str2Wxs(m_pResults->surfDatas[i].dataName)) == 0){
            for (uInt j=0; j<m_pResults->surfDatas[i].caseTitles.size(); j++)
                CaseChoice->Append(str2Wxs(m_pResults->surfDatas[i].caseTitles[j]));
            CaseChoice->SetSelection(0);
            break;
        }
    }
}

void DExportAbaqus::OnBrowseButtonClick(wxCommandEvent& event)
{
    // show browse dialog and get filename with full path
    ExportFileDialog->SetFilename(FileName->GetValue());
    if (ExportFileDialog->ShowModal() == wxID_OK)
        FileName->SetValue(ExportFileDialog->GetPath());
}

void DExportAbaqus::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DExportAbaqus::OnWriteMeshCheckBoxClick(wxCommandEvent& event)
{
    if (WriteMeshCheckBox->IsChecked())
        WriteMeshPropertyCheckBox->Enable();
    else{
        WriteMeshPropertyCheckBox->SetValue(false);
        WriteMeshPropertyCheckBox->Disable();
    }

    OnWriteMeshPropertyCheckBoxClick(event);
}

void DExportAbaqus::OnWriteMeshPropertyCheckBoxClick(wxCommandEvent& event)
{
    if (WriteMeshPropertyCheckBox->IsChecked()){
        ModulStaticText->Enable();
        PoissonStaticText->Enable();
        ThicknessStaticText->Enable();
        ModulTextCtrl->Enable();
        PoissonTextCtrl->Enable();
        ThicknessTextCtrl->Enable();
    }
    else{
        ModulStaticText->Disable();
        PoissonStaticText->Disable();
        ThicknessStaticText->Disable();
        ModulTextCtrl->Disable();
        PoissonTextCtrl->Disable();
        ThicknessTextCtrl->Disable();
    }
}

void DExportAbaqus::OnWriteLoadsCheckBoxClick(wxCommandEvent& event)
{
    if (WriteLoadsCheckBox->IsChecked()){
        SelectLoadDataStaticText->Enable();
        SelectCaseStaticText->Enable();
        LoadDataChoice->Enable();
        CaseChoice->Enable();
    }
    else{
        SelectLoadDataStaticText->Disable();
        SelectCaseStaticText->Disable();
        LoadDataChoice->Disable();
        CaseChoice->Disable();
    }
}

void DExportAbaqus::OnOKButtonClick(wxCommandEvent& event)
{
    // get file name from filename box
    string fileName = wxs2Str(FileName->GetValue());
    if (fileName.empty()){
        showErrorMessage("Please enter Abaqus input filename!");
        return;
    }

    // delete existing file
    if (fileExists(fileName)){
        if (remove(fileName.c_str())){
            showErrorMessage("Existing file could not be deleted");
            return;
        }
    }

    // get requested data
    bool writeMesh = false;
    bool writeProperty = false;
    bool writeLoads = false;
    string modulus;
    string poisson;
    string thickness;
    string selectedData;
    string selectedCase;
    if (WriteMeshCheckBox->IsChecked())
        writeMesh = true;
    if (WriteMeshPropertyCheckBox->IsChecked()){
        writeProperty = true;
        // get Young's modulus
        modulus = wxs2Str(ModulTextCtrl->GetValue());
        if (modulus.empty()){
            showErrorMessage("Please enter Young's Modulus if writing mesh property!");
            return;
        }

        // get Poisson's ratio
        poisson = wxs2Str(PoissonTextCtrl->GetValue());
        if (poisson.empty()){
            showErrorMessage("Please enter Poisson's Ratio if writing mesh property!");
            return;
        }

        // get plate thickness
        thickness = wxs2Str(ThicknessTextCtrl->GetValue());
        if (thickness.empty()){
            showErrorMessage("Please enter plate thickness if writing mesh property!");
            return;
        }
    }
    if (WriteLoadsCheckBox->IsChecked()){
        writeLoads = true;
        selectedData = wxs2Str(LoadDataChoice->GetString(LoadDataChoice->GetSelection()));
        if (selectedData.empty()){
            showErrorMessage("Results are missing, please run solver with (Manometer) pressure request!");
            return;
        }

        selectedCase = wxs2Str(CaseChoice->GetString(CaseChoice->GetSelection()));
        if (selectedCase.empty()){
            showErrorMessage("Cases are missing, contact support!");
            return;
        }
    }

    // export the file
    if (exportAbaqusFile(
            fileName,
            m_pMesh,
            m_pResults,
            writeMesh,
            writeProperty,
            writeLoads,
            modulus,
            poisson,
            thickness,
            selectedData,
            selectedCase))
        return;

    this->Destroy();
}
