#include "wx_pch.h"
#include "DExtrudeLine.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DExtrudeLine)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DExtrudeLine)
//*)

//(*IdInit(DExtrudeLine)
const long DExtrudeLine::ID_STATICTEXT1 = wxNewId();
const long DExtrudeLine::ID_BUTTON1 = wxNewId();
const long DExtrudeLine::ID_STATICTEXT3 = wxNewId();
const long DExtrudeLine::ID_TEXTCTRL2 = wxNewId();
const long DExtrudeLine::ID_STATICTEXT4 = wxNewId();
const long DExtrudeLine::ID_TEXTCTRL1 = wxNewId();
const long DExtrudeLine::ID_BUTTON2 = wxNewId();
const long DExtrudeLine::ID_BUTTON3 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DExtrudeLine,wxDialog)
	//(*EventTable(DExtrudeLine)
	//*)
END_EVENT_TABLE()

DExtrudeLine::DExtrudeLine(
        wxWindow* parent,
        bool& modified,
        CGUIData* pGUIData,
        CMesh* pMesh,
        setUInt& nodeSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pGUIData(pGUIData), m_pMesh(pMesh), m_nodeSelection(nodeSelection)
{
	//(*Initialize(DExtrudeLine)
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Node Selection"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer2->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON1, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer2->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5 = new wxFlexGridSizer(2, 2, 0, 0);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Extrusion Length"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer5->Add(StaticText3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	sExtrusionLength = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer5->Add(sExtrusionLength, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Number of Elements"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer5->Add(StaticText4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	sNumElem = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer5->Add(sNumElem, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer5, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON2, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON3, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DExtrudeLine::OnSelectButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DExtrudeLine::OnOKButtonClick);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DExtrudeLine::OnCancelButtonClick);
	//*)

	// fill boxes with values
	sExtrusionLength->WriteText(wxString::Format("%f", m_pGUIData->wakeLength));
    sNumElem->WriteText(wxString::Format("%i", m_pGUIData->wakeNum));

	if (m_nodeSelection.size() < 2) OKButton->Disable();
    else                            OKButton->Enable();
}

DExtrudeLine::~DExtrudeLine()
{
	//(*Destroy(DExtrudeLine)
	//*)
}

void DExtrudeLine::OnSelectButtonClick(wxCommandEvent& event)
{
    DNodeSelection* node = new DNodeSelection(0, m_pMesh, m_nodeSelection);
    node->ShowModal();

	if (m_nodeSelection.size() < 2) OKButton->Disable();
    else                            OKButton->Enable();
}

void DExtrudeLine::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DExtrudeLine::OnOKButtonClick(wxCommandEvent& event)
{
    // get extrusion length
    double extrusionLength;
    wxString number = sExtrusionLength->GetValue();
    if(!number.ToDouble(&extrusionLength) || extrusionLength<=0.0){
        showErrorMessage("Incorrect value entered for extrusion length");
        return;
    }

    // get number of elements
    long elemNum;
    number = sNumElem->GetValue();
    if(!number.ToLong(&elemNum) || elemNum<=0){
        showErrorMessage("Incorrect value entered for number of elements");
        return;
    }

    // set m_modified flag to true
    m_modified = true;

    m_pMesh->extrudeLine(extrusionLength, elemNum, m_nodeSelection);

    this->Destroy();
}
