#include "wx_pch.h"
#include "DFlowParams.h"

#ifndef WX_PRECOMP
//(*InternalHeadersPCH(DFlowParams)
#include <wx/intl.h>
#include <wx/string.h>
//*)
#endif
//(*InternalHeaders(DFlowParams)
//*)

//(*IdInit(DFlowParams)
const long DFlowParams::ID_STATICTEXT1 = wxNewId();
const long DFlowParams::ID_TEXTCTRL5 = wxNewId();
const long DFlowParams::ID_STATICTEXT2 = wxNewId();
const long DFlowParams::ID_TEXTCTRL6 = wxNewId();
const long DFlowParams::ID_STATICTEXT3 = wxNewId();
const long DFlowParams::ID_TEXTCTRL7 = wxNewId();
const long DFlowParams::ID_STATICTEXT4 = wxNewId();
const long DFlowParams::ID_TEXTCTRL8 = wxNewId();
const long DFlowParams::ID_BUTTON2 = wxNewId();
const long DFlowParams::ID_BUTTON5 = wxNewId();
const long DFlowParams::ID_GRID1 = wxNewId();
const long DFlowParams::ID_BUTTON1 = wxNewId();
const long DFlowParams::ID_BUTTON3 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DFlowParams,wxDialog)
    //(*EventTable(DFlowParams)
    //*)
END_EVENT_TABLE()

DFlowParams::DFlowParams(wxWindow* parent,bool& modified,CProjectData* pProjectData,wxWindowID id,const wxPoint& pos,const wxSize& size) : m_modified(modified),m_pProjectData(pProjectData)
{
    //(*Initialize(DFlowParams)
    wxFlexGridSizer* FlexGridSizer4;
    wxFlexGridSizer* FlexGridSizer5;
    wxFlexGridSizer* FlexGridSizer2;
    wxFlexGridSizer* FlexGridSizer6;

    Create(parent, wxID_ANY, _("Flow Parameters"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
    FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
    FlexGridSizer2 = new wxFlexGridSizer(4, 2, 0, 0);
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Airspeed"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    FlexGridSizer2->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    AirspeedBox = new wxTextCtrl(this, ID_TEXTCTRL5, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
    FlexGridSizer2->Add(AirspeedBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Density"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
    FlexGridSizer2->Add(StaticText2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    DensityBox = new wxTextCtrl(this, ID_TEXTCTRL6, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
    FlexGridSizer2->Add(DensityBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Atmospheric Pressure"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
    FlexGridSizer2->Add(StaticText3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    PressureBox = new wxTextCtrl(this, ID_TEXTCTRL7, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL7"));
    FlexGridSizer2->Add(PressureBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Mach Number"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
    FlexGridSizer2->Add(StaticText4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    MachBox = new wxTextCtrl(this, ID_TEXTCTRL8, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL8"));
    FlexGridSizer2->Add(MachBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer4 = new wxFlexGridSizer(2, 1, 0, 0);
    FlexGridSizer6 = new wxFlexGridSizer(1, 2, 0, 0);
    InsertButton = new wxButton(this, ID_BUTTON2, _("Insert"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    FlexGridSizer6->Add(InsertButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    RemoveButton = new wxButton(this, ID_BUTTON5, _("Remove"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON5"));
    FlexGridSizer6->Add(RemoveButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer4->Add(FlexGridSizer6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    AnglesGrid = new wxGrid(this, ID_GRID1, wxDefaultPosition, wxDefaultSize, wxVSCROLL, _T("ID_GRID1"));
    AnglesGrid->CreateGrid(0,2);
    AnglesGrid->EnableEditing(true);
    AnglesGrid->EnableGridLines(true);
    AnglesGrid->SetColLabelSize(20);
    AnglesGrid->SetRowLabelSize(20);
    AnglesGrid->SetDefaultRowSize(20, true);
    AnglesGrid->SetDefaultColSize(100, true);
    AnglesGrid->SetColLabelValue(0, _("Angle Of Attack"));
    AnglesGrid->SetColLabelValue(1, _("Sideslip Angle"));
    AnglesGrid->SetDefaultCellFont( AnglesGrid->GetFont() );
    AnglesGrid->SetDefaultCellTextColour( AnglesGrid->GetForegroundColour() );
    FlexGridSizer4->Add(AnglesGrid, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer5 = new wxFlexGridSizer(0, 3, 0, 0);
    OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    FlexGridSizer5->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    CancelButton = new wxButton(this, ID_BUTTON3, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
    FlexGridSizer5->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer1->Add(FlexGridSizer5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    SetSizer(FlexGridSizer1);
    FlexGridSizer1->Fit(this);
    FlexGridSizer1->SetSizeHints(this);
    Center();

    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DFlowParams::OnInsertButtonClick);
    Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DFlowParams::OnRemoveButtonClick);
    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DFlowParams::OnOKButtonClick);
    Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DFlowParams::OnCancelButtonClick);
    //*)

    AnglesGrid->DisableDragGridSize();

    // fill Apame data into window
    AirspeedBox->WriteText(wxString::Format("%f", m_pProjectData->airspeed));
    DensityBox->WriteText(wxString::Format("%e", m_pProjectData->density));
    PressureBox->WriteText(wxString::Format("%e", m_pProjectData->pressure));
    MachBox->WriteText(wxString::Format("%f", m_pProjectData->mach));

    // insert angles into grid
    AnglesGrid->InsertRows(0, m_pProjectData->alfa.size());
    for (uInt caseIndex=0; caseIndex<m_pProjectData->alfa.size(); caseIndex++){
        AnglesGrid->SetCellValue(caseIndex, 0, (wxString::Format("%f", m_pProjectData->alfa[caseIndex])));
        AnglesGrid->SetCellValue(caseIndex, 1, (wxString::Format("%f", m_pProjectData->beta[caseIndex])));
    }

    SetSizer(FlexGridSizer1);
    FlexGridSizer1->Fit(this);
    FlexGridSizer1->SetSizeHints(this);
    Center();
}

DFlowParams::~DFlowParams()
{
    //(*Destroy(DFlowParams)
    //*)
}

void DFlowParams::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DFlowParams::OnInsertButtonClick(wxCommandEvent& event)
{
    AnglesGrid->InsertRows(AnglesGrid->GetNumberRows(), 1);
    AnglesGrid->SetCellValue(AnglesGrid->GetNumberRows()-1, 0, "0.000000");
    AnglesGrid->SetCellValue(AnglesGrid->GetNumberRows()-1, 1, "0.000000");

    SetSizer(FlexGridSizer1);
    FlexGridSizer1->Fit(this);
    FlexGridSizer1->SetSizeHints(this);
}

void DFlowParams::OnRemoveButtonClick(wxCommandEvent& event)
{
    if (AnglesGrid->GetNumberRows() > 1)
        AnglesGrid->DeleteRows(AnglesGrid->GetNumberRows()-1, 1);

    SetSizer(FlexGridSizer1);
    FlexGridSizer1->Fit(this);
    FlexGridSizer1->SetSizeHints(this);
}

void DFlowParams::OnOKButtonClick(wxCommandEvent& event)
{
    // extract variables from dialog
    wxString number = AirspeedBox->GetValue();
    double airspeed;
    if(!number.ToDouble(&airspeed)){
        showErrorMessage("Incorrect value for airspeed entered");
        return;
    }
    number = DensityBox->GetValue();
    double density;
    if(!number.ToDouble(&density)){
        showErrorMessage("Incorrect value for density entered");
        return;
    }
    number = PressureBox->GetValue();
    double pressure;
    if(!number.ToDouble(&pressure)){
        showErrorMessage("Incorrect value for Atmospheric Pressure entered");
        return;
    }
    number = MachBox->GetValue();
    double mach;
    if(!number.ToDouble(&mach)){
        showErrorMessage("Incorrect value for Mach Number entered");
        return;
    }

    vecDbl alfa(AnglesGrid->GetNumberRows());
    vecDbl beta(AnglesGrid->GetNumberRows());
    for (uInt caseIndex=0; caseIndex<alfa.size(); caseIndex++){
        if(!AnglesGrid->GetCellValue(caseIndex, 0).ToDouble(&alfa[caseIndex])){
            showErrorMessage("Incorrect value in table");
            return;
        }
        if(!AnglesGrid->GetCellValue(caseIndex, 1).ToDouble(&beta[caseIndex])){
            showErrorMessage("Incorrect value in table");
            return;
        }
    }

    m_modified = true;

    // add values to Apame data structure
    m_pProjectData->airspeed = airspeed;
    m_pProjectData->density = density;
    m_pProjectData->pressure = pressure;
    m_pProjectData->mach = mach;
    m_pProjectData->alfa.resize(alfa.size());
    m_pProjectData->beta.resize(alfa.size());
    for (uInt caseIndex=0; caseIndex<alfa.size(); caseIndex++){
        m_pProjectData->alfa[caseIndex] = alfa[caseIndex];
        m_pProjectData->beta[caseIndex] = beta[caseIndex];
    }

    this->Destroy();
}
