#include "wx_pch.h"
#include "DGenerateWake.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DGenerateWake)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DGenerateWake)
//*)

//(*IdInit(DGenerateWake)
const long DGenerateWake::ID_STATICTEXT1 = wxNewId();
const long DGenerateWake::ID_TEXTCTRL1 = wxNewId();
const long DGenerateWake::ID_STATICTEXT2 = wxNewId();
const long DGenerateWake::ID_TEXTCTRL2 = wxNewId();
const long DGenerateWake::ID_STATICTEXT3 = wxNewId();
const long DGenerateWake::ID_TEXTCTRL3 = wxNewId();
const long DGenerateWake::ID_RADIOBOX1 = wxNewId();
const long DGenerateWake::ID_BUTTON3 = wxNewId();
const long DGenerateWake::ID_BUTTON1 = wxNewId();
const long DGenerateWake::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DGenerateWake,wxDialog)
	//(*EventTable(DGenerateWake)
	//*)
END_EVENT_TABLE()

DGenerateWake::DGenerateWake(
        wxWindow* parent,
        bool& modified,
        CGUIData* pGUIData,
        CMesh* pMesh,
        setUInt& elemSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pGUIData(pGUIData), m_pMesh(pMesh), m_elemSelection(elemSelection)
{
	//(*Initialize(DGenerateWake)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;
	
	Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(3, 2, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Angle [deg] threshold for applying Kutta condition"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer2->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	wakeThresholdBox = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxSize(100,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(wakeThresholdBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Length of wake (in multiples of geometry span)"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer2->Add(StaticText2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	wakeLengthBox = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxSize(100,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer2->Add(wakeLengthBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Number of downstream elements"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer2->Add(StaticText3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	wakeNumBox = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxSize(100,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer2->Add(wakeNumBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(0, 3, 0, 0);
	wxString __wxRadioBoxChoices_1[2] = 
	{
		_("Whole Mesh"),
		_("Element Selection")
	};
	DomainRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Select Domain"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	FlexGridSizer3->Add(DomainRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON3, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer3->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);
	
	Connect(ID_RADIOBOX1,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DGenerateWake::OnDomainRadioBoxSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DGenerateWake::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DGenerateWake::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DGenerateWake::OnCancelButtonClick);
	//*)
    
    // fill GUI data into window
    wakeThresholdBox->WriteText(wxString::Format("%f", m_pGUIData->wakeThreshold));
    wakeLengthBox->WriteText(wxString::Format("%f", m_pGUIData->wakeLength));
    wakeNumBox->WriteText(wxString::Format("%i", m_pGUIData->wakeNum));
}

DGenerateWake::~DGenerateWake()
{
	//(*Destroy(DGenerateWake)
	//*)
}

void DGenerateWake::OnOKButtonClick(wxCommandEvent& event)
{
    // extract trailing edge angle sharpness threshold
    wxString number = wakeThresholdBox->GetValue();
    double dWakeThreshold;
    number.ToDouble(&dWakeThreshold);
    if (dWakeThreshold<=0 || dWakeThreshold>=180){
        showErrorMessage("Trailing edge angle sharpness threshold value should be greater than 0 and less than 180");
        return;
    }
    // get opposite angle (angle between normals)
    dWakeThreshold = 180.0-dWakeThreshold;
    // transform to radians
    dWakeThreshold *= pi/180;

    // extract wake length
    number = wakeLengthBox->GetValue();
    double dWakeLength;
    number.ToDouble(&dWakeLength);
    if (dWakeLength <= 0){
        showErrorMessage("Wake length value should be greater than 0");
        return;
    }

    // extract number of wake elements
    number = wakeNumBox->GetValue();
    long iWakeNum;
    number.ToLong(&iWakeNum);
    if (iWakeNum <= 0){
        showErrorMessage("Number of wake elements value should be greater than 0");
        return;
    }

    m_modified = true;

    // run wake update mesh method
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))
        m_pMesh->updateWakeInfo(dWakeThreshold, dWakeLength, uInt(iWakeNum));
    else
        m_pMesh->updateWakeInfo(dWakeThreshold, dWakeLength, uInt(iWakeNum), m_elemSelection);

    this->Destroy();
}

void DGenerateWake::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DGenerateWake::OnDomainRadioBoxSelect(wxCommandEvent& event)
{
    // enable/disable select button
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh")) SelectButton->Enable(false);
    else                                                         SelectButton->Enable(true);
}

void DGenerateWake::OnSelectButtonClick(wxCommandEvent& event)
{
    DElemSelection* ElemSelectionFrame = new DElemSelection(0, m_pMesh, m_elemSelection);
    ElemSelectionFrame->ShowModal();
}
