#include "wx_pch.h"
#include "DImportApameSolverInput.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DImportApameSolverInput)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DImportApameSolverInput)
//*)

//(*IdInit(DImportApameSolverInput)
const long DImportApameSolverInput::ID_CHECKBOX1 = wxNewId();
const long DImportApameSolverInput::ID_CHECKBOX2 = wxNewId();
const long DImportApameSolverInput::ID_CHECKBOX3 = wxNewId();
const long DImportApameSolverInput::ID_CHECKBOX4 = wxNewId();
const long DImportApameSolverInput::ID_CHECKBOX5 = wxNewId();
const long DImportApameSolverInput::ID_CHECKBOX6 = wxNewId();
const long DImportApameSolverInput::ID_TEXTCTRL1 = wxNewId();
const long DImportApameSolverInput::ID_BUTTON3 = wxNewId();
const long DImportApameSolverInput::ID_BUTTON1 = wxNewId();
const long DImportApameSolverInput::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DImportApameSolverInput,wxDialog)
	//(*EventTable(DImportApameSolverInput)
	//*)
END_EVENT_TABLE()

DImportApameSolverInput::DImportApameSolverInput(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        CProjectData* pProjectData,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh), m_pProjectData(pProjectData)
{
	//(*Initialize(DImportApameSolverInput)
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Import ApameSolver Input File"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(0, 1, 0, 0);
	ReadFlowParamsBox = new wxCheckBox(this, ID_CHECKBOX1, _("Read Flow Parameters"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	ReadFlowParamsBox->SetValue(true);
	FlexGridSizer1->Add(ReadFlowParamsBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadRefDataBox = new wxCheckBox(this, ID_CHECKBOX2, _("Read Reference Data"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX2"));
	ReadRefDataBox->SetValue(true);
	FlexGridSizer1->Add(ReadRefDataBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadSolverParamsBox = new wxCheckBox(this, ID_CHECKBOX3, _("Read Solver Parameters"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX3"));
	ReadSolverParamsBox->SetValue(true);
	FlexGridSizer1->Add(ReadSolverParamsBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadResReqBox = new wxCheckBox(this, ID_CHECKBOX4, _("Read Result Requests"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX4"));
	ReadResReqBox->SetValue(true);
	FlexGridSizer1->Add(ReadResReqBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadNodesBox = new wxCheckBox(this, ID_CHECKBOX5, _("Read Nodes"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX5"));
	ReadNodesBox->SetValue(true);
	FlexGridSizer1->Add(ReadNodesBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadElementsBox = new wxCheckBox(this, ID_CHECKBOX6, _("Read Elements"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX6"));
	ReadElementsBox->SetValue(true);
	FlexGridSizer1->Add(ReadElementsBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(0, 3, 0, 0);
	FileName = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxSize(300,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer3->Add(FileName, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BrowseButton = new wxButton(this, ID_BUTTON3, _("Select File"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer3->Add(BrowseButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(0, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer2->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer2->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	ApameSolverInputImportDialog = new wxFileDialog(this, _("Select ApameSolver input file"), wxEmptyString, wxEmptyString, _("ApameSolver input file (*.inp)|*.inp|All files (*.*)|*.*"), wxFD_OPEN|wxFD_FILE_MUST_EXIST, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);
	Center();

	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportApameSolverInput::OnBrowseButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportApameSolverInput::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportApameSolverInput::OnCancelButtonClick);
	//*)
}

DImportApameSolverInput::~DImportApameSolverInput()
{
	//(*Destroy(DImportApameSolverInput)
	//*)
}

void DImportApameSolverInput::OnOKButtonClick(wxCommandEvent& event)
{
    m_modified = true;

    // get file name
    string fileName = wxs2Str(FileName->GetValue());

    // get user requested options
    bool readFlowParams   = false;
    bool readRefData      = false;
    bool readSolverParams = false;
    bool readResReq       = false;
    bool readNodes        = false;
    bool readElements     = false;
    if (ReadFlowParamsBox->IsChecked())   readFlowParams   = true;
    if (ReadRefDataBox->IsChecked())      readRefData      = true;
    if (ReadSolverParamsBox->IsChecked()) readSolverParams = true;
    if (ReadResReqBox->IsChecked())       readResReq       = true;
    if (ReadNodesBox->IsChecked())        readNodes        = true;
    if (ReadElementsBox->IsChecked())     readElements     = true;

    // read data from file
    readApameSolverInputFile(
            m_pMesh,
            m_pProjectData,
            fileName,
            readFlowParams,
            readRefData,
            readSolverParams,
            readResReq,
            readNodes,
            readElements);

    this->Destroy();
}

void DImportApameSolverInput::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DImportApameSolverInput::OnBrowseButtonClick(wxCommandEvent& event)
{
    // show browse dialog
    if (ApameSolverInputImportDialog->ShowModal() == wxID_OK){
        // get filename with full path
        wxString wxSFileName = ApameSolverInputImportDialog->GetPath();
        FileName->SetValue(wxSFileName);
    }
}
