#include "wx_pch.h"
#include "DImportApameSolverResults.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DImportApameSolverResults)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DImportApameSolverResults)
//*)

//(*IdInit(DImportApameSolverResults)
const long DImportApameSolverResults::ID_CHECKBOX1 = wxNewId();
const long DImportApameSolverResults::ID_CHECKBOX2 = wxNewId();
const long DImportApameSolverResults::ID_CHECKBOX3 = wxNewId();
const long DImportApameSolverResults::ID_CHECKBOX4 = wxNewId();
const long DImportApameSolverResults::ID_CHECKBOX5 = wxNewId();
const long DImportApameSolverResults::ID_CHECKBOX6 = wxNewId();
const long DImportApameSolverResults::ID_CHECKBOX7 = wxNewId();
const long DImportApameSolverResults::ID_TEXTCTRL1 = wxNewId();
const long DImportApameSolverResults::ID_BUTTON1 = wxNewId();
const long DImportApameSolverResults::ID_BUTTON2 = wxNewId();
const long DImportApameSolverResults::ID_BUTTON3 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DImportApameSolverResults,wxDialog)
	//(*EventTable(DImportApameSolverResults)
	//*)
END_EVENT_TABLE()

DImportApameSolverResults::DImportApameSolverResults(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        CProjectData* pProjectData,
        CResults* pResults,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh), m_pProjectData(pProjectData), m_pResults(pResults)
{
	//(*Initialize(DImportApameSolverResults)
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(0, 1, 0, 0);
	ReadFlowParamsBox = new wxCheckBox(this, ID_CHECKBOX1, _("Read Flow Parameters"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	ReadFlowParamsBox->SetValue(true);
	FlexGridSizer1->Add(ReadFlowParamsBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadRefDataBox = new wxCheckBox(this, ID_CHECKBOX2, _("Read Reference Data"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX2"));
	ReadRefDataBox->SetValue(true);
	FlexGridSizer1->Add(ReadRefDataBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadSolverParamsBox = new wxCheckBox(this, ID_CHECKBOX3, _("Read Solver Parameters"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX3"));
	ReadSolverParamsBox->SetValue(true);
	FlexGridSizer1->Add(ReadSolverParamsBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadResReqBox = new wxCheckBox(this, ID_CHECKBOX4, _("Read Result Requests"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX4"));
	ReadResReqBox->SetValue(true);
	FlexGridSizer1->Add(ReadResReqBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadNodesBox = new wxCheckBox(this, ID_CHECKBOX5, _("Read Nodes"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX5"));
	ReadNodesBox->SetValue(true);
	FlexGridSizer1->Add(ReadNodesBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadElementsBox = new wxCheckBox(this, ID_CHECKBOX6, _("Read Elements"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX6"));
	ReadElementsBox->SetValue(true);
	FlexGridSizer1->Add(ReadElementsBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ReadResultsBox = new wxCheckBox(this, ID_CHECKBOX7, _("Read Results"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX7"));
	ReadResultsBox->SetValue(true);
	FlexGridSizer1->Add(ReadResultsBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(0, 3, 0, 0);
	FileName = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxSize(300,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(FileName, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BrowseButton = new wxButton(this, ID_BUTTON1, _("Select File"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer2->Add(BrowseButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(0, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON2, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON3, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	ApameSolverResultsImportDialog = new wxFileDialog(this, _("Select ApameSolver results file"), wxEmptyString, wxEmptyString, _("ApameSolver results file (*.res)|*.res|All files (*.*)|*.*"), wxFD_OPEN|wxFD_FILE_MUST_EXIST, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_CHECKBOX6,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DImportApameSolverResults::OnReadElementsBoxClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportApameSolverResults::OnBrowseButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportApameSolverResults::OnOKButtonClick);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportApameSolverResults::OnCancelButtonClick);
	//*)
}

DImportApameSolverResults::~DImportApameSolverResults()
{
	//(*Destroy(DImportApameSolverResults)
	//*)
}

void DImportApameSolverResults::OnBrowseButtonClick(wxCommandEvent& event)
{
    // show browse dialog and get filename with full path
    if (ApameSolverResultsImportDialog->ShowModal() == wxID_OK)
        FileName->SetValue(ApameSolverResultsImportDialog->GetPath());
}

void DImportApameSolverResults::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DImportApameSolverResults::OnOKButtonClick(wxCommandEvent& event)
{
    m_modified = true;

    // get file name
    string fileName = wxs2Str(FileName->GetValue());

    // get user requested options
    bool readFlowParams   = false;
    bool readRefData      = false;
    bool readSolverParams = false;
    bool readNodes        = false;
    bool readElements     = false;
    if (ReadFlowParamsBox->IsChecked())   readFlowParams   = true;
    if (ReadRefDataBox->IsChecked())      readRefData      = true;
    if (ReadSolverParamsBox->IsChecked()) readSolverParams = true;
    if (ReadNodesBox->IsChecked())        readNodes        = true;
    if (ReadElementsBox->IsChecked())     readElements     = true;

    // read data from file
    vecUInt elemIDs;    // IDs of imported elements (excluding wake types)
    readApameSolverResultMeshAndProjectData(
            m_pMesh,
            m_pProjectData,
            fileName,
            readFlowParams,
            readRefData,
            readSolverParams,
            readNodes,
            readElements,
            elemIDs);

    if (ReadResultsBox->IsChecked())
        readApameSolverResults(
                m_pResults,
                fileName,
                elemIDs);

    this->Destroy();
}

void DImportApameSolverResults::OnReadElementsBoxClick(wxCommandEvent& event)
{
    if (ReadElementsBox->IsChecked())
        ReadResultsBox->Enable();
    else
        ReadResultsBox->Disable();
}
