#include "wx_pch.h"
#include "DImportNastran.h"

#ifndef WX_PRECOMP
//(*InternalHeadersPCH(DImportNastran)
#include <wx/intl.h>
#include <wx/string.h>
//*)
#endif
//(*InternalHeaders(DImportNastran)
//*)

//(*IdInit(DImportNastran)
const long DImportNastran::ID_CHECKBOX1 = wxNewId();
const long DImportNastran::ID_STATICTEXT1 = wxNewId();
const long DImportNastran::ID_TEXTCTRL1 = wxNewId();
const long DImportNastran::ID_STATICTEXT3 = wxNewId();
const long DImportNastran::ID_TEXTCTRL3 = wxNewId();
const long DImportNastran::ID_TEXTCTRL2 = wxNewId();
const long DImportNastran::ID_BUTTON3 = wxNewId();
const long DImportNastran::ID_BUTTON1 = wxNewId();
const long DImportNastran::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DImportNastran,wxDialog)
    //(*EventTable(DImportNastran)
    //*)
END_EVENT_TABLE()

DImportNastran::DImportNastran(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        wxWindowID id) : m_modified(modified), m_pMesh(pMesh)
{
    //(*Initialize(DImportNastran)
    wxFlexGridSizer* FlexGridSizer4;
    wxFlexGridSizer* FlexGridSizer3;
    wxFlexGridSizer* FlexGridSizer2;
    wxFlexGridSizer* FlexGridSizer1;

    Create(parent, id, _("Import NASTRAN File"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
    FlexGridSizer1 = new wxFlexGridSizer(5, 1, 0, 0);
    PreserveIDBox = new wxCheckBox(this, ID_CHECKBOX1, _("Preserve Element and Node ID\'s"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
    PreserveIDBox->SetValue(true);
    FlexGridSizer1->Add(PreserveIDBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer2 = new wxFlexGridSizer(2, 2, 0, 0);
    EnumElemIDText = new wxStaticText(this, ID_STATICTEXT1, _("Shift element IDs by"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    EnumElemIDText->Disable();
    FlexGridSizer2->Add(EnumElemIDText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    EnumElemID = new wxTextCtrl(this, ID_TEXTCTRL1, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    EnumElemID->Disable();
    FlexGridSizer2->Add(EnumElemID, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    EnumNodeIDText = new wxStaticText(this, ID_STATICTEXT3, _("Shift node IDs by"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
    EnumNodeIDText->Disable();
    FlexGridSizer2->Add(EnumNodeIDText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    EnumNodeID = new wxTextCtrl(this, ID_TEXTCTRL3, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    EnumNodeID->Disable();
    FlexGridSizer2->Add(EnumNodeID, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
    FlexGridSizer4->AddGrowableCol(0);
    FileName = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxSize(300,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    FlexGridSizer4->Add(FileName, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    BrowseButton = new wxButton(this, ID_BUTTON3, _("Select File"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
    FlexGridSizer4->Add(BrowseButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
    OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    SetSizer(FlexGridSizer1);
    NastranImportDialog = new wxFileDialog(this, _("Select Nastran file"), wxEmptyString, wxEmptyString, _("Nastran file extensions (*.bdf;*.nas;*.dat)|*.bdf;*.nas;*.dat|Nastran BDF (*.bdf)|*.bdf|Nastran NAS (*.nas)|*.nas|Nastran DAT (*.dat)|*.dat|All files (*.*)|*.*"), wxFD_OPEN|wxFD_FILE_MUST_EXIST, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
    FlexGridSizer1->Fit(this);
    FlexGridSizer1->SetSizeHints(this);
    Center();

    Connect(ID_CHECKBOX1,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DImportNastran::OnPreserveIDBoxClick);
    Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportNastran::OnBrowseButtonClick);
    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportNastran::OnOKButtonClick);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DImportNastran::OnCancelButtonClick);
    //*)
}

DImportNastran::~DImportNastran()
{
    //(*Destroy(DImportNastran)
    //*)
}

void DImportNastran::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DImportNastran::OnOKButtonClick(wxCommandEvent& event)
{
    // read starting IDs for renumbering
    long shiftNodeIDs = 0;
    long shiftElemIDs = 0;
    if (!PreserveIDBox->IsChecked()){
        if (!EnumNodeID->GetValue().ToLong(&shiftNodeIDs)){
            showErrorMessage("Incorrect value entered for node IDs shift");
            return;
        }
        if (!EnumElemID->GetValue().ToLong(&shiftElemIDs)){
            showErrorMessage("Incorrect value entered for element IDs shift");
            return;
        }
    }

    m_modified = true;

    // get file name
    string fileName = wxs2Str(FileName->GetValue());

    // read Nastran data from lines
    readNastranFile(m_pMesh, fileName, shiftNodeIDs, shiftElemIDs);

    this->Destroy();
}

void DImportNastran::OnPreserveIDBoxClick(wxCommandEvent& event)
{
    if (PreserveIDBox->IsChecked()){
        EnumElemIDText->Disable();
        EnumElemID->Disable();
        EnumNodeIDText->Disable();
        EnumNodeID->Disable();
    }
    else{
        EnumElemIDText->Enable();
        EnumElemID->Enable();
        EnumNodeIDText->Enable();
        EnumNodeID->Enable();
    }
}

void DImportNastran::OnBrowseButtonClick(wxCommandEvent& event)
{
    // show browse dialog and get filename with full path
    if (NastranImportDialog->ShowModal() == wxID_OK)
        FileName->SetValue(NastranImportDialog->GetPath());
}
