#include "wx_pch.h"
#include "DMergeNodes.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DMergeNodes)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DMergeNodes)
//*)

//(*IdInit(DMergeNodes)
const long DMergeNodes::ID_STATICTEXT1 = wxNewId();
const long DMergeNodes::ID_TEXTCTRL1 = wxNewId();
const long DMergeNodes::ID_RADIOBOX2 = wxNewId();
const long DMergeNodes::ID_RADIOBOX1 = wxNewId();
const long DMergeNodes::ID_BUTTON3 = wxNewId();
const long DMergeNodes::ID_BUTTON1 = wxNewId();
const long DMergeNodes::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DMergeNodes,wxDialog)
	//(*EventTable(DMergeNodes)
	//*)
END_EVENT_TABLE()

DMergeNodes::DMergeNodes(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        setUInt& nodeSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh), m_nodeSelection(nodeSelection)
{
	//(*Initialize(DMergeNodes)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Merge Coincident Nodes"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(4, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Enter Tolerance:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer2->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ToleranceText = new wxTextCtrl(this, ID_TEXTCTRL1, _("0.001"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(ToleranceText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5 = new wxFlexGridSizer(1, 1, 0, 0);
	wxString __wxRadioBoxChoices_1[3] =
	{
		_("Merge to node with higher ID"),
		_("Merge to node with lower ID"),
		_("Merge to middle")
	};
	MethodRadioBox = new wxRadioBox(this, ID_RADIOBOX2, _("Select Method"), wxDefaultPosition, wxDefaultSize, 3, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX2"));
	MethodRadioBox->SetSelection(2);
	FlexGridSizer5->Add(MethodRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer5, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	wxString __wxRadioBoxChoices_2[2] =
	{
		_("Whole Mesh"),
		_("Node Selection")
	};
	DomainRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Select Domain"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_2, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	DomainRadioBox->SetSelection(0);
	FlexGridSizer3->Add(DomainRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON3, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	SelectButton->Disable();
	FlexGridSizer3->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_RADIOBOX1,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DMergeNodes::OnDomainRadioBoxSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DMergeNodes::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DMergeNodes::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DMergeNodes::OnCancelButtonClick);
	//*)
}

DMergeNodes::~DMergeNodes()
{
	//(*Destroy(DMergeNodes)
	//*)
}

void DMergeNodes::OnOKButtonClick(wxCommandEvent& event)
{
    // get tolerance
    double tolerance;
    wxString number = ToleranceText->GetValue();
    if(!number.ToDouble(&tolerance)){
        showErrorMessage("Incorrect value for tolerance entered");
        return;
    }

    string type;
    if      (MethodRadioBox->GetSelection() == 0)
        type = "higher";
    else if (MethodRadioBox->GetSelection() == 1)
        type = "lower";
    else
        type = "middle";

    m_modified = true;

    // check domain type and merge
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))
        m_pMesh->mergeNodes(tolerance, type);
    else
        m_pMesh->mergeNodes(tolerance, type, m_nodeSelection);

    this->Destroy();
}

void DMergeNodes::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DMergeNodes::OnDomainRadioBoxSelect(wxCommandEvent& event)
{
    // enable/disable select button
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))
        SelectButton->Enable(false);
    else
        SelectButton->Enable(true);
}

void DMergeNodes::OnSelectButtonClick(wxCommandEvent& event)
{
    DNodeSelection* NodeSelectionFrame = new DNodeSelection(0, m_pMesh, m_nodeSelection);
    NodeSelectionFrame->ShowModal();
}
