#include "wx_pch.h"
#include "DNodeSelection.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DNodeSelection)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DNodeSelection)
//*)

//(*IdInit(DNodeSelection)
const long DNodeSelection::ID_LISTBOX1 = wxNewId();
const long DNodeSelection::ID_BUTTON3 = wxNewId();
const long DNodeSelection::ID_BUTTON5 = wxNewId();
const long DNodeSelection::ID_STATICTEXT1 = wxNewId();
const long DNodeSelection::ID_CHOICE1 = wxNewId();
const long DNodeSelection::ID_RADIOBOX1 = wxNewId();
const long DNodeSelection::ID_STATICTEXT2 = wxNewId();
const long DNodeSelection::ID_TEXTCTRL1 = wxNewId();
const long DNodeSelection::ID_STATICTEXT3 = wxNewId();
const long DNodeSelection::ID_TEXTCTRL2 = wxNewId();
const long DNodeSelection::ID_STATICTEXT4 = wxNewId();
const long DNodeSelection::ID_TEXTCTRL3 = wxNewId();
const long DNodeSelection::ID_BUTTON4 = wxNewId();
const long DNodeSelection::ID_STATICTEXT5 = wxNewId();
const long DNodeSelection::ID_BUTTON1 = wxNewId();
const long DNodeSelection::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DNodeSelection,wxDialog)
	//(*EventTable(DNodeSelection)
	//*)
END_EVENT_TABLE()

DNodeSelection::DNodeSelection(
        wxWindow* parent,
        CMesh* pMesh,
        setUInt& nodeSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_pMesh(pMesh), m_nodeSelection(nodeSelection)
{
	//(*Initialize(DNodeSelection)
	wxFlexGridSizer* FlexGridSizer3;

	Create(parent, id, _("Node Selection"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	MainFlexGridSizer = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer6 = new wxFlexGridSizer(3, 1, 0, 0);
	NodeList = new wxListBox(this, ID_LISTBOX1, wxDefaultPosition, wxDefaultSize, 0, 0, wxLB_EXTENDED|wxSUNKEN_BORDER, wxDefaultValidator, _T("ID_LISTBOX1"));
	NodeList->SetMinSize(wxSize(80,400));
	FlexGridSizer6->Add(NodeList, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	DeleteListButton = new wxButton(this, ID_BUTTON3, _("Delete"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	DeleteListButton->Disable();
	FlexGridSizer6->Add(DeleteListButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ClearListButton = new wxButton(this, ID_BUTTON5, _("Clear List"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON5"));
	ClearListButton->Disable();
	FlexGridSizer6->Add(ClearListButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(FlexGridSizer6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(6, 1, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Select Type:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer4->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	TypeChoice = new wxChoice(this, ID_CHOICE1, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE1"));
	TypeChoice->SetSelection( TypeChoice->Append(_("By Node ID")) );
	TypeChoice->Append(_("By Node ID Range"));
	FlexGridSizer4->Add(TypeChoice, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	wxString __wxRadioBoxChoices_1[2] =
	{
		_("Add"),
		_("Remove")
	};
	AddOrRemove = new wxRadioBox(this, ID_RADIOBOX1, _("Select Action"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, wxRA_VERTICAL, wxDefaultValidator, _T("ID_RADIOBOX1"));
	AddOrRemove->SetSelection(0);
	FlexGridSizer4->Add(AddOrRemove, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1 = new wxFlexGridSizer(3, 2, 0, 0);
	labelOne = new wxStaticText(this, ID_STATICTEXT2, _("Label"), wxDefaultPosition, wxSize(80,-1), 0, _T("ID_STATICTEXT2"));
	FlexGridSizer1->Add(labelOne, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	labelBoxOne = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer1->Add(labelBoxOne, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	labelTwo = new wxStaticText(this, ID_STATICTEXT3, _("Label"), wxDefaultPosition, wxSize(80,-1), 0, _T("ID_STATICTEXT3"));
	FlexGridSizer1->Add(labelTwo, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	labelBoxTwo = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer1->Add(labelBoxTwo, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	labelThree = new wxStaticText(this, ID_STATICTEXT4, _("Label"), wxDefaultPosition, wxSize(80,-1), 0, _T("ID_STATICTEXT4"));
	FlexGridSizer1->Add(labelThree, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	labelBoxThree = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer1->Add(labelBoxThree, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4->Add(FlexGridSizer1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ApplyButton = new wxButton(this, ID_BUTTON4, _("Apply"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
	FlexGridSizer4->Add(ApplyButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	InfoText = new wxStaticText(this, ID_STATICTEXT5, wxEmptyString, wxDefaultPosition, wxSize(220,170), 0, _T("ID_STATICTEXT5"));
	FlexGridSizer4->Add(InfoText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(FlexGridSizer4, 1, wxALL|wxALIGN_TOP|wxALIGN_CENTER_HORIZONTAL, 5);
	MainFlexGridSizer->Add(FlexGridSizer2, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	MainFlexGridSizer->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(MainFlexGridSizer);
	MainFlexGridSizer->Fit(this);
	MainFlexGridSizer->SetSizeHints(this);

	Connect(ID_LISTBOX1,wxEVT_COMMAND_LISTBOX_SELECTED,(wxObjectEventFunction)&DNodeSelection::OnNodeListSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DNodeSelection::OnDeleteListButtonClick);
	Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DNodeSelection::OnClearListButtonClick);
	Connect(ID_CHOICE1,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&DNodeSelection::OnTypeChoiceSelect);
	Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DNodeSelection::OnApplyButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DNodeSelection::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DNodeSelection::OnCancelButtonClick);
	//*)

	// copy external node selection to temporary one
	m_tempSelection = m_nodeSelection;

	// append selection list from selection vector
    updateSelectionList();

    // update type definition boxes
    updateTypeSelection();
}

DNodeSelection::~DNodeSelection()
{
	//(*Destroy(DNodeSelection)
	//*)
}

void DNodeSelection::updateSelectionList()
{
    // append selection list from selection map
    NodeList->Clear();
    for (setUIntIt it=m_tempSelection.begin(); it!=m_tempSelection.end(); it++)
        NodeList->Append(wxString::Format("%i", *it));

    // enable or disable clear list button
    if (!m_tempSelection.empty()) ClearListButton->Enable(true);
    else                          ClearListButton->Enable(false);
}

void DNodeSelection::updateTypeSelection()
{
    // remove any messages from dialog
    InfoText->SetLabel("");

    // check which type is selected and fill appropriate boxes
    if (TypeChoice->GetCurrentSelection() == 0){
        // enable/disable boxes
        labelOne->Enable(true);
        labelTwo->Enable(false);
        labelThree->Enable(false);
        labelBoxOne->Enable(true);
        labelBoxTwo->Enable(false);
        labelBoxThree->Enable(false);
        // name them
        labelOne->SetLabel("ID");
        labelTwo->SetLabel("");
        labelThree->SetLabel("");
    }
    else if (TypeChoice->GetCurrentSelection() == 1){
        // enable/disable boxes
        labelOne->Enable(true);
        labelTwo->Enable(true);
        labelThree->Enable(false);
        labelBoxOne->Enable(true);
        labelBoxTwo->Enable(true);
        labelBoxThree->Enable(false);
        // name them
        labelOne->SetLabel("Starting ID");
        labelTwo->SetLabel("Ending ID");
        labelThree->SetLabel("");
    }
    else{
        // disable all in case not supported option is selected
        labelOne->Enable(false);
        labelTwo->Enable(false);
        labelThree->Enable(false);
        labelBoxOne->Enable(false);
        labelBoxTwo->Enable(false);
        labelBoxThree->Enable(false);
        // clear names
        labelOne->SetLabel("");
        labelTwo->SetLabel("");
        labelThree->SetLabel("");
    }
}

void DNodeSelection::OnNodeListSelect(wxCommandEvent& event)
{
    // enable or disable delete button based on weather selection has been made in selection list
    wxArrayInt dummy;
    if (NodeList->GetSelections(dummy)) DeleteListButton->Enable(true);
    else                                DeleteListButton->Enable(false);
}

void DNodeSelection::OnDeleteListButtonClick(wxCommandEvent& event)
{
    // array of list strings
    wxArrayString allNodes = NodeList->GetStrings();

    // array of selected items
    wxArrayInt selectedIndexes;
    if (!NodeList->GetSelections(selectedIndexes))
        return;

    // remove selected items from selection map
    for (uInt i=0; i<selectedIndexes.GetCount(); i++)
        m_tempSelection.erase(wxAtoi(allNodes[selectedIndexes[i]]));

    // update selection list from selection map
    updateSelectionList();
}

void DNodeSelection::OnClearListButtonClick(wxCommandEvent& event)
{
    // remove any messages from dialog
    InfoText->SetLabel("");

    // clear selection
    m_tempSelection.clear();

    // append selection list from selection vector
    updateSelectionList();

    // enable/disable delete button
    wxCommandEvent dummyEvent;
    OnNodeListSelect(dummyEvent);
}

void DNodeSelection::OnTypeChoiceSelect(wxCommandEvent& event)
{
    updateTypeSelection();
}

void DNodeSelection::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DNodeSelection::OnOKButtonClick(wxCommandEvent& event)
{
    // store temporary selection
    m_nodeSelection = m_tempSelection;

    this->Destroy();
}

void DNodeSelection::OnApplyButtonClick(wxCommandEvent& event)
{
    // remove any messages from dialog
    InfoText->SetLabel("");

    if (TypeChoice->GetCurrentSelection() == 0){
        // read node ID
        long nodeID;
        wxString number = labelBoxOne->GetValue();
        if(!number.ToLong(&nodeID) || nodeID<=0){
            showErrorMessage("Incorrect value for Node ID entered");
            return;
        }

        // check if node (ID) exists in mesh
        if (!m_pMesh->checkIfNodeExists(nodeID)){
            InfoText->SetLabel("Node does not exist");
            return;
        }

        // check if addition or removal
        if (AddOrRemove->GetStringSelection() == "Add"){
            // check if node ID is already in list
            if (m_tempSelection.find(nodeID) != m_tempSelection.end()){
                InfoText->SetLabel("Node is already in selection");
                return;
            }
            m_tempSelection.insert(nodeID);
        }
        else{
            // check if node ID is not in list
            if (m_tempSelection.find(nodeID) == m_tempSelection.end()){
                InfoText->SetLabel("Node is not in selection");
                return;
            }
            m_tempSelection.erase(nodeID);
        }
    }
    else if (TypeChoice->GetCurrentSelection() == 1){
        // read starting ID
        long startID;
        wxString number = labelBoxOne->GetValue();
        if(!number.ToLong(&startID) || startID<=0){
            // incorrect string entered
            showErrorMessage("Incorrect value for starting Node ID entered");
            return;
        }

        // read ending ID
        long endID;
        number = labelBoxTwo->GetValue();
        if(!number.ToLong(&endID) || endID<=startID){
            // incorrect string entered
            showErrorMessage("Incorrect value for ending Node ID entered");
            return;
        }

        // process node ID's
        for (uInt nodeID=uInt(startID); nodeID<=uInt(endID); nodeID++){
            // check if node ID exists in mesh
            if (!m_pMesh->checkIfNodeExists(nodeID))
                continue;

            // add or remove node according to request and nodes existence in list
            if   (AddOrRemove->GetStringSelection() == "Add") m_tempSelection.insert(nodeID);
            else                                              m_tempSelection.erase (nodeID);
        }
    }

    // update selection list
    updateSelectionList();

    // enable/disable delete button
    wxCommandEvent dummyEvent;
    OnNodeListSelect(dummyEvent);
}
