#include "wx_pch.h"
#include "DReferenceValues.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DReferenceValues)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DReferenceValues)
//*)

//(*IdInit(DReferenceValues)
const long DReferenceValues::ID_STATICTEXT8 = wxNewId();
const long DReferenceValues::ID_TEXTCTRL1 = wxNewId();
const long DReferenceValues::ID_STATICTEXT9 = wxNewId();
const long DReferenceValues::ID_TEXTCTRL2 = wxNewId();
const long DReferenceValues::ID_STATICTEXT10 = wxNewId();
const long DReferenceValues::ID_TEXTCTRL3 = wxNewId();
const long DReferenceValues::ID_STATICTEXT1 = wxNewId();
const long DReferenceValues::ID_STATICTEXT2 = wxNewId();
const long DReferenceValues::ID_TEXTCTRL4 = wxNewId();
const long DReferenceValues::ID_STATICTEXT3 = wxNewId();
const long DReferenceValues::ID_TEXTCTRL5 = wxNewId();
const long DReferenceValues::ID_STATICTEXT4 = wxNewId();
const long DReferenceValues::ID_TEXTCTRL6 = wxNewId();
const long DReferenceValues::ID_BUTTON1 = wxNewId();
const long DReferenceValues::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DReferenceValues,wxDialog)
	//(*EventTable(DReferenceValues)
	//*)
END_EVENT_TABLE()

DReferenceValues::DReferenceValues(
        wxWindow* parent,
        bool& modified,
        CProjectData* pProjectData,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pProjectData(pProjectData)
{
	//(*Initialize(DReferenceValues)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer6;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, wxID_ANY, _("Reference Values"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(3, 2, 0, 0);
	StaticText8 = new wxStaticText(this, ID_STATICTEXT8, _("Wingspan"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT8"));
	FlexGridSizer2->Add(StaticText8, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	WingspanBox = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(WingspanBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText9 = new wxStaticText(this, ID_STATICTEXT9, _("Mean Aerodynamic Chord"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT9"));
	FlexGridSizer2->Add(StaticText9, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	MacBox = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer2->Add(MacBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText10 = new wxStaticText(this, ID_STATICTEXT10, _("Surface Area"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT10"));
	FlexGridSizer2->Add(StaticText10, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	SurfaceBox = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer2->Add(SurfaceBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer6->AddGrowableCol(0);
	FlexGridSizer6->AddGrowableRow(0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Origin Coordinates"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer6->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(3, 2, 0, 0);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("x"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer3->Add(StaticText2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	originX = new wxTextCtrl(this, ID_TEXTCTRL4, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
	FlexGridSizer3->Add(originX, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("y"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer3->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	originY = new wxTextCtrl(this, ID_TEXTCTRL5, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
	FlexGridSizer3->Add(originY, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("z"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer3->Add(StaticText4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	originZ = new wxTextCtrl(this, ID_TEXTCTRL6, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
	FlexGridSizer3->Add(originZ, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6->Add(FlexGridSizer3, 1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer6, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(0, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DReferenceValues::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DReferenceValues::OnCancelButtonClick);
	//*)

	// fill Apame data into window
    WingspanBox->WriteText(wxString::Format("%f", m_pProjectData->wingspan));
    MacBox     ->WriteText(wxString::Format("%f", m_pProjectData->mac));
    SurfaceBox ->WriteText(wxString::Format("%f", m_pProjectData->surface));
    originX->WriteText(wxString::Format("%f", m_pProjectData->origin[0]));
    originY->WriteText(wxString::Format("%f", m_pProjectData->origin[1]));
    originZ->WriteText(wxString::Format("%f", m_pProjectData->origin[2]));
}

DReferenceValues::~DReferenceValues()
{
	//(*Destroy(DReferenceValues)
	//*)
}

void DReferenceValues::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DReferenceValues::OnOKButtonClick(wxCommandEvent& event)
{
    // extract variables from boxes
    wxString number = WingspanBox->GetValue();
    double wingspan;
    if(!number.ToDouble(&wingspan)){
        showErrorMessage("Incorrect value for wingspan entered");
        return;
    }
    number = MacBox->GetValue();
    double mac;
    if(!number.ToDouble(&mac)){
        showErrorMessage("Incorrect value for mean aerodynamic chord entered");
        return;
    }
    number = SurfaceBox->GetValue();
    double surface;
    if(!number.ToDouble(&surface)){
        showErrorMessage("Incorrect value for surface area entered");
        return;
    }
    double origin[3];
    number = originX->GetValue();
    if(!number.ToDouble(&origin[0])){
        showErrorMessage("Incorrect value for origin X coordinate entered");
        return;
    }
    number = originY->GetValue();
    if(!number.ToDouble(&origin[1])){
        showErrorMessage("Incorrect value for origin Y coordinate entered");
        return;
    }
    number = originZ->GetValue();
    if(!number.ToDouble(&origin[2])){
        showErrorMessage("Incorrect value for origin Z coordinate entered");
        return;
    }

    m_modified = true;

    // add values to Apame data structure
    m_pProjectData->wingspan = wingspan;
    m_pProjectData->mac = mac;
    m_pProjectData->surface = surface;
    m_pProjectData->origin[0] = origin[0];
    m_pProjectData->origin[1] = origin[1];
    m_pProjectData->origin[2] = origin[2];

    this->Destroy();
}
