#include "wx_pch.h"
#include "DResultsRequest.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DResultsRequest)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DResultsRequest)
#include <wx/button.h>
//*)

//(*IdInit(DResultsRequest)
const long DResultsRequest::ID_CHECKBOX1 = wxNewId();
const long DResultsRequest::ID_CHECKBOX2 = wxNewId();
const long DResultsRequest::ID_CHECKBOX3 = wxNewId();
const long DResultsRequest::ID_CHECKBOX4 = wxNewId();
const long DResultsRequest::ID_CHECKBOX5 = wxNewId();
const long DResultsRequest::ID_CHECKBOX6 = wxNewId();
const long DResultsRequest::ID_CHECKBOX7 = wxNewId();
const long DResultsRequest::ID_CHECKBOX8 = wxNewId();
const long DResultsRequest::ID_CHECKBOX9 = wxNewId();
const long DResultsRequest::ID_CHECKBOX10 = wxNewId();
const long DResultsRequest::ID_CHECKBOX11 = wxNewId();
const long DResultsRequest::ID_CHECKBOX12 = wxNewId();
const long DResultsRequest::ID_CHECKBOX13 = wxNewId();
const long DResultsRequest::ID_CHECKBOX14 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DResultsRequest,wxDialog)
	//(*EventTable(DResultsRequest)
	//*)
END_EVENT_TABLE()

DResultsRequest::DResultsRequest(
        wxWindow* parent,
        bool& modified,
        CProjectData* pProjectData,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pProjectData(pProjectData)
{
	//(*Initialize(DResultsRequest)
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;
	wxStdDialogButtonSizer* StdDialogButtonSizer1;

	Create(parent, id, _("Results Request"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	results = new wxCheckBox(this, ID_CHECKBOX1, _("Write Results File"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	results->SetValue(false);
	FlexGridSizer1->Add(results, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(13, 1, 0, 0);
	coefficients = new wxCheckBox(this, ID_CHECKBOX2, _("Coefficients"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX2"));
	coefficients->SetValue(false);
	FlexGridSizer2->Add(coefficients, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	forces = new wxCheckBox(this, ID_CHECKBOX3, _("Forces"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX3"));
	forces->SetValue(false);
	FlexGridSizer2->Add(forces, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	geometry = new wxCheckBox(this, ID_CHECKBOX4, _("Geometry"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX4"));
	geometry->SetValue(false);
	FlexGridSizer2->Add(geometry, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	velocity = new wxCheckBox(this, ID_CHECKBOX5, _("Velocity"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX5"));
	velocity->SetValue(false);
	FlexGridSizer2->Add(velocity, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	pressureCoefficient = new wxCheckBox(this, ID_CHECKBOX6, _("Pressure Coefficient"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX6"));
	pressureCoefficient->SetValue(false);
	FlexGridSizer2->Add(pressureCoefficient, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	centerPoints = new wxCheckBox(this, ID_CHECKBOX7, _("Center Points"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX7"));
	centerPoints->SetValue(false);
	FlexGridSizer2->Add(centerPoints, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	doubletValues = new wxCheckBox(this, ID_CHECKBOX8, _("Doublet Values"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX8"));
	doubletValues->SetValue(false);
	FlexGridSizer2->Add(doubletValues, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	sourceValues = new wxCheckBox(this, ID_CHECKBOX9, _("Source Values"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX9"));
	sourceValues->SetValue(false);
	FlexGridSizer2->Add(sourceValues, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	velocityComponents = new wxCheckBox(this, ID_CHECKBOX10, _("Velocity Components"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX10"));
	velocityComponents->SetValue(false);
	FlexGridSizer2->Add(velocityComponents, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	meshCharacteristics = new wxCheckBox(this, ID_CHECKBOX11, _("Mesh Characteristics"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX11"));
	meshCharacteristics->SetValue(false);
	FlexGridSizer2->Add(meshCharacteristics, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	staticPressure = new wxCheckBox(this, ID_CHECKBOX12, _("Static Pressure"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX12"));
	staticPressure->SetValue(false);
	FlexGridSizer2->Add(staticPressure, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	dynamicPressure = new wxCheckBox(this, ID_CHECKBOX13, _("Dynamic Pressure"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX13"));
	dynamicPressure->SetValue(false);
	FlexGridSizer2->Add(dynamicPressure, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	manometerPressure = new wxCheckBox(this, ID_CHECKBOX14, _("Manometer Pressure"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX14"));
	manometerPressure->SetValue(false);
	FlexGridSizer2->Add(manometerPressure, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StdDialogButtonSizer1 = new wxStdDialogButtonSizer();
	StdDialogButtonSizer1->AddButton(new wxButton(this, wxID_OK, wxEmptyString));
	StdDialogButtonSizer1->AddButton(new wxButton(this, wxID_CANCEL, wxEmptyString));
	StdDialogButtonSizer1->Realize();
	FlexGridSizer1->Add(StdDialogButtonSizer1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_CHECKBOX1,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DResultsRequest::OnresultsClick);
	//*)

	Connect(wxID_OK,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DResultsRequest::OnOKButtonClick);
	Connect(wxID_CANCEL,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DResultsRequest::OnCancelButtonClick);

    // get bools from project data structure
	results            ->SetValue(m_pProjectData->results);
    coefficients       ->SetValue(m_pProjectData->coefficients);
    forces             ->SetValue(m_pProjectData->forces);
    geometry           ->SetValue(m_pProjectData->geometry);
    velocity           ->SetValue(m_pProjectData->velocity);
    pressureCoefficient->SetValue(m_pProjectData->pressureCoefficient);
    centerPoints       ->SetValue(m_pProjectData->centerPoints);
    doubletValues      ->SetValue(m_pProjectData->doubletValues);
    sourceValues       ->SetValue(m_pProjectData->sourceValues);
    velocityComponents ->SetValue(m_pProjectData->velocityComponents);
    meshCharacteristics->SetValue(m_pProjectData->meshCharacteristics);
    staticPressure     ->SetValue(m_pProjectData->staticPressure);
    dynamicPressure    ->SetValue(m_pProjectData->dynamicPressure);
    manometerPressure  ->SetValue(m_pProjectData->manometerPressure);

    wxCommandEvent dummyEvent;
    OnresultsClick(dummyEvent);
}

DResultsRequest::~DResultsRequest()
{
	//(*Destroy(DResultsRequest)
	//*)
}

void DResultsRequest::OnOKButtonClick(wxCommandEvent& event)
{
    m_modified = true;

    // set bools to project data structure
    m_pProjectData->results             = results             ->GetValue();
    m_pProjectData->coefficients        = coefficients        ->GetValue();
    m_pProjectData->forces              = forces              ->GetValue();
    m_pProjectData->geometry            = geometry            ->GetValue();
    m_pProjectData->velocity            = velocity            ->GetValue();
    m_pProjectData->pressureCoefficient = pressureCoefficient ->GetValue();
    m_pProjectData->centerPoints        = centerPoints        ->GetValue();
    m_pProjectData->doubletValues       = doubletValues       ->GetValue();
    m_pProjectData->sourceValues        = sourceValues        ->GetValue();
    m_pProjectData->velocityComponents  = velocityComponents  ->GetValue();
    m_pProjectData->meshCharacteristics = meshCharacteristics ->GetValue();
    m_pProjectData->staticPressure      = staticPressure      ->GetValue();
    m_pProjectData->dynamicPressure     = dynamicPressure     ->GetValue();
    m_pProjectData->manometerPressure   = manometerPressure   ->GetValue();

    this->Destroy();
}

void DResultsRequest::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DResultsRequest::OnresultsClick(wxCommandEvent& event)
{
    if (results->GetValue()){
        // enable sub results
        coefficients        ->Enable();
        forces              ->Enable();
        geometry            ->Enable();
        velocity            ->Enable();
        pressureCoefficient ->Enable();
        centerPoints        ->Enable();
        doubletValues       ->Enable();
        sourceValues        ->Enable();
        velocityComponents  ->Enable();
        meshCharacteristics ->Enable();
        staticPressure      ->Enable();
        dynamicPressure     ->Enable();
        manometerPressure   ->Enable();
    }
    else{
        // disable sub results
        coefficients        ->Disable();
        forces              ->Disable();
        geometry            ->Disable();
        velocity            ->Disable();
        pressureCoefficient ->Disable();
        centerPoints        ->Disable();
        doubletValues       ->Disable();
        sourceValues        ->Disable();
        velocityComponents  ->Disable();
        meshCharacteristics ->Disable();
        staticPressure      ->Disable();
        dynamicPressure     ->Disable();
        manometerPressure   ->Disable();
    }
}
