#include "wx_pch.h"
#include "DSeparateNeighbors.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DSeparateNeighbors)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DSeparateNeighbors)
//*)

//(*IdInit(DSeparateNeighbors)
const long DSeparateNeighbors::ID_STATICTEXT1 = wxNewId();
const long DSeparateNeighbors::ID_BUTTON3 = wxNewId();
const long DSeparateNeighbors::ID_BUTTON1 = wxNewId();
const long DSeparateNeighbors::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DSeparateNeighbors,wxDialog)
	//(*EventTable(DSeparateNeighbors)
	//*)
END_EVENT_TABLE()

DSeparateNeighbors::DSeparateNeighbors(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        setUInt& nodeSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh), m_nodeSelection(nodeSelection)
{
	//(*Initialize(DSeparateNeighbors)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Separate Neighbors"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer3 = new wxFlexGridSizer(0, 3, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Node Selection"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer3->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON3, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer3->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(0, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSeparateNeighbors::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSeparateNeighbors::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSeparateNeighbors::OnCancelButtonClick);
	//*)

	if (m_nodeSelection.size() < 2) OKButton->Disable();
    else                            OKButton->Enable();
}

DSeparateNeighbors::~DSeparateNeighbors()
{
	//(*Destroy(DSeparateNeighbors)
	//*)
}

void DSeparateNeighbors::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DSeparateNeighbors::OnSelectButtonClick(wxCommandEvent& event)
{
    DNodeSelection* nodeSelection = new DNodeSelection(0, m_pMesh, m_nodeSelection);
    nodeSelection->ShowModal();

	if (m_nodeSelection.size() < 2) OKButton->Disable();
    else                            OKButton->Enable();
}

void DSeparateNeighbors::OnOKButtonClick(wxCommandEvent& event)
{
    m_modified = true;

    m_pMesh->separateAtSeam(m_nodeSelection);

    this->Destroy();
}
