#include "wx_pch.h"
#include "DSettings.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DSettings)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DSettings)
//*)

//(*IdInit(DSettings)
const long DSettings::ID_STATICTEXT1 = wxNewId();
const long DSettings::ID_TEXTCTRL3 = wxNewId();
const long DSettings::ID_BUTTON5 = wxNewId();
const long DSettings::ID_STATICTEXT3 = wxNewId();
const long DSettings::ID_CHECKBOX1 = wxNewId();
const long DSettings::ID_STATICTEXT4 = wxNewId();
const long DSettings::ID_TEXTCTRL6 = wxNewId();
const long DSettings::ID_BUTTON1 = wxNewId();
const long DSettings::ID_STATICTEXT5 = wxNewId();
const long DSettings::ID_TEXTCTRL5 = wxNewId();
const long DSettings::ID_STATICTEXT6 = wxNewId();
const long DSettings::ID_TEXTCTRL7 = wxNewId();
const long DSettings::ID_STATICTEXT7 = wxNewId();
const long DSettings::ID_TEXTCTRL8 = wxNewId();
const long DSettings::ID_STATICTEXT8 = wxNewId();
const long DSettings::ID_TEXTCTRL9 = wxNewId();
const long DSettings::ID_STATICTEXT9 = wxNewId();
const long DSettings::ID_TEXTCTRL10 = wxNewId();
const long DSettings::ID_BUTTON3 = wxNewId();
const long DSettings::ID_BUTTON4 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DSettings,wxDialog)
	//(*EventTable(DSettings)
	//*)
END_EVENT_TABLE()

DSettings::DSettings(
        wxWindow* parent,
        CGUIData* pGUIData,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_pGUIData(pGUIData)
{
	//(*Initialize(DSettings)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer9;
	wxFlexGridSizer* FlexGridSizer7;
	wxFlexGridSizer* FlexGridSizer8;
	wxFlexGridSizer* FlexGridSizer6;
	wxFlexGridSizer* FlexGridSizer1;
	
	Create(parent, wxID_ANY, _("General Settings"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(4, 1, 0, 0);
	FlexGridSizer1->AddGrowableCol(0);
	FlexGridSizer1->AddGrowableRow(0);
	FlexGridSizer5 = new wxFlexGridSizer(3, 1, 0, 0);
	FlexGridSizer6 = new wxFlexGridSizer(4, 3, 0, 0);
	FlexGridSizer6->AddGrowableCol(1);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("ApameSolver path"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer6->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ApameSolverPathBox = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxSize(400,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer6->Add(ApameSolverPathBox, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BrowseApameSolverExeButton = new wxButton(this, ID_BUTTON5, _("Browse"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON5"));
	FlexGridSizer6->Add(BrowseApameSolverExeButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Use temporary directory"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer6->Add(StaticText3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	TempDirCheckBox = new wxCheckBox(this, ID_CHECKBOX1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
	TempDirCheckBox->SetValue(false);
	FlexGridSizer6->Add(TempDirCheckBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer8 = new wxFlexGridSizer(0, 3, 0, 0);
	FlexGridSizer6->Add(FlexGridSizer8, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	TempDirStaticText = new wxStaticText(this, ID_STATICTEXT4, _("Temporary directory"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	TempDirStaticText->Disable();
	FlexGridSizer6->Add(TempDirStaticText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	TempDirBox = new wxTextCtrl(this, ID_TEXTCTRL6, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
	TempDirBox->Disable();
	FlexGridSizer6->Add(TempDirBox, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BrowseTemporaryDirButton = new wxButton(this, ID_BUTTON1, _("Browse"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	BrowseTemporaryDirButton->Disable();
	FlexGridSizer6->Add(BrowseTemporaryDirButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5->Add(FlexGridSizer6, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_TOP, 5);
	FlexGridSizer7 = new wxFlexGridSizer(1, 2, 0, 0);
	StaticText5 = new wxStaticText(this, ID_STATICTEXT5, _("ApameSolver log windows refresh rate"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT5"));
	FlexGridSizer7->Add(StaticText5, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	RefreshRateBox = new wxTextCtrl(this, ID_TEXTCTRL5, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
	FlexGridSizer7->Add(RefreshRateBox, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5->Add(FlexGridSizer7, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_TOP, 5);
	FlexGridSizer9 = new wxFlexGridSizer(4, 2, 0, 0);
	StaticText6 = new wxStaticText(this, ID_STATICTEXT6, _("Angle threshold for separating neighbors"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT6"));
	FlexGridSizer9->Add(StaticText6, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	NeighborThresholdBox = new wxTextCtrl(this, ID_TEXTCTRL7, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL7"));
	FlexGridSizer9->Add(NeighborThresholdBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText7 = new wxStaticText(this, ID_STATICTEXT7, _("Angle threshold for applying Kutta condition"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT7"));
	FlexGridSizer9->Add(StaticText7, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	WakeThresholdBox = new wxTextCtrl(this, ID_TEXTCTRL8, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL8"));
	FlexGridSizer9->Add(WakeThresholdBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText8 = new wxStaticText(this, ID_STATICTEXT8, _("Wake length (in multiples of geometry span)"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT8"));
	FlexGridSizer9->Add(StaticText8, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	WakeLengthBox = new wxTextCtrl(this, ID_TEXTCTRL9, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL9"));
	FlexGridSizer9->Add(WakeLengthBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText9 = new wxStaticText(this, ID_STATICTEXT9, _("Downstream number of wake elements"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT9"));
	FlexGridSizer9->Add(StaticText9, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	WakeNumBox = new wxTextCtrl(this, ID_TEXTCTRL10, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL10"));
	FlexGridSizer9->Add(WakeNumBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5->Add(FlexGridSizer9, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_TOP, 5);
	FlexGridSizer1->Add(FlexGridSizer5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(0, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON3, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON4, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	ApameSolverPathDialog = new wxFileDialog(this, _("Select ApameSolver Executable"), wxEmptyString, wxEmptyString, _("Executables (*.exe)|*.exe"), wxFD_FILE_MUST_EXIST, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	#ifndef WIN32
	ApameSolverPathDialog->SetWildcard(_("Executable (*)|*"));
	#endif
	TemporaryDirDialog = new wxDirDialog(this, _("Select Temporary Directory"), wxEmptyString, wxDD_DEFAULT_STYLE|wxDD_DIR_MUST_EXIST, wxDefaultPosition, wxDefaultSize, _T("wxDirDialog"));
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);
	
	Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSettings::OnBrowseApameSolverPathButtonClick);
	Connect(ID_CHECKBOX1,wxEVT_COMMAND_CHECKBOX_CLICKED,(wxObjectEventFunction)&DSettings::OnTempDirCheckBoxClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSettings::OnBrowseTemporaryDirButtonClick);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSettings::OnOKButtonClick);
	Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSettings::OnCancelButtonClick);
	//*)

	// fill ApameSolver path
	ApameSolverPathBox->SetValue(str2Wxs(m_pGUIData->apameSolverPath));

    // enable or disable check box for working directory
    if (m_pGUIData->useTempDir) TempDirCheckBox->SetValue(true);
    else                        TempDirCheckBox->SetValue(false);

	// fill temporary directory path
	TempDirBox->SetValue(str2Wxs(m_pGUIData->tempDir));

	// enable or disable temporary directory box
    wxCommandEvent dummyEvent;
    OnTempDirCheckBoxClick(dummyEvent);

    // fill other boxes
    RefreshRateBox      ->SetValue(wxString::Format("%i", m_pGUIData->logWinRefreshRate));
    NeighborThresholdBox->SetValue(wxString::Format("%f", m_pGUIData->neighThreshold));
    WakeThresholdBox    ->SetValue(wxString::Format("%f", m_pGUIData->wakeThreshold));
    WakeLengthBox       ->SetValue(wxString::Format("%f", m_pGUIData->wakeLength));
    WakeNumBox          ->SetValue(wxString::Format("%i", m_pGUIData->wakeNum));
}

DSettings::~DSettings()
{
	//(*Destroy(DSettings)
	//*)
}

void DSettings::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DSettings::OnTempDirCheckBoxClick(wxCommandEvent& event)
{
    if (TempDirCheckBox->IsChecked()){
        TempDirBox->SetEditable(true);
        TempDirBox->Enable();
        TempDirStaticText->Enable();
        BrowseTemporaryDirButton->Enable();
    }
    else{
        TempDirBox->SetEditable(false);
        TempDirBox->Disable();
        TempDirStaticText->Disable();
        BrowseTemporaryDirButton->Disable();
    }
}

void DSettings::OnBrowseApameSolverPathButtonClick(wxCommandEvent& event)
{
    // get ApameSolver path from file dialog
    if (ApameSolverPathDialog->ShowModal() == wxID_OK)
        ApameSolverPathBox->SetValue(ApameSolverPathDialog->GetPath());
}

void DSettings::OnBrowseTemporaryDirButtonClick(wxCommandEvent& event)
{
    // get temporary directory path from file dialog
    if (TemporaryDirDialog->ShowModal() == wxID_OK)
        TempDirBox->SetValue(TemporaryDirDialog->GetPath());
}

void DSettings::OnOKButtonClick(wxCommandEvent& event)
{
    // store ApameSolver path
    m_pGUIData->apameSolverPath = wxs2Str(ApameSolverPathBox->GetValue());

    // store temporary directory flag
    if (TempDirCheckBox->IsChecked()) m_pGUIData->useTempDir = 1;
    else                              m_pGUIData->useTempDir = 0;

    // store temporary directory
    m_pGUIData->tempDir = wxs2Str(TempDirBox->GetValue());

    // store log window refresh rate
    m_pGUIData->logWinRefreshRate = wxAtoi(RefreshRateBox->GetValue());

    // store neighbor threshold
    NeighborThresholdBox->GetValue().ToDouble(&m_pGUIData->neighThreshold);

    // store wake threshold
    WakeThresholdBox->GetValue().ToDouble(&m_pGUIData->wakeThreshold);

    // store wake length
    WakeLengthBox->GetValue().ToDouble(&m_pGUIData->wakeLength);

    // store wake number
    m_pGUIData->wakeNum = wxAtoi(WakeNumBox->GetValue());

    this->Destroy();
}
