#include "wx_pch.h"
#include "DSimpleMessage.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DSimpleMessage)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DSimpleMessage)
//*)

//(*IdInit(DSimpleMessage)
const long DSimpleMessage::ID_STATICTEXT1 = wxNewId();
const long DSimpleMessage::ID_BUTTON1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DSimpleMessage,wxDialog)
	//(*EventTable(DSimpleMessage)
	//*)
END_EVENT_TABLE()

DSimpleMessage::DSimpleMessage(
        wxWindow* parent,
        wxString& message,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_message(message)
{
	//(*Initialize(DSimpleMessage)
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Message"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION|wxRESIZE_BORDER, _T("id"));
	FlexGridSizer1 = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer1->AddGrowableCol(0);
	FlexGridSizer1->AddGrowableRow(0);
	errorMessage = new wxStaticText(this, ID_STATICTEXT1, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE, _T("ID_STATICTEXT1"));
	FlexGridSizer1->Add(errorMessage, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer1->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);
	Center();

	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSimpleMessage::OnOKButtonClick);
	//*)

	errorMessage->SetLabel(m_message);
	FlexGridSizer1->Fit(this);
}

DSimpleMessage::~DSimpleMessage()
{
	//(*Destroy(DSimpleMessage)
	//*)
}

void DSimpleMessage::OnOKButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

//-----------------------------------------------------------------------/
// displays error message
//-----------------------------------------------------------------------/
void showErrorMessage(const string& message)
{
    wxString wxMessage = str2Wxs(message);
    DSimpleMessage* simpleMessage = new DSimpleMessage(0, wxMessage);
    simpleMessage->SetTitle("Error");
    simpleMessage->ShowModal();
}

//-----------------------------------------------------------------------/
// displays warning message
//-----------------------------------------------------------------------/
void showWarningMessage(const string& message)
{
    wxString wxMessage = str2Wxs(message);
    DSimpleMessage* simpleMessage = new DSimpleMessage(0, wxMessage);
    simpleMessage->SetTitle("Warning");
    simpleMessage->ShowModal();
}

//-----------------------------------------------------------------------/
// displays information message
//-----------------------------------------------------------------------/
void showInfoMessage(const string& message)
{
    wxString wxMessage = str2Wxs(message);
    DSimpleMessage* simpleMessage = new DSimpleMessage(0, wxMessage);
    simpleMessage->SetTitle("Information");
    simpleMessage->ShowModal();
}

//-----------------------------------------------------------------------/
// shows error message with line index
//-----------------------------------------------------------------------/
void showLineErrorMessage(const string& message, const uInt& lineIndex)
{
    wxString wxMessage = str2Wxs(message+"\nError at line "+int2Str(lineIndex));
    DSimpleMessage* simpleMessage = new DSimpleMessage(0, wxMessage);
    simpleMessage->SetTitle("Error");
    simpleMessage->ShowModal();
}

//-----------------------------------------------------------------------/
// checks if end of file will happen with given numbers of lines (numSkip)
//-----------------------------------------------------------------------/
int checkEndOfFile(
        const uInt& numSkip,
        const uInt& lineIndex,
        const uInt& numLines)
{
    if (lineIndex+numSkip >= numLines){
        showLineErrorMessage("Unexpected end of file", lineIndex+1);
        return -1;
    }

    return 0;
}
