#include "wx_pch.h"
#include "DSolverParams.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DSolverParams)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DSolverParams)
//*)

//(*IdInit(DSolverParams)
const long DSolverParams::ID_RADIOBOX1 = wxNewId();
const long DSolverParams::ID_RADIOBOX2 = wxNewId();
const long DSolverParams::ID_RADIOBOX3 = wxNewId();
const long DSolverParams::ID_STATICTEXT1 = wxNewId();
const long DSolverParams::ID_TEXTCTRL1 = wxNewId();
const long DSolverParams::ID_STATICTEXT2 = wxNewId();
const long DSolverParams::ID_TEXTCTRL2 = wxNewId();
const long DSolverParams::ID_STATICTEXT3 = wxNewId();
const long DSolverParams::ID_TEXTCTRL3 = wxNewId();
const long DSolverParams::ID_BUTTON1 = wxNewId();
const long DSolverParams::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DSolverParams,wxDialog)
	//(*EventTable(DSolverParams)
	//*)
END_EVENT_TABLE()

DSolverParams::DSolverParams(
        wxWindow* parent,
        bool& modified,
        CProjectData* pProjectData,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pProjectData(pProjectData)
{
	//(*Initialize(DSolverParams)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, wxID_ANY, _("Solver Parameters"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 3, 0, 0);
	wxString __wxRadioBoxChoices_1[2] =
	{
		_("Constant Source/Doublet"),
		_("Constant Doublet")
	};
	MethodBox = new wxRadioBox(this, ID_RADIOBOX1, _("Singularity Method"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, wxRA_HORIZONTAL, wxDefaultValidator, _T("ID_RADIOBOX1"));
	MethodBox->SetSelection(0);
	FlexGridSizer2->Add(MethodBox, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	wxString __wxRadioBoxChoices_2[3] =
	{
		_("Nodal"),
		_("First Order Neighbors"),
		_("Second Order Neighbors")
	};
	VelorderBox = new wxRadioBox(this, ID_RADIOBOX2, _("Velocity Interpolation Method"), wxDefaultPosition, wxDefaultSize, 3, __wxRadioBoxChoices_2, 1, wxRA_HORIZONTAL, wxDefaultValidator, _T("ID_RADIOBOX2"));
	VelorderBox->SetSelection(0);
	FlexGridSizer2->Add(VelorderBox, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	wxString __wxRadioBoxChoices_3[2] =
	{
		_("Approximative"),
		_("Accurate")
	};
	CollcalcBox = new wxRadioBox(this, ID_RADIOBOX3, _("Collocation Point Calculation"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_3, 1, wxRA_HORIZONTAL, wxDefaultValidator, _T("ID_RADIOBOX3"));
	CollcalcBox->SetSelection(0);
	FlexGridSizer2->Add(CollcalcBox, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(3, 2, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Farfield Distance"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer3->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FarfieldBox = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer3->Add(FarfieldBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Collocation Point Depth"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer3->Add(StaticText2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ColldistBox = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer3->Add(ColldistBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Small Value/Distance"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer3->Add(StaticText3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ErrorBox = new wxTextCtrl(this, ID_TEXTCTRL3, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer3->Add(ErrorBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSolverParams::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DSolverParams::OnCancelButtonClick);
	//*)

    // fill project data into dialog
    FarfieldBox->WriteText(wxString::Format("%f", m_pProjectData->farField));
    ColldistBox->WriteText(wxString::Format("%e", m_pProjectData->collDist));
    ErrorBox   ->WriteText(wxString::Format("%e", m_pProjectData->error));

    // singularity method
    if (m_pProjectData->method == 0) MethodBox->SetSelection(0);
    else                             MethodBox->SetSelection(1);

    // velocity interpolation order
    if      (m_pProjectData->velOrder == 0) VelorderBox->SetSelection(0);
    else if (m_pProjectData->velOrder == 1) VelorderBox->SetSelection(1);
    else                                    VelorderBox->SetSelection(2);

    // collocation point calculation
    if (m_pProjectData->collCalc == 0) CollcalcBox->SetSelection(0);
    else                               CollcalcBox->SetSelection(1);
}

DSolverParams::~DSolverParams()
{
	//(*Destroy(DSolverParams)
	//*)
}

void DSolverParams::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DSolverParams::OnOKButtonClick(wxCommandEvent& event)
{
    // extract variables from boxes
    wxString number = FarfieldBox->GetValue();
    double farfield;
    if(!number.ToDouble(&farfield)){
        showErrorMessage("Incorrect value for far field distance entered");
        return;
    }
    number = ColldistBox->GetValue();
    double colldist;
    if(!number.ToDouble(&colldist)){
        showErrorMessage("Incorrect value for collocation point depth entered");
        return;
    }
    number = ErrorBox->GetValue();
    double error;
    if(!number.ToDouble(&error)){
        showErrorMessage("Incorrect value for small value/distance entered");
        return;
    }

    m_modified = true;

    // add values to project data structure
    m_pProjectData->method   = MethodBox->GetSelection();
    m_pProjectData->velOrder = VelorderBox->GetSelection();
    m_pProjectData->collCalc = CollcalcBox->GetSelection();
    m_pProjectData->farField = farfield;
    m_pProjectData->collDist = colldist;
    m_pProjectData->error    = error;

    this->Destroy();
}
