#include "wx_pch.h"
#include "DTransformMirror.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DTransformMirror)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DTransformMirror)
//*)

//(*IdInit(DTransformMirror)
const long DTransformMirror::ID_BUTTON3 = wxNewId();
const long DTransformMirror::ID_BUTTON4 = wxNewId();
const long DTransformMirror::ID_BUTTON5 = wxNewId();
const long DTransformMirror::ID_STATICTEXT1 = wxNewId();
const long DTransformMirror::ID_TEXTCTRL1 = wxNewId();
const long DTransformMirror::ID_TEXTCTRL2 = wxNewId();
const long DTransformMirror::ID_TEXTCTRL3 = wxNewId();
const long DTransformMirror::ID_STATICTEXT2 = wxNewId();
const long DTransformMirror::ID_TEXTCTRL4 = wxNewId();
const long DTransformMirror::ID_TEXTCTRL5 = wxNewId();
const long DTransformMirror::ID_TEXTCTRL6 = wxNewId();
const long DTransformMirror::ID_RADIOBOX1 = wxNewId();
const long DTransformMirror::ID_BUTTON6 = wxNewId();
const long DTransformMirror::ID_BUTTON1 = wxNewId();
const long DTransformMirror::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DTransformMirror,wxDialog)
	//(*EventTable(DTransformMirror)
	//*)
END_EVENT_TABLE()

DTransformMirror::DTransformMirror(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        setUInt& elemSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh), m_elemSelection(elemSelection)
{
	//(*Initialize(DTransformMirror)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer9;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Mirror Mesh"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("id"));
	SetClientSize(wxDefaultSize);
	Move(wxDefaultPosition);
	FlexGridSizer1 = new wxFlexGridSizer(4, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(1, 3, 0, 0);
	ZXButton = new wxButton(this, ID_BUTTON3, _("ZX Plane"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer2->Add(ZXButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	XYButton = new wxButton(this, ID_BUTTON4, _("XY Plane"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
	FlexGridSizer2->Add(XYButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	YZButton = new wxButton(this, ID_BUTTON5, _("YZ Plane"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON5"));
	FlexGridSizer2->Add(YZButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(2, 4, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Vector Origin"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer3->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	OriginX = new wxTextCtrl(this, ID_TEXTCTRL1, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer3->Add(OriginX, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	OriginY = new wxTextCtrl(this, ID_TEXTCTRL2, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer3->Add(OriginY, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	OriginZ = new wxTextCtrl(this, ID_TEXTCTRL3, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer3->Add(OriginZ, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Vector Tip"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer3->Add(StaticText2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	TipX = new wxTextCtrl(this, ID_TEXTCTRL4, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
	FlexGridSizer3->Add(TipX, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	TipY = new wxTextCtrl(this, ID_TEXTCTRL5, _("1"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
	FlexGridSizer3->Add(TipY, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	TipZ = new wxTextCtrl(this, ID_TEXTCTRL6, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
	FlexGridSizer3->Add(TipZ, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer9 = new wxFlexGridSizer(1, 2, 0, 0);
	wxString __wxRadioBoxChoices_1[2] =
	{
		_("Whole Mesh"),
		_("Element Selection")
	};
	DomainRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Select Domain"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	DomainRadioBox->SetSelection(0);
	FlexGridSizer9->Add(DomainRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON6, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON6"));
	SelectButton->Disable();
	FlexGridSizer9->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer9, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformMirror::OnZXButtonClick);
	Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformMirror::OnXYButtonClick);
	Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformMirror::OnYZButtonClick);
	Connect(ID_RADIOBOX1,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DTransformMirror::OnDomainRadioBoxSelect);
	Connect(ID_BUTTON6,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformMirror::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformMirror::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformMirror::OnCancelButtonClick);
	//*)
}

DTransformMirror::~DTransformMirror()
{
	//(*Destroy(DTransformMirror)
	//*)
}

void DTransformMirror::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DTransformMirror::OnDomainRadioBoxSelect(wxCommandEvent& event)
{
    // enable/disable select button
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))
        SelectButton->Enable(false);
    else
        SelectButton->Enable(true);
}

void DTransformMirror::OnSelectButtonClick(wxCommandEvent& event)
{
    DElemSelection* elemSelection = new DElemSelection(0, m_pMesh, m_elemSelection);
    elemSelection->ShowModal();
}

void DTransformMirror::OnZXButtonClick(wxCommandEvent& event)
{
    OriginX->SetValue("0");
    OriginY->SetValue("0");
    OriginZ->SetValue("0");
    TipX->SetValue("0");
    TipY->SetValue("1");
    TipZ->SetValue("0");
}

void DTransformMirror::OnXYButtonClick(wxCommandEvent& event)
{
    OriginX->SetValue("0");
    OriginY->SetValue("0");
    OriginZ->SetValue("0");
    TipX->SetValue("0");
    TipY->SetValue("0");
    TipZ->SetValue("1");
}

void DTransformMirror::OnYZButtonClick(wxCommandEvent& event)
{
    OriginX->SetValue("0");
    OriginY->SetValue("0");
    OriginZ->SetValue("0");
    TipX->SetValue("1");
    TipY->SetValue("0");
    TipZ->SetValue("0");
}

void DTransformMirror::OnOKButtonClick(wxCommandEvent& event)
{
    // get vector origin
    double origin[3];
    wxString number = OriginX->GetValue();
    if(!number.ToDouble(&origin[0])){
        showErrorMessage("Incorrect value for X origin entered");
        return;
    }
    number = OriginY->GetValue();
    if(!number.ToDouble(&origin[1])){
        showErrorMessage("Incorrect value for Y origin entered");
        return;
    }
    number = OriginZ->GetValue();
    if(!number.ToDouble(&origin[2])){
        showErrorMessage("Incorrect value for Z origin entered");
        return;
    }

    // get vector tip
    double tip[3];
    number = TipX->GetValue();
    if(!number.ToDouble(&tip[0])){
        showErrorMessage("Incorrect value for X tip entered");
        return;
    }
    number = TipY->GetValue();
    if(!number.ToDouble(&tip[1])){
        showErrorMessage("Incorrect value for Y tip entered");
        return;
    }
    number = TipZ->GetValue();
    if(!number.ToDouble(&tip[2])){
        showErrorMessage("Incorrect value for Z tip entered");
        return;
    }

    if (origin[0]==tip[0] && origin[1]==tip[1] && origin[2]==tip[2]){
        showErrorMessage("Vector origin and tip are coincident");
        return;
    }

    m_modified = true;

    // mirror mesh
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh")) m_pMesh->mirror(origin, tip);
    else                                                         m_pMesh->mirror(origin, tip, m_elemSelection);

    this->Destroy();
}
