#include "wx_pch.h"
#include "DTransformRotate.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DTransformRotate)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DTransformRotate)
//*)

//(*IdInit(DTransformRotate)
const long DTransformRotate::ID_STATICTEXT1 = wxNewId();
const long DTransformRotate::ID_TEXTCTRL1 = wxNewId();
const long DTransformRotate::ID_STATICTEXT2 = wxNewId();
const long DTransformRotate::ID_STATICTEXT8 = wxNewId();
const long DTransformRotate::ID_TEXTCTRL10 = wxNewId();
const long DTransformRotate::ID_TEXTCTRL9 = wxNewId();
const long DTransformRotate::ID_TEXTCTRL8 = wxNewId();
const long DTransformRotate::ID_STATICTEXT12 = wxNewId();
const long DTransformRotate::ID_TEXTCTRL11 = wxNewId();
const long DTransformRotate::ID_TEXTCTRL12 = wxNewId();
const long DTransformRotate::ID_TEXTCTRL13 = wxNewId();
const long DTransformRotate::ID_RADIOBOX1 = wxNewId();
const long DTransformRotate::ID_BUTTON3 = wxNewId();
const long DTransformRotate::ID_BUTTON1 = wxNewId();
const long DTransformRotate::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DTransformRotate,wxDialog)
	//(*EventTable(DTransformRotate)
	//*)
END_EVENT_TABLE()

DTransformRotate::DTransformRotate(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        setUInt& nodeSelection,
        setUInt& elemSelection,
        wxWindowID id,
        const wxPoint& pos,
        const wxSize& size) : m_modified(modified), m_pMesh(pMesh), m_nodeSelection(nodeSelection), m_elemSelection(elemSelection)
{
	//(*Initialize(DTransformRotate)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer7;
	wxFlexGridSizer* FlexGridSizer6;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, wxID_ANY, _("Rotate Mesh"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(3, 1, 0, 0);
	FlexGridSizer2 = new wxFlexGridSizer(2, 1, 0, 0);
	FlexGridSizer5 = new wxFlexGridSizer(1, 2, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Angle"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer5->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Angle = new wxTextCtrl(this, ID_TEXTCTRL1, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer5->Add(Angle, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(FlexGridSizer5, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6 = new wxFlexGridSizer(2, 1, 0, 0);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("Rotation Axis Vector Definition"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer6->Add(StaticText2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer7 = new wxFlexGridSizer(2, 4, 0, 0);
	StaticText8 = new wxStaticText(this, ID_STATICTEXT8, _("Start"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT8"));
	FlexGridSizer7->Add(StaticText8, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	XStart = new wxTextCtrl(this, ID_TEXTCTRL10, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL10"));
	FlexGridSizer7->Add(XStart, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	YStart = new wxTextCtrl(this, ID_TEXTCTRL9, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL9"));
	FlexGridSizer7->Add(YStart, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ZStart = new wxTextCtrl(this, ID_TEXTCTRL8, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL8"));
	FlexGridSizer7->Add(ZStart, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText12 = new wxStaticText(this, ID_STATICTEXT12, _("End"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT12"));
	FlexGridSizer7->Add(StaticText12, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	XEnd = new wxTextCtrl(this, ID_TEXTCTRL11, _("1"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL11"));
	FlexGridSizer7->Add(XEnd, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	YEnd = new wxTextCtrl(this, ID_TEXTCTRL12, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL12"));
	FlexGridSizer7->Add(YEnd, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ZEnd = new wxTextCtrl(this, ID_TEXTCTRL13, _("0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL13"));
	FlexGridSizer7->Add(ZEnd, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6->Add(FlexGridSizer7, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2->Add(FlexGridSizer6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	wxString __wxRadioBoxChoices_1[3] =
	{
		_("Whole Mesh"),
		_("Node Selection"),
		_("Element Selection")
	};
	DomainRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Select Domain"), wxDefaultPosition, wxDefaultSize, 3, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	DomainRadioBox->SetSelection(0);
	FlexGridSizer3->Add(DomainRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON3, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	FlexGridSizer3->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(0, 3, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer4->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer4->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_RADIOBOX1,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DTransformRotate::OnDomainRadioBoxSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformRotate::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformRotate::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformRotate::OnCancelButtonClick);
	//*)
}

DTransformRotate::~DTransformRotate()
{
	//(*Destroy(DTransformRotate)
	//*)
}

void DTransformRotate::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DTransformRotate::OnSelectButtonClick(wxCommandEvent& event)
{
    if (DomainRadioBox->GetStringSelection() == _("Node Selection")){
        DNodeSelection* nodeSelection = new DNodeSelection(0, m_pMesh, m_nodeSelection);
        nodeSelection->ShowModal();
    }
    else{
        DElemSelection* elemSelection = new DElemSelection(0, m_pMesh, m_elemSelection);
        elemSelection->ShowModal();
    }
}

void DTransformRotate::OnDomainRadioBoxSelect(wxCommandEvent& event)
{
    // enable/disable select button
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))
        SelectButton->Enable(false);
    else
        SelectButton->Enable(true);
}

void DTransformRotate::OnOKButtonClick(wxCommandEvent& event)
{
    // get data from boxes
    double angle;
    double origin[3], tip[3];
    wxString number;

    // get angle value
    number = Angle->GetValue();
    if(!number.ToDouble(&angle)){
        showErrorMessage("Incorrect value for angle entered");
        return;
    }
    // transform to radians
    angle *= pi/180;

    // get origin coordinates
    number = XStart->GetValue();
    if(!number.ToDouble(&origin[0])){
        showErrorMessage("Incorrect value for X origin entered");
        return;
    }
    number = YStart->GetValue();
    if(!number.ToDouble(&origin[1])){
        showErrorMessage("Incorrect value for Y origin entered");
        return;
    }
    number = ZStart->GetValue();
    if(!number.ToDouble(&origin[2])){
        showErrorMessage("Incorrect value for Z origin entered");
        return;
    }

    // get tip coordinates
    number = XEnd->GetValue();
    if(!number.ToDouble(&tip[0])){
        showErrorMessage("Incorrect value for X tip entered");
        return;
    }
    number = YEnd->GetValue();
    if(!number.ToDouble(&tip[1])){
        showErrorMessage("Incorrect value for Y tip entered");
        return;
    }
    number = ZEnd->GetValue();
    if(!number.ToDouble(&tip[2])){
        showErrorMessage("Incorrect value for Z tip entered");
        return;
    }

    m_modified = true;

    // scale according to selection
    if      (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))     m_pMesh->rotate(angle, origin, tip);
    else if (DomainRadioBox->GetStringSelection() == _("Node Selection")) m_pMesh->rotate(angle, origin, tip, m_nodeSelection);
    else                                                                  m_pMesh->rotate(angle, origin, tip, setUInt(), m_elemSelection);

    this->Destroy();
}
