#include "wx_pch.h"
#include "DTransformScale.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DTransformScale)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DTransformScale)
//*)

//(*IdInit(DTransformScale)
const long DTransformScale::ID_RADIOBOX1 = wxNewId();
const long DTransformScale::ID_STATICTEXT3 = wxNewId();
const long DTransformScale::ID_STATICTEXT4 = wxNewId();
const long DTransformScale::ID_TEXTCTRL2 = wxNewId();
const long DTransformScale::ID_STATICTEXT5 = wxNewId();
const long DTransformScale::ID_TEXTCTRL3 = wxNewId();
const long DTransformScale::ID_STATICTEXT6 = wxNewId();
const long DTransformScale::ID_TEXTCTRL4 = wxNewId();
const long DTransformScale::ID_STATICTEXT1 = wxNewId();
const long DTransformScale::ID_STATICTEXT2 = wxNewId();
const long DTransformScale::ID_TEXTCTRL1 = wxNewId();
const long DTransformScale::ID_STATICTEXT7 = wxNewId();
const long DTransformScale::ID_TEXTCTRL5 = wxNewId();
const long DTransformScale::ID_STATICTEXT8 = wxNewId();
const long DTransformScale::ID_TEXTCTRL6 = wxNewId();
const long DTransformScale::ID_RADIOBOX2 = wxNewId();
const long DTransformScale::ID_BUTTON3 = wxNewId();
const long DTransformScale::ID_BUTTON1 = wxNewId();
const long DTransformScale::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DTransformScale,wxDialog)
	//(*EventTable(DTransformScale)
	//*)
END_EVENT_TABLE()

DTransformScale::DTransformScale(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        setUInt& nodeSelection,
        setUInt& elemSelection,
        wxWindowID id) : m_modified(modified), m_pMesh(pMesh), m_nodeSelection(nodeSelection), m_elemSelection(elemSelection)
{
	//(*Initialize(DTransformScale)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer5;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer7;
	wxFlexGridSizer* FlexGridSizer8;
	wxFlexGridSizer* FlexGridSizer6;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, wxID_ANY, _("Scale Mesh"), wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxCAPTION, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(4, 1, 0, 0);
	wxString __wxRadioBoxChoices_1[2] =
	{
		_("Uniform Scaling"),
		_("Axis Specific")
	};
	RadioBoxType = new wxRadioBox(this, ID_RADIOBOX1, _("Check Type"), wxDefaultPosition, wxDefaultSize, 2, __wxRadioBoxChoices_1, 1, wxRA_HORIZONTAL, wxDefaultValidator, _T("ID_RADIOBOX1"));
	RadioBoxType->SetSelection(0);
	FlexGridSizer1->Add(RadioBoxType, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	FlexGridSizer5 = new wxFlexGridSizer(2, 1, 0, 0);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Ratios"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer5->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer6 = new wxFlexGridSizer(3, 2, 0, 0);
	StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("X"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer6->Add(StaticText4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	XRatio = new wxTextCtrl(this, ID_TEXTCTRL2, _("1."), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer6->Add(XRatio, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText5 = new wxStaticText(this, ID_STATICTEXT5, _("Y"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT5"));
	FlexGridSizer6->Add(StaticText5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	YRatio = new wxTextCtrl(this, ID_TEXTCTRL3, _("1."), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	YRatio->Disable();
	FlexGridSizer6->Add(YRatio, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText6 = new wxStaticText(this, ID_STATICTEXT6, _("Z"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT6"));
	FlexGridSizer6->Add(StaticText6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ZRatio = new wxTextCtrl(this, ID_TEXTCTRL4, _("1."), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL4"));
	ZRatio->Disable();
	FlexGridSizer6->Add(ZRatio, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer5->Add(FlexGridSizer6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3->Add(FlexGridSizer5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer7 = new wxFlexGridSizer(2, 1, 0, 0);
	CenterStaticText = new wxStaticText(this, ID_STATICTEXT1, _("Scale About"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer7->Add(CenterStaticText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer8 = new wxFlexGridSizer(3, 2, 0, 0);
	XCenterText = new wxStaticText(this, ID_STATICTEXT2, _("X"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer8->Add(XCenterText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	XCenter = new wxTextCtrl(this, ID_TEXTCTRL1, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer8->Add(XCenter, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	YCenterText = new wxStaticText(this, ID_STATICTEXT7, _("Y"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT7"));
	FlexGridSizer8->Add(YCenterText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	YCenter = new wxTextCtrl(this, ID_TEXTCTRL5, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL5"));
	FlexGridSizer8->Add(YCenter, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ZCenterText = new wxStaticText(this, ID_STATICTEXT8, _("Z"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT8"));
	FlexGridSizer8->Add(ZCenterText, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ZCenter = new wxTextCtrl(this, ID_TEXTCTRL6, _("0.0"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL6"));
	FlexGridSizer8->Add(ZCenter, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer7->Add(FlexGridSizer8, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3->Add(FlexGridSizer7, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	wxString __wxRadioBoxChoices_2[3] =
	{
		_("Whole Mesh"),
		_("Node Selection"),
		_("Element Selection")
	};
	DomainRadioBox = new wxRadioBox(this, ID_RADIOBOX2, _("Select Domain"), wxDefaultPosition, wxDefaultSize, 3, __wxRadioBoxChoices_2, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX2"));
	DomainRadioBox->SetSelection(0);
	FlexGridSizer4->Add(DomainRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON3, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	SelectButton->Disable();
	FlexGridSizer4->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer2->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer2->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_RADIOBOX1,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DTransformScale::OnRadioBoxTypeSelect);
	Connect(ID_RADIOBOX2,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DTransformScale::OnDomainRadioBoxSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformScale::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformScale::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformScale::OnCancelButtonClick);
	//*)
}

DTransformScale::~DTransformScale()
{
	//(*Destroy(DTransformScale)
	//*)
}

void DTransformScale::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DTransformScale::OnRadioBoxTypeSelect(wxCommandEvent& event)
{
    if (RadioBoxType->GetStringSelection() == _("Uniform Scaling")){
        YRatio->Enable(false);
        ZRatio->Enable(false);
    }
    else{
        YRatio->Enable(true);
        ZRatio->Enable(true);
    }
}

void DTransformScale::OnSelectButtonClick(wxCommandEvent& event)
{
    if (DomainRadioBox->GetStringSelection() == _("Node Selection")){
        DNodeSelection* nodeSelection = new DNodeSelection(0, m_pMesh, m_nodeSelection);
        nodeSelection->ShowModal();
    }
    else{
        DElemSelection* elemSelection = new DElemSelection(0, m_pMesh, m_elemSelection);
        elemSelection->ShowModal();
    }
}

void DTransformScale::OnDomainRadioBoxSelect(wxCommandEvent& event)
{
    // enable/disable select button
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))
        SelectButton->Enable(false);
    else
        SelectButton->Enable(true);
}

void DTransformScale::OnOKButtonClick(wxCommandEvent& event)
{
    // get scaling ratios
    wxString number;
    double ratio[3];
    if (RadioBoxType->GetStringSelection() == _("Uniform Scaling")){
        // uniform scaling -> use only X ratio
        number = XRatio->GetValue();
        if (!number.ToDouble(&ratio[0])){
            showErrorMessage("Incorrect value for ratio entered");
            return;
        }
        ratio[1] = ratio[0];
        ratio[2] = ratio[0];
    }
    else{
        number = XRatio->GetValue();
        if (!number.ToDouble(&ratio[0])){
            showErrorMessage("Incorrect value for X ratio entered");
            return;
        }
        number = YRatio->GetValue();
        if (!number.ToDouble(&ratio[1])){
            showErrorMessage("Incorrect value for Y ratio entered");
            return;
        }
        number = ZRatio->GetValue();
        if (!number.ToDouble(&ratio[2])){
            showErrorMessage("Incorrect value for Z ratio entered");
            return;
        }
    }

    // get scaling origin
    double origin[3];
    number = XCenter->GetValue();
    if (!number.ToDouble(&origin[0])){
        showErrorMessage("Incorrect value for X origin entered");
        return;
    }
    number = YCenter->GetValue();
    if (!number.ToDouble(&origin[1])){
        showErrorMessage("Incorrect value for Y origin entered");
        return;
    }
    number = ZCenter->GetValue();
    if (!number.ToDouble(&origin[2])){
        showErrorMessage("Incorrect value for Z origin entered");
        return;
    }

    m_modified = true;

    // scale according to selection
    if      (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))     m_pMesh->scale(ratio, origin);
    else if (DomainRadioBox->GetStringSelection() == _("Node Selection")) m_pMesh->scale(ratio, origin, m_nodeSelection);
    else                                                                  m_pMesh->scale(ratio, origin, setUInt(), m_elemSelection);

    this->Destroy();
}
