#include "wx_pch.h"
#include "DTransformTranslate.h"

#ifndef WX_PRECOMP
	//(*InternalHeadersPCH(DTransformTranslate)
	#include <wx/intl.h>
	#include <wx/string.h>
	//*)
#endif
//(*InternalHeaders(DTransformTranslate)
//*)

//(*IdInit(DTransformTranslate)
const long DTransformTranslate::ID_STATICTEXT1 = wxNewId();
const long DTransformTranslate::ID_STATICTEXT2 = wxNewId();
const long DTransformTranslate::ID_TEXTCTRL1 = wxNewId();
const long DTransformTranslate::ID_STATICTEXT3 = wxNewId();
const long DTransformTranslate::ID_TEXTCTRL2 = wxNewId();
const long DTransformTranslate::ID_STATICTEXT4 = wxNewId();
const long DTransformTranslate::ID_TEXTCTRL3 = wxNewId();
const long DTransformTranslate::ID_RADIOBOX1 = wxNewId();
const long DTransformTranslate::ID_BUTTON3 = wxNewId();
const long DTransformTranslate::ID_BUTTON1 = wxNewId();
const long DTransformTranslate::ID_BUTTON2 = wxNewId();
//*)

BEGIN_EVENT_TABLE(DTransformTranslate,wxDialog)
	//(*EventTable(DTransformTranslate)
	//*)
END_EVENT_TABLE()

DTransformTranslate::DTransformTranslate(
        wxWindow* parent,
        bool& modified,
        CMesh* pMesh,
        setUInt& nodeSelection,
        setUInt& elemSelection,
        wxWindowID id) : m_modified(modified), m_pMesh(pMesh), m_nodeSelection(nodeSelection), m_elemSelection(elemSelection)
{
	//(*Initialize(DTransformTranslate)
	wxFlexGridSizer* FlexGridSizer4;
	wxFlexGridSizer* FlexGridSizer3;
	wxFlexGridSizer* FlexGridSizer2;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, id, _("Translate Mesh"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("id"));
	FlexGridSizer1 = new wxFlexGridSizer(4, 1, 0, 0);
	StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("Enter translation distance:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	FlexGridSizer1->Add(StaticText1, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer2 = new wxFlexGridSizer(3, 2, 0, 0);
	StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("X"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	FlexGridSizer2->Add(StaticText2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	sx = new wxTextCtrl(this, ID_TEXTCTRL1, _("0.0"), wxDefaultPosition, wxSize(120,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	FlexGridSizer2->Add(sx, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText3 = new wxStaticText(this, ID_STATICTEXT3, _("Y"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT3"));
	FlexGridSizer2->Add(StaticText3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	sy = new wxTextCtrl(this, ID_TEXTCTRL2, _("0.0"), wxDefaultPosition, wxSize(120,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
	FlexGridSizer2->Add(sy, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticText4 = new wxStaticText(this, ID_STATICTEXT4, _("Z"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT4"));
	FlexGridSizer2->Add(StaticText4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	sz = new wxTextCtrl(this, ID_TEXTCTRL3, _("0.0"), wxDefaultPosition, wxSize(120,-1), 0, wxDefaultValidator, _T("ID_TEXTCTRL3"));
	FlexGridSizer2->Add(sz, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer2, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer4 = new wxFlexGridSizer(1, 2, 0, 0);
	wxString __wxRadioBoxChoices_1[3] =
	{
		_("Whole Mesh"),
		_("Node Selection"),
		_("Element Selection")
	};
	DomainRadioBox = new wxRadioBox(this, ID_RADIOBOX1, _("Select Domain"), wxDefaultPosition, wxDefaultSize, 3, __wxRadioBoxChoices_1, 1, 0, wxDefaultValidator, _T("ID_RADIOBOX1"));
	DomainRadioBox->SetSelection(0);
	FlexGridSizer4->Add(DomainRadioBox, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SelectButton = new wxButton(this, ID_BUTTON3, _("Select"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	SelectButton->Disable();
	FlexGridSizer4->Add(SelectButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer4, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer3 = new wxFlexGridSizer(1, 2, 0, 0);
	OKButton = new wxButton(this, ID_BUTTON1, _("OK"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
	FlexGridSizer3->Add(OKButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CancelButton = new wxButton(this, ID_BUTTON2, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
	FlexGridSizer3->Add(CancelButton, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(FlexGridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_RADIOBOX1,wxEVT_COMMAND_RADIOBOX_SELECTED,(wxObjectEventFunction)&DTransformTranslate::OnDomainRadioBoxSelect);
	Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformTranslate::OnSelectButtonClick);
	Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformTranslate::OnOKButtonClick);
	Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&DTransformTranslate::OnCancelButtonClick);
	//*)
}

DTransformTranslate::~DTransformTranslate()
{
	//(*Destroy(DTransformTranslate)
	//*)
}

void DTransformTranslate::OnCancelButtonClick(wxCommandEvent& event)
{
    this->Destroy();
}

void DTransformTranslate::OnSelectButtonClick(wxCommandEvent& event)
{
    if (DomainRadioBox->GetStringSelection() == _("Node Selection")){
        DNodeSelection* nodeSelection = new DNodeSelection(0, m_pMesh, m_nodeSelection);
        nodeSelection->ShowModal();
    }
    else{
        DElemSelection* elemSelection = new DElemSelection(0, m_pMesh, m_elemSelection);
        elemSelection->ShowModal();
    }
}

void DTransformTranslate::OnDomainRadioBoxSelect(wxCommandEvent& event)
{
    // enable/disable select button
    if (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))
        SelectButton->Enable(false);
    else
        SelectButton->Enable(true);
}

void DTransformTranslate::OnOKButtonClick(wxCommandEvent& event)
{
    double distance[3];
    wxString number;

    // get X distance
    number = sx->GetValue();
    if(!number.ToDouble(&distance[0])){
        showErrorMessage("Incorrect value for X distance entered");
        return;
    }

    // get Y distance
    number = sy->GetValue();
    if(!number.ToDouble(&distance[1])){
        showErrorMessage("Incorrect value for Y distance entered");
        return;
    }

    // get Z distance
    number = sz->GetValue();
    if(!number.ToDouble(&distance[2])){
        showErrorMessage("Incorrect value for Z distance entered");
        return;
    }

    m_modified = true;

    // translate according to selection
    if      (DomainRadioBox->GetStringSelection() == _("Whole Mesh"))     m_pMesh->translate(distance);
    else if (DomainRadioBox->GetStringSelection() == _("Node Selection")) m_pMesh->translate(distance, m_nodeSelection);
    else                                                                  m_pMesh->translate(distance, setUInt(), m_elemSelection);
    
    this->Destroy();
}
