// Copyright (C) 2011  Daniel Filkovic

// This file is part of APAME.

// APAME is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// APAME is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with APAME.  If not, see <http://www.gnu.org/licenses/>.

// file initialize_apame_data.sci

// This function initializes apame data structure to default values

function [apame_data]=initialize_apame_data()

pi = 4.0*atan(1.0);

apame_data=struct("airspeed", 1,    ...
                  "ro",1.225,    ...
                  "p_ref",101325,    ...
                  "mach",0,    ...
                  "case_num",1,    ...
                  "alfa",0,    ...
                  "beta",0,    ...
                  "wing_span",1,    ...
                  "mac",1,    ...
                  "wing_surf",1,    ...
                  "origin",[0,0,0],    ...
                  "method",0,    ...
                  "error",0.0000001,    ...
                  "coplanarity_angle",179*pi/180,    ...
                  "colldist",0.0000001,    ...
                  "farfield",5,    ...
                  "collcalc",0,    ...
                  "velorder",1,    ...
                  "res_req",1,    ...
                  "res_coef",1,    ...
                  "res_forc",0,    ...
                  "res_geom",0,    ...
                  "res_velo",0,    ...
                  "res_pres",0,    ...
                  "res_cent",0,    ...
                  "res_doub",0,    ...
                  "res_sorc",0,    ...
                  "res_velc",0,    ...
                  "res_mesh",0,    ...
                  "res_stat",0,    ...
                  "res_dyna",0,    ...
                  "res_mano",0);

endfunction
