// Copyright (C) 2010-2011  Daniel Filkovic

// This file is part of APAME.

// APAME is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// APAME is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with APAME.  If not, see <http://www.gnu.org/licenses/>.

// file assemble.sci

// This function calculates x and z coordinates based on their polynoms and
// y_ribs positions

function [x,y,z] = assemble(y_ribs,p_x,p_y,p_z,wing_span,N,M)

halfspan = wing_span/2;

y_ribs = y_ribs*halfspan;   // getting absolute y position since polynoms are defined that way

x = zeros(N,M);
y = zeros(N,M);
z = zeros(N,M);
for i=1:N
    for j=1:M
        x(i,j) = polyval(p_x(i,:),y_ribs(j));
        y(i,j) = polyval(p_y(i,:),y_ribs(j));
        z(i,j) = polyval(p_z(i,:),y_ribs(j));
    end
end

endfunction
