// Copyright (C) 2010-2011  Daniel Filkovic

// This file is part of APAME.

// APAME is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// APAME is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with APAME.  If not, see <http://www.gnu.org/licenses/>.

// file derivating.sci

// This function calculates airfoil segments coordinates absolute in space

function [p_dih,p_swp,p_crd,p_aoa, ...
    p_dih_der,p_swp_der,p_crd_der,p_aoa_der, ...
    p_dih_der2,p_swp_der2,p_crd_der2,p_aoa_der2]=derivating(x_af,y_af,z_af,crd_af,aoa_af,M_seg)

// calculating global dihedral and sweep polynoms
p_dih = polyfit(y_af,z_af,M_seg-1);
p_swp = polyfit(y_af,x_af,M_seg-1);
p_crd = polyfit(y_af,crd_af,M_seg-1);
p_aoa = polyfit(y_af,aoa_af,M_seg-1);

// polynom derivations
p_dih_der = polyder(p_dih);
p_swp_der = polyder(p_swp);
p_crd_der = polyder(p_crd);
p_aoa_der = polyder(p_aoa);

// polynom second derivations
p_dih_der2 = polyder(p_dih_der);
p_swp_der2 = polyder(p_swp_der);
p_crd_der2 = polyder(p_crd_der);
p_aoa_der2 = polyder(p_aoa_der);

endfunction
