// Copyright (C) 2010-2011  Daniel Filkovic

// This file is part of APAME.

// APAME is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// APAME is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with APAME.  If not, see <http://www.gnu.org/licenses/>.

// file trans_seg.sci

// This functions translates airfoil segments to their position (_af)

function [x_foil_new,y_foil_new,z_foil_new]=trans_seg(x_foil,y_foil,z_foil,N,M_seg,x_af,y_af,z_af,wing_span)

halfspan = wing_span/2;

x_foil_new = zeros(N,M_seg);
y_foil_new = zeros(N,M_seg);
z_foil_new = zeros(N,M_seg);
for i = 1:M_seg
    x_foil_new(:,i) = x_foil(:,i) + x_af(i);
    y_foil_new(:,i) = y_foil(:,i) + y_af(i)*halfspan;
    z_foil_new(:,i) = z_foil(:,i) + z_af(i);
end

endfunction
