// Copyright (C) 2011  Daniel Filkovic

// This file is part of APAME.

// APAME is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// APAME is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with APAME.  If not, see <http://www.gnu.org/licenses/>.

// file meshing.sci

// This function creates mesh between root and tip airfoil

function [x,y,z,N,M] = meshing(xp,zp,wing_data,apame_data)

// number of nodes on airfoil section
N=size(xp,"r");

// number of nodes on halfspan section
M=wing_data.Mp+1;

// find cosine distribution
ykoef=zeros(M,1);
for i = 1:M
    ykoef(i)=cos(pi/wing_data.Mp*(i+wing_data.Mp-1))*0.5-0.5;
end

// mesh the wing
x = zeros(N,M);
y = zeros(N,M);
z = zeros(N,M);
for i = 1:M
    for j = 1:N
        x(j,i) = xp(j,1)*(1-abs(ykoef(i)))+xp(j,2)*abs((ykoef(i)));
        y(j,i) = ykoef(i)*(apame_data.wing_span/2);
        z(j,i) = zp(j,1)*(1-abs(ykoef(i)))+zp(j,2)*abs((ykoef(i)));
    end
end

endfunction
